/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         VLparse
#define yylex           VLlex
#define yyerror         VLerror
#define yydebug         VLdebug
#define yynerrs         VLnerrs

#define yylval          VLlval
#define yychar          VLchar
#define yylloc          VLlloc

/* Copy the first part of user declarations.  */
#line 2 "parse.y" /* yacc.c:339  */

/*
 * Copyright (c) 1998-2012 Stephen Williams (steve@icarus.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

# include "config.h"

# include  "parse_misc.h"
# include  "compiler.h"
# include  "pform.h"
# include  "Statement.h"
# include  "PSpec.h"
# include  <stack>
# include  <cstring>
# include  <sstream>

class PSpecPath;

extern void lex_start_table();
extern void lex_end_table();

static svector<PExpr*>* param_active_range = 0;
static bool param_active_signed = false;
static ivl_variable_type_t param_active_type = IVL_VT_LOGIC;

/* Port declaration lists use this structure for context. */
static struct {
      NetNet::Type port_net_type;
      NetNet::PortType port_type;
      ivl_variable_type_t var_type;
      bool sign_flag;
      svector<PExpr*>* range;
} port_declaration_context = {NetNet::NONE, NetNet::NOT_A_PORT,
                              IVL_VT_NO_TYPE, false, 0};

/* The task and function rules need to briefly hold the pointer to the
   task/function that is currently in progress. */
static PTask* current_task = 0;
static PFunction* current_function = 0;
static stack<PBlock*> current_block_stack;

/* This is used to keep track of the extra arguments after the notifier
 * in the $setuphold and $recrem timing checks. This allows us to print
 * a warning message that the delayed signals will not be created. We
 * need to do this since not driving these signals creates real
 * simulation issues. */
static unsigned args_after_notifier;

/* Later version of bison (including 1.35) will not compile in stack
   extension if the output is compiled with C++ and either the YYSTYPE
   or YYLTYPE are provided by the source code. However, I can get the
   old behavior back by defining these symbols. */
# define YYSTYPE_IS_TRIVIAL 1
# define YYLTYPE_IS_TRIVIAL 1

/* Recent version of bison expect that the user supply a
   YYLLOC_DEFAULT macro that makes up a yylloc value from existing
   values. I need to supply an explicit version to account for the
   text field, that otherwise won't be copied. */
# define YYLLOC_DEFAULT(Current, Rhs, N)  do {       \
  (Current).first_line   = (Rhs)[1].first_line;      \
  (Current).first_column = (Rhs)[1].first_column;    \
  (Current).last_line    = (Rhs)[N].last_line;       \
  (Current).last_column  = (Rhs)[N].last_column;     \
  (Current).text         = (Rhs)[1].text;   } while (0)

/*
 * These are some common strength pairs that are used as defaults when
 * the user is not otherwise specific.
 */
const static struct str_pair_t pull_strength = { PGate::PULL,  PGate::PULL };
const static struct str_pair_t str_strength = { PGate::STRONG, PGate::STRONG };

static list<pair<perm_string,PExpr*> >* make_port_list(char*id, PExpr*expr)
{
      list<pair<perm_string,PExpr*> >*tmp = new list<pair<perm_string,PExpr*> >;
      tmp->push_back(make_pair(lex_strings.make(id), expr));
      delete[]id;
      return tmp;
}
static list<pair<perm_string,PExpr*> >* make_port_list(list<pair<perm_string,
                                                                 PExpr*> >*tmp,
                                                       char*id, PExpr*expr)
{
      tmp->push_back(make_pair(lex_strings.make(id), expr));
      delete[]id;
      return tmp;
}

static list<perm_string>* list_from_identifier(char*id)
{
      list<perm_string>*tmp = new list<perm_string>;
      tmp->push_back(lex_strings.make(id));
      delete[]id;
      return tmp;
}

static list<perm_string>* list_from_identifier(list<perm_string>*tmp, char*id)
{
      tmp->push_back(lex_strings.make(id));
      delete[]id;
      return tmp;
}

static svector<PExpr*>* copy_range(svector<PExpr*>* orig)
{
      svector<PExpr*>*copy = 0;

      if (orig) {
	    copy = new svector<PExpr*>(2);
	    (*copy)[0] = (*orig)[0];
	    (*copy)[1] = (*orig)[1];
      }

      return copy;
}

template <class T> void append(vector<T>&out, const vector<T>&in)
{
      for (size_t idx = 0 ; idx < in.size() ; idx += 1)
	    out.push_back(in[idx]);
}

/*
 * This is a shorthand for making a PECallFunction that takes a single
 * arg. This is used by some of the code that detects built-ins.
 */
static PECallFunction*make_call_function(perm_string tn, PExpr*arg)
{
      svector<PExpr*> parms(1);
      parms[0] = arg;
      PECallFunction*tmp = new PECallFunction(tn, parms);
      return tmp;
}

static PECallFunction*make_call_function(perm_string tn, PExpr*arg1, PExpr*arg2)
{
      svector<PExpr*> parms(2);
      parms[0] = arg1;
      parms[1] = arg2;
      PECallFunction*tmp = new PECallFunction(tn, parms);
      return tmp;
}


#line 236 "parse.cc" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parse.hh".  */
#ifndef YY_VL_PARSE_HH_INCLUDED
# define YY_VL_PARSE_HH_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int VLdebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENTIFIER = 258,
    SYSTEM_IDENTIFIER = 259,
    STRING = 260,
    DISCIPLINE_IDENTIFIER = 261,
    PATHPULSE_IDENTIFIER = 262,
    BASED_NUMBER = 263,
    DEC_NUMBER = 264,
    REALTIME = 265,
    K_LE = 266,
    K_GE = 267,
    K_EG = 268,
    K_EQ = 269,
    K_NE = 270,
    K_CEQ = 271,
    K_CNE = 272,
    K_LS = 273,
    K_RS = 274,
    K_RSS = 275,
    K_SG = 276,
    K_CONTRIBUTE = 277,
    K_PO_POS = 278,
    K_PO_NEG = 279,
    K_POW = 280,
    K_PSTAR = 281,
    K_STARP = 282,
    K_LOR = 283,
    K_LAND = 284,
    K_NAND = 285,
    K_NOR = 286,
    K_NXOR = 287,
    K_TRIGGER = 288,
    K_edge_descriptor = 289,
    K_always = 290,
    K_and = 291,
    K_assign = 292,
    K_begin = 293,
    K_buf = 294,
    K_bufif0 = 295,
    K_bufif1 = 296,
    K_case = 297,
    K_casex = 298,
    K_casez = 299,
    K_cmos = 300,
    K_deassign = 301,
    K_default = 302,
    K_defparam = 303,
    K_disable = 304,
    K_edge = 305,
    K_else = 306,
    K_end = 307,
    K_endcase = 308,
    K_endfunction = 309,
    K_endmodule = 310,
    K_endprimitive = 311,
    K_endspecify = 312,
    K_endtable = 313,
    K_endtask = 314,
    K_event = 315,
    K_for = 316,
    K_force = 317,
    K_forever = 318,
    K_fork = 319,
    K_function = 320,
    K_highz0 = 321,
    K_highz1 = 322,
    K_if = 323,
    K_ifnone = 324,
    K_initial = 325,
    K_inout = 326,
    K_input = 327,
    K_integer = 328,
    K_join = 329,
    K_large = 330,
    K_macromodule = 331,
    K_medium = 332,
    K_module = 333,
    K_nand = 334,
    K_negedge = 335,
    K_nmos = 336,
    K_nor = 337,
    K_not = 338,
    K_notif0 = 339,
    K_notif1 = 340,
    K_or = 341,
    K_output = 342,
    K_parameter = 343,
    K_pmos = 344,
    K_posedge = 345,
    K_primitive = 346,
    K_pull0 = 347,
    K_pull1 = 348,
    K_pulldown = 349,
    K_pullup = 350,
    K_rcmos = 351,
    K_real = 352,
    K_realtime = 353,
    K_reg = 354,
    K_release = 355,
    K_repeat = 356,
    K_rnmos = 357,
    K_rpmos = 358,
    K_rtran = 359,
    K_rtranif0 = 360,
    K_rtranif1 = 361,
    K_scalared = 362,
    K_small = 363,
    K_specify = 364,
    K_specparam = 365,
    K_strong0 = 366,
    K_strong1 = 367,
    K_supply0 = 368,
    K_supply1 = 369,
    K_table = 370,
    K_task = 371,
    K_time = 372,
    K_tran = 373,
    K_tranif0 = 374,
    K_tranif1 = 375,
    K_tri = 376,
    K_tri0 = 377,
    K_tri1 = 378,
    K_triand = 379,
    K_trior = 380,
    K_trireg = 381,
    K_vectored = 382,
    K_wait = 383,
    K_wand = 384,
    K_weak0 = 385,
    K_weak1 = 386,
    K_while = 387,
    K_wire = 388,
    K_wor = 389,
    K_xnor = 390,
    K_xor = 391,
    K_Shold = 392,
    K_Snochange = 393,
    K_Speriod = 394,
    K_Srecovery = 395,
    K_Ssetup = 396,
    K_Ssetuphold = 397,
    K_Sskew = 398,
    K_Swidth = 399,
    KK_attribute = 400,
    K_bool = 401,
    K_logic = 402,
    K_automatic = 403,
    K_endgenerate = 404,
    K_generate = 405,
    K_genvar = 406,
    K_localparam = 407,
    K_noshowcancelled = 408,
    K_pulsestyle_onevent = 409,
    K_pulsestyle_ondetect = 410,
    K_showcancelled = 411,
    K_signed = 412,
    K_unsigned = 413,
    K_Sfullskew = 414,
    K_Srecrem = 415,
    K_Sremoval = 416,
    K_Stimeskew = 417,
    K_cell = 418,
    K_config = 419,
    K_design = 420,
    K_endconfig = 421,
    K_incdir = 422,
    K_include = 423,
    K_instance = 424,
    K_liblist = 425,
    K_library = 426,
    K_use = 427,
    K_wone = 428,
    K_uwire = 429,
    K_always_comb = 430,
    K_always_ff = 431,
    K_always_latch = 432,
    K_assert = 433,
    K_abs = 434,
    K_abstol = 435,
    K_access = 436,
    K_acos = 437,
    K_acosh = 438,
    K_analog = 439,
    K_asin = 440,
    K_asinh = 441,
    K_atan = 442,
    K_atan2 = 443,
    K_atanh = 444,
    K_ceil = 445,
    K_continuous = 446,
    K_cos = 447,
    K_cosh = 448,
    K_ddt_nature = 449,
    K_discipline = 450,
    K_discrete = 451,
    K_domain = 452,
    K_enddiscipline = 453,
    K_endnature = 454,
    K_exclude = 455,
    K_exp = 456,
    K_floor = 457,
    K_flow = 458,
    K_from = 459,
    K_ground = 460,
    K_hypot = 461,
    K_idt_nature = 462,
    K_inf = 463,
    K_ln = 464,
    K_log = 465,
    K_max = 466,
    K_min = 467,
    K_nature = 468,
    K_potential = 469,
    K_pow = 470,
    K_sin = 471,
    K_sinh = 472,
    K_sqrt = 473,
    K_string = 474,
    K_tan = 475,
    K_tanh = 476,
    K_units = 477,
    K_TAND = 478,
    UNARY_PREC = 479,
    less_than_K_else = 480
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 163 "parse.y" /* yacc.c:355  */

      bool flag;

      char letter;

	/* text items are C strings allocated by the lexor using
	   strdup. They can be put into lists with the texts type. */
      char*text;
      list<perm_string>*perm_strings;

      list<pair<perm_string,PExpr*> >*port_list;

      pform_name_t*pform_name;

      ivl_discipline_t discipline;

      hname_t*hier;

      list<string>*strings;

      struct str_pair_t drive;

      PCase::Item*citem;
      svector<PCase::Item*>*citems;

      lgate*gate;
      svector<lgate>*gates;

      Module::port_t *mport;
      LexicalScope::range_t* value_range;
      vector<Module::port_t*>*mports;

      named_pexpr_t*named_pexpr;
      svector<named_pexpr_t*>*named_pexprs;
      struct parmvalue_t*parmvalue;

      PExpr*expr;
      svector<PExpr*>*exprs;

      svector<PEEvent*>*event_expr;

      NetNet::Type nettype;
      PGBuiltin::Type gatetype;
      NetNet::PortType porttype;
      ivl_variable_type_t datatype;

      PWire*wire;
      svector<PWire*>*wires;

      PEventStatement*event_statement;
      Statement*statement;
      svector<Statement*>*statement_list;

      PTaskFuncArg function_type;

      net_decl_assign_t*net_decl_assign;

      verinum* number;

      verireal* realtime;

      PSpecPath* specpath;
      list<index_component_t> *dimensions;

#line 567 "parse.cc" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE VLlval;
extern YYLTYPE VLlloc;
int VLparse (void);

#endif /* !YY_VL_PARSE_HH_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 596 "parse.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  26
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   11432

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  271
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  185
/* YYNRULES -- Number of rules.  */
#define YYNRULES  730
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1784

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   480

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   247,     2,   243,     2,   235,   228,     2,
     238,   242,   233,   231,   239,   232,   244,   234,   252,   253,
       2,     2,     2,     2,     2,     2,     2,     2,   225,   241,
     229,   240,   230,   224,   245,     2,   260,     2,     2,     2,
     257,     2,     2,     2,     2,     2,     2,   263,   265,     2,
     267,   268,   262,     2,     2,     2,     2,     2,     2,     2,
       2,   250,     2,   251,   227,   270,     2,     2,   255,     2,
       2,     2,   256,     2,   259,     2,     2,     2,   258,     2,
     264,     2,   266,   269,   261,     2,     2,     2,     2,     2,
     254,     2,     2,   248,   226,   249,   246,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   236,
     237
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   394,   394,   394,   397,   398,   401,   403,   405,   413,
     414,   421,   422,   426,   427,   428,   429,   441,   447,   456,
     463,   481,   494,   508,   513,   522,   524,   527,   531,   532,
     537,   542,   547,   551,   555,   559,   563,   570,   571,   575,
     576,   580,   587,   592,   597,   604,   610,   618,   619,   620,
     624,   625,   629,   636,   637,   641,   645,   650,   658,   663,
     668,   674,   684,   685,   689,   694,   702,   706,   712,   723,
     733,   742,   743,   744,   745,   746,   747,   759,   759,   763,
     762,   769,   770,   774,   776,   778,   780,   786,   785,   793,
     794,   798,   800,   801,   803,   805,   810,   820,   823,   826,
     828,   832,   833,   835,   837,   838,   841,   843,   847,   849,
     853,   855,   860,   864,   868,   872,   876,   880,   887,   888,
     892,   893,   894,   895,   899,   900,   901,   902,   906,   914,
     920,   927,   929,   935,   944,   951,   958,   972,   974,   979,
     981,   983,   988,   993,   998,  1003,  1008,  1013,  1018,  1023,
    1028,  1033,  1038,  1043,  1048,  1053,  1058,  1063,  1068,  1073,
    1078,  1083,  1088,  1093,  1098,  1103,  1108,  1113,  1118,  1123,
    1128,  1133,  1138,  1143,  1148,  1153,  1158,  1163,  1168,  1173,
    1178,  1186,  1188,  1235,  1240,  1246,  1251,  1259,  1264,  1272,
    1278,  1283,  1288,  1299,  1310,  1316,  1323,  1328,  1337,  1344,
    1351,  1358,  1365,  1372,  1379,  1386,  1393,  1400,  1407,  1414,
    1421,  1428,  1435,  1442,  1449,  1456,  1463,  1470,  1477,  1488,
    1494,  1500,  1508,  1513,  1519,  1526,  1542,  1544,  1559,  1561,
    1568,  1578,  1591,  1602,  1619,  1630,  1645,  1658,  1673,  1681,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1705,  1706,  1707,  1708,  1709,  1710,  1711,  1712,
    1713,  1714,  1715,  1716,  1726,  1731,  1737,  1746,  1756,  1766,
    1782,  1784,  1789,  1791,  1793,  1795,  1817,  1823,  1831,  1837,
    1842,  1861,  1866,  1874,  1891,  1908,  1925,  1942,  1967,  1968,
    1971,  1971,  1978,  1984,  1996,  2005,  2011,  2021,  2025,  2020,
    2047,  2047,  2050,  2051,  2055,  2056,  2057,  2063,  2065,  2069,
    2070,  2071,  2082,  2103,  2122,  2137,  2143,  2151,  2156,  2176,
    2182,  2188,  2199,  2205,  2209,  2215,  2219,  2223,  2227,  2232,
    2236,  2243,  2247,  2252,  2256,  2260,  2264,  2268,  2272,  2280,
    2288,  2299,  2304,  2308,  2313,  2325,  2324,  2339,  2338,  2354,
    2353,  2369,  2381,  2380,  2395,  2394,  2409,  2422,  2424,  2430,
    2427,  2437,  2434,  2441,  2446,  2445,  2452,  2459,  2459,  2472,
    2475,  2479,  2488,  2495,  2500,  2506,  2512,  2521,  2528,  2533,
    2534,  2537,  2540,  2541,  2545,  2545,  2547,  2547,  2552,  2553,
    2557,  2558,  2568,  2569,  2570,  2574,  2574,  2585,  2596,  2602,
    2608,  2609,  2610,  2613,  2613,  2616,  2617,  2618,  2619,  2620,
    2621,  2622,  2623,  2624,  2625,  2626,  2631,  2635,  2640,  2644,
    2649,  2654,  2659,  2671,  2683,  2696,  2697,  2701,  2702,  2706,
    2715,  2723,  2723,  2726,  2728,  2733,  2735,  2737,  2739,  2741,
    2746,  2747,  2748,  2749,  2752,  2752,  2771,  2777,  2783,  2795,
    2806,  2812,  2816,  2823,  2833,  2838,  2861,  2869,  2880,  2889,
    2898,  2899,  2915,  2923,  2946,  2968,  2982,  2984,  2997,  3004,
    3012,  3022,  3028,  3036,  3037,  3038,  3042,  3051,  3052,  3055,
    3056,  3060,  3068,  3080,  3081,  3082,  3083,  3084,  3085,  3086,
    3095,  3111,  3121,  3127,  3136,  3151,  3160,  3166,  3175,  3194,
    3200,  3209,  3210,  3213,  3216,  3224,  3232,  3240,  3245,  3250,
    3254,  3259,  3263,  3267,  3272,  3276,  3280,  3285,  3289,  3293,
    3298,  3301,  3304,  3307,  3310,  3316,  3317,  3321,  3323,  3330,
    3330,  3333,  3337,  3341,  3345,  3352,  3353,  3354,  3358,  3360,
    3365,  3373,  3376,  3379,  3386,  3392,  3398,  3404,  3413,  3418,
    3456,  3460,  3468,  3469,  3473,  3474,  3475,  3479,  3481,  3483,
    3487,  3491,  3493,  3497,  3501,  3510,  3511,  3516,  3517,  3521,
    3523,  3525,  3527,  3536,  3548,  3554,  3564,  3569,  3581,  3586,
    3594,  3593,  3609,  3617,  3622,  3630,  3629,  3645,  3648,  3654,
    3660,  3665,  3670,  3675,  3680,  3685,  3687,  3689,  3691,  3696,
    3701,  3705,  3709,  3715,  3720,  3725,  3729,  3734,  3738,  3745,
    3756,  3763,  3770,  3775,  3780,  3785,  3790,  3797,  3804,  3809,
    3815,  3820,  3825,  3833,  3840,  3847,  3859,  3866,  3873,  3881,
    3893,  3897,  3902,  3910,  3912,  3917,  3924,  3925,  3929,  3930,
    3934,  3943,  3952,  3965,  3980,  3995,  4013,  4027,  4041,  4058,
    4066,  4074,  4085,  4091,  4096,  4099,  4104,  4118,  4131,  4147,
    4168,  4189,  4213,  4233,  4253,  4276,  4289,  4302,  4318,  4324,
    4326,  4340,  4345,  4353,  4353,  4359,  4360,  4364,  4377,  4383,
    4392,  4398,  4407,  4421,  4432,  4433,  4437,  4443,  4455,  4456,
    4457,  4458,  4459,  4460,  4461,  4462,  4463,  4464,  4465,  4466,
    4467,  4468,  4469,  4470,  4471,  4472,  4473,  4474,  4475,  4476,
    4477,  4481,  4482,  4483,  4484,  4491,  4493,  4501,  4509,  4520,
    4522,  4531,  4537,  4545,  4545,  4548,  4549,  4553,  4559,  4572,
    4587
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENTIFIER", "SYSTEM_IDENTIFIER",
  "STRING", "DISCIPLINE_IDENTIFIER", "PATHPULSE_IDENTIFIER",
  "BASED_NUMBER", "DEC_NUMBER", "REALTIME", "K_LE", "K_GE", "K_EG", "K_EQ",
  "K_NE", "K_CEQ", "K_CNE", "K_LS", "K_RS", "K_RSS", "K_SG",
  "K_CONTRIBUTE", "K_PO_POS", "K_PO_NEG", "K_POW", "K_PSTAR", "K_STARP",
  "K_LOR", "K_LAND", "K_NAND", "K_NOR", "K_NXOR", "K_TRIGGER",
  "K_edge_descriptor", "K_always", "K_and", "K_assign", "K_begin", "K_buf",
  "K_bufif0", "K_bufif1", "K_case", "K_casex", "K_casez", "K_cmos",
  "K_deassign", "K_default", "K_defparam", "K_disable", "K_edge", "K_else",
  "K_end", "K_endcase", "K_endfunction", "K_endmodule", "K_endprimitive",
  "K_endspecify", "K_endtable", "K_endtask", "K_event", "K_for", "K_force",
  "K_forever", "K_fork", "K_function", "K_highz0", "K_highz1", "K_if",
  "K_ifnone", "K_initial", "K_inout", "K_input", "K_integer", "K_join",
  "K_large", "K_macromodule", "K_medium", "K_module", "K_nand",
  "K_negedge", "K_nmos", "K_nor", "K_not", "K_notif0", "K_notif1", "K_or",
  "K_output", "K_parameter", "K_pmos", "K_posedge", "K_primitive",
  "K_pull0", "K_pull1", "K_pulldown", "K_pullup", "K_rcmos", "K_real",
  "K_realtime", "K_reg", "K_release", "K_repeat", "K_rnmos", "K_rpmos",
  "K_rtran", "K_rtranif0", "K_rtranif1", "K_scalared", "K_small",
  "K_specify", "K_specparam", "K_strong0", "K_strong1", "K_supply0",
  "K_supply1", "K_table", "K_task", "K_time", "K_tran", "K_tranif0",
  "K_tranif1", "K_tri", "K_tri0", "K_tri1", "K_triand", "K_trior",
  "K_trireg", "K_vectored", "K_wait", "K_wand", "K_weak0", "K_weak1",
  "K_while", "K_wire", "K_wor", "K_xnor", "K_xor", "K_Shold",
  "K_Snochange", "K_Speriod", "K_Srecovery", "K_Ssetup", "K_Ssetuphold",
  "K_Sskew", "K_Swidth", "KK_attribute", "K_bool", "K_logic",
  "K_automatic", "K_endgenerate", "K_generate", "K_genvar", "K_localparam",
  "K_noshowcancelled", "K_pulsestyle_onevent", "K_pulsestyle_ondetect",
  "K_showcancelled", "K_signed", "K_unsigned", "K_Sfullskew", "K_Srecrem",
  "K_Sremoval", "K_Stimeskew", "K_cell", "K_config", "K_design",
  "K_endconfig", "K_incdir", "K_include", "K_instance", "K_liblist",
  "K_library", "K_use", "K_wone", "K_uwire", "K_always_comb",
  "K_always_ff", "K_always_latch", "K_assert", "K_abs", "K_abstol",
  "K_access", "K_acos", "K_acosh", "K_analog", "K_asin", "K_asinh",
  "K_atan", "K_atan2", "K_atanh", "K_ceil", "K_continuous", "K_cos",
  "K_cosh", "K_ddt_nature", "K_discipline", "K_discrete", "K_domain",
  "K_enddiscipline", "K_endnature", "K_exclude", "K_exp", "K_floor",
  "K_flow", "K_from", "K_ground", "K_hypot", "K_idt_nature", "K_inf",
  "K_ln", "K_log", "K_max", "K_min", "K_nature", "K_potential", "K_pow",
  "K_sin", "K_sinh", "K_sqrt", "K_string", "K_tan", "K_tanh", "K_units",
  "K_TAND", "'?'", "':'", "'|'", "'^'", "'&'", "'<'", "'>'", "'+'", "'-'",
  "'*'", "'/'", "'%'", "UNARY_PREC", "less_than_K_else", "'('", "','",
  "'='", "';'", "')'", "'#'", "'.'", "'@'", "'~'", "'!'", "'{'", "'}'",
  "'['", "']'", "'0'", "'1'", "'x'", "'b'", "'f'", "'F'", "'l'", "'h'",
  "'B'", "'r'", "'R'", "'M'", "'n'", "'N'", "'p'", "'P'", "'Q'", "'q'",
  "'_'", "$accept", "main", "source_file", "number", "real_or_realtime",
  "attribute_list_opt", "attribute_instance_list", "attribute_list",
  "attribute", "block_item_decl", "block_item_decls",
  "block_item_decls_opt", "case_item", "case_items", "charge_strength",
  "charge_strength_opt", "defparam_assign", "defparam_assign_list",
  "delay1", "delay3", "delay3_opt", "delay_value_list", "delay_value",
  "delay_value_simple", "description", "optional_semicolon",
  "discipline_declaration", "$@1", "discipline_items", "discipline_item",
  "nature_declaration", "$@2", "nature_items", "nature_item",
  "config_declaration", "lib_cell_identifiers",
  "list_of_config_rule_statements", "config_rule_statement", "opt_config",
  "lib_cell_id", "list_of_libraries", "drive_strength",
  "drive_strength_opt", "dr_strength0", "dr_strength1", "event_control",
  "event_expression_list", "event_expression", "branch_probe_expression",
  "expression", "expr_mintypmax", "expression_list_with_nuls",
  "expression_list_proper", "expr_primary", "function_item_list",
  "function_item", "gate_instance", "gate_instance_list", "gatetype",
  "switchtype", "hierarchy_identifier", "list_of_identifiers",
  "list_of_port_identifiers", "list_of_ports", "list_of_port_declarations",
  "port_declaration", "net_type_opt", "signed_opt", "lpvalue",
  "cont_assign", "cont_assign_list", "module", "$@3", "$@4",
  "module_start", "module_attribute_foreign", "module_port_list_opt",
  "module_parameter_port_list_opt", "module_parameter_port_list",
  "module_item", "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12",
  "$@13", "automatic_opt", "generate_if", "generate_case_items",
  "generate_case_item", "$@14", "$@15", "module_item_list",
  "module_item_list_opt", "generate_block", "generate_block_opt",
  "net_decl_assign", "net_decl_assigns", "primitive_type",
  "primitive_type_opt", "net_type", "var_type", "param_type",
  "parameter_assign_list", "localparam_assign_list", "parameter_assign",
  "localparam_assign", "parameter_value_ranges_opt",
  "parameter_value_ranges", "parameter_value_range",
  "value_range_expression", "from_exclude", "parameter_value_opt",
  "parameter_value_byname", "parameter_value_byname_list", "port",
  "port_opt", "port_reference", "port_reference_list", "port_name",
  "port_name_list", "port_type", "range", "range_opt", "dimensions_opt",
  "dimensions", "function_range_or_type_opt", "register_variable",
  "register_variable_list", "real_variable", "real_variable_list",
  "net_variable", "net_variable_list", "specify_item", "specify_item_list",
  "specify_edge_path_decl", "edge_operator", "specify_edge_path",
  "polarity_operator", "specify_simple_path_decl", "specify_simple_path",
  "specify_path_identifiers", "specparam", "specparam_list",
  "spec_polarity", "spec_reference_event", "edge_descriptor_list",
  "spec_notifier_opt", "spec_notifier", "statement", "$@16", "$@17",
  "statement_list_or_null", "statement_list", "statement_or_null",
  "analog_statement", "task_item", "reg_opt", "task_port_item",
  "task_item_list", "task_item_list_opt", "task_port_decl",
  "task_port_decl_list", "udp_body", "$@18", "udp_entry_list",
  "udp_comb_entry", "udp_comb_entry_list", "udp_sequ_entry_list",
  "udp_sequ_entry", "udp_initial", "udp_init_opt", "udp_input_list",
  "udp_input_sym", "udp_output_sym", "udp_port_decl", "udp_port_decls",
  "udp_port_list", "udp_reg_opt", "udp_initial_expr_opt",
  "udp_input_declaration_list", "udp_primitive", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,    63,    58,   124,    94,    38,    60,
      62,    43,    45,    42,    47,    37,   479,   480,    40,    44,
      61,    59,    41,    35,    46,    64,   126,    33,   123,   125,
      91,    93,    48,    49,   120,    98,   102,    70,   108,   104,
      66,   114,    82,    77,   110,    78,   112,    80,    81,   113,
      95
};
# endif

#define YYPACT_NINF -1308

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1308)))

#define YYTABLE_NINF -714

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     291,   166,    38,  -172,   183,   310,   425,   424,   501,   383,
     420, -1308, -1308, -1308, -1308, -1308, -1308,   245, -1308,     8,
   -1308,   197,   460,   304,   308,   308, -1308, -1308, -1308, -1308,
     606,   195,  5428, -1308,   615,   179,   386,   480, -1308, -1308,
   -1308, -1308, -1308,    20, -1308,   459, -1308, -1308,   629, -1308,
    5972,  5972,  5972,   503,   507,   516,   537,   558,   567,   572,
     593,   604,   610,   618,   632,   640,   644,   666,   679,   685,
     734,   762,   785,   841,   846,   847,   852,  5972,   871,  5972,
    5972,  5972,  5428,  5710,  1439,  5428, -1308, 10367, -1308,   268,
   -1308, -1308,   802,   434,   980, -1308,   399,   575,   790, -1308,
    4621, -1308, -1308, -1308, -1308,  5428,  5428,  5428,  5428,  5428,
    5428,  5428,  5428,  5428,  5428,  5428,  5428,  5428,  5428,  5428,
    5428,  5428,  5428,  5428,  5428,  5428,  5428,  5428,  5428, -1308,
   -1308, -1308, -1308, -1308, -1308,  9931,   809,  5972,  5972,  5972,
   -1308, -1308, -1308,  6340,   -18,  5428,  5428,  5428,  5428,  5428,
    5428,  5428,  5428,  5428,  5428,  5428,  5428,  5428,  5428,  5428,
    5428,  5428,  5428,  5428,  5428,  5428,  5428,  5428,  5428,  5428,
    5428,  4735,  1071,  5428, -1308,  1100,  1107,   863,   877,    34,
     409,  1114,  1118,   457, -1308,   899,   904,   905,   911,   921,
     719, -1308,   932,   933, -1308, 10367,   448,  6186,  6421,  6443,
    6465,  6487,  6509,  9301,  6531,  6596,  6760,  6782,  6825,  6847,
    9323,  6869,  6891,  9345,  9367,  9389,  6913,  6935,  7011,  7164,
    7186,  5428, -1308, -1308, -1308, -1308,  5428,  5428, -1308,   497,
     497,   796,   796,   796,   796,   349,   349,   349, -1308,  4415,
    3848,   478,   518,   518,  9958,  4526,   518,   478,   497,   497,
     118,   118,  1137,  1137,  1137, -1308,   584, -1308,  3968,   936,
   -1308,   112,  1178,   940, -1308, -1308,   947,   952,   966,   974,
   -1308, -1308,  5428,  1213,  1217,  1218,  1231, -1308, -1308,  1154,
     170,  1215, -1308, -1308, -1308, -1308, -1308, -1308, -1308,  5428,
   -1308, -1308, -1308, -1308, -1308, -1308,  5428, -1308, -1308,  5428,
    5428,  5428, -1308, -1308, -1308, -1308, -1308,  9980,   204, 10367,
    5428, -1308,  5428,  5428,  5428, -1308,  5428,  1010,  1255,  1268,
     243, -1308,   491,  1050,  1278,   276, -1308, -1308, -1308, -1308,
    1468,  1048,  1054,  1081,  1089,   660,   616,  1062,  1332,  1333,
     577,   680,   599, -1308, -1308, -1308, -1308,  1345,  1125,  7240,
    7262,  7284,  7306,  7328,  5428,    21, 10367,   663,  4297,  4646,
   10367,  1287, -1308,    92,  1129,  1142,  1395,  1400, -1308,  1295,
   -1308, -1308, -1308,  1247,  1435, -1308,  1436, -1308, -1308, -1308,
   -1308, -1308, -1308, -1308, -1308, -1308, -1308,  1204,  5428, -1308,
    1438, -1308,   109, -1308,  2815,  1219, -1308,   271,  1239,  1239,
     830,    52, -1308,   188, -1308, -1308,  1382, -1308, -1308, -1308,
   -1308, -1308, -1308, 10367,  1209, -1308, -1308, -1308, -1308,  1457,
     718,  1458, -1308, -1308, -1308,  1222,  1224, -1308,  1410, -1308,
     421,   351, -1308, 10002,  1228, -1308,   660, -1308,  1220,  1194,
      28,  1333, -1308, -1308, -1308, -1308, -1308, -1308, -1308, -1308,
   -1308, -1308, -1308, -1308, -1308,  1312, -1308,  1312, -1308,  1312,
    1312, -1308, -1308, -1308,  1467, 10860, -1308, -1308,  1401,  1233,
   -1308, -1308,   384, 10216, -1308,    94, -1308,  1435, -1308,  1435,
    5428,  5428,  1438, -1308,  5428, -1308,  1333,  1230, -1308, -1308,
    1204,  1204,  1204,  1204,  1235,  1236,  1255,    60,  1238,    27,
    1255,  1243,   303,  1252,  1392,  1392,  1494,  1392,   154,    67,
     108,  2179,  1353,  1264,  1270, 10720,  1255,   324, 11248, -1308,
   -1308,  6193, 10580,  1454,  1393,  1507,  1295,  1272, -1308, -1308,
   -1308, -1308, -1308, -1308, -1308, -1308, -1308, -1308, -1308, -1308,
   -1308, -1308, -1308, -1308, -1308, -1308, -1308, -1308, -1308, -1308,
   -1308,  1453, -1308, 10216, 10216, -1308,  1826, -1308, -1308, -1308,
      97,  1296,   106,  1296,  4760,  9907, -1308,  5108,   326, -1308,
   -1308,  1517,  1520,  1521,  1522,  1523, -1308,   463,  -135,   650,
   -1308,  1286,  5428, -1308,   486,   307,  1436,   608,  1527,  1477,
   -1308,   662,  5428,  1312,  1312,  1292,  1312,  1297,  1438,   -92,
    4041, -1308,   701,  4041,   717,  1480, -1308,  1305,  1308,   100,
    1309,  1310,  1311,  1313,  1314,  1317,  1318,  1319,  1555,  1555,
    1555,  1555,  1321,  1322,  1326,  1327,   472, -1308,  2555,  1328,
    1330,  1331,  1334,  1565,   436, -1308,  1204,   988,  9604,  1422,
     754,  1335,  1570,  1337,  3844, -1308, -1308, -1308, -1308, -1308,
    3844,   998, -1308, -1308, -1308, -1308, -1308, -1308, -1308, -1308,
   -1308,  1021,  1065,    66, -1308, -1308, -1308, -1308, -1308,  1095,
   -1308, -1308, -1308, -1308, -1308,  1572,    69,    99,   217,  9760,
   -1308, -1308, -1308,  1526, -1308, -1308,  1204,  1312, -1308,  1525,
   -1308, -1308, -1308,  2834, -1308,  9227, 10169, -1308, -1308,  1414,
    1341, -1308,  1342, -1308,  5659, -1308, -1308,   190, -1308,    12,
   -1308,  1343, -1308, -1308, -1308,  1344,  1346, -1308,  5428, -1308,
    1347,  1349, -1308, -1308, -1308, -1308, -1308, -1308, -1308, -1308,
    1350,  1351,   169, -1308,    35,  7350,  1436, -1308,  5428, -1308,
   -1308,  1352, -1308, -1308, -1308, -1308, -1308,  1204, -1308,  1588,
    7415,  1204,  1204, -1308,  1204, -1308,   955, -1308,  1531,  1356,
     726,  1357, 10367,   727,   158, -1308,  1358,   766, -1308, -1308,
    5428,  1354,  1359,  1361,  1362, -1308,   959,  5777,  5777,  5777,
    5777,  5777,  5777,  5777,  5777,  1355,   960,   963,   989,   992,
    5777,  5777,  5777,  5777,  1365, -1308, -1308,  1555,   505, -1308,
   -1308, -1308,   206, -1308,   234,   107,  1369,  1370,  1374,  1286,
    1375,  1360,  1600,  1552, -1308, -1308, -1308,  1380,  1005, -1308,
     165,    61,   247,   769,  1436,    35,  3516,  1385,  1404,  1405,
      35,  1436,  1406,    35,  3844,  3651,  1408,    35,  1409,  1415,
    1420,   246,   147,  5428,  2365,  1604,   627,    23, -1308, -1308,
    1397,   411, -1308,  1006,  1398,   413, -1308,  1009,  1421,  1013,
    1423, -1308, -1308, -1308, -1308,  1312,  1424,  1014,  1425,  1639,
   -1308,  3911,   158,    99,  1018,  5428,   158,  1023,  1312,  1665,
    1617, -1308,  1286,  1204, -1308,   466, 10216, -1308,  1429,  1430,
    1432,  1449,  1434, -1308, -1308, -1308, 10367, -1308,  4852,  4852,
   -1308,  5428,  1654,  8463,   675,   794,   554,   592, -1308, -1308,
   -1308,  5428, -1308,   255,  1442, -1308,  1027, -1308, -1308, 10367,
    5428, -1308,   161, -1308,  1255,  1255,  1683,  1438, -1308,  1446,
    1686,   774, -1308,   778,  1605,   675,   158,   794,  5428, -1308,
   -1308,   675,   794,   158,  7579, -1308, -1308,  5428,  5545,   100,
   -1308,  1440,  5428,  5428,  1470,  1452,  1465,  1469,  1472,  1473,
    1476,  1483,  1486,  5972,  1723, -1308, -1308, -1308, -1308,  1488,
    1489,  1490,  1491, -1308,   505, -1308, -1308,   566,  5428, -1308,
    3047, -1308,  1672,  1492, -1308, -1308, -1308, -1308,  1255,  1498,
    1730, -1308,  1595,  5428,  1570, -1308, -1308, -1308, -1308,  4966,
    1504,  1028,  5428,  5428, -1308,  5428, -1308,   323,  1510,   193,
   -1308,  1750, -1308,  1914,  5428,  5428,  5428,  1513,   568,    26,
    1516, -1308,   191, -1308,  1757,  2741,  3117,  1530,  5428,  5428,
    3187,  5428, -1308,  1604,  1675,   255,   418, -1308, -1308, -1308,
    2365,  5083, -1308,  4159,  4272, -1308,  5428,  5428, -1308,  1511,
    1761, -1308, -1308,  5428, -1308,  1763, -1308, -1308, -1308, -1308,
      45, -1308, -1308,  1764,  5428,  1031,   158,  1038, -1308,  1039,
   -1308,    59, 11000, -1308, 11140,  1234,  1255, -1308, -1308, -1308,
     466, -1308, -1308,  5820,  5905, 10367,  1543,  1547, 10367, -1308,
   -1308,  1532,  1534,  1538,  1539,  1540,  1541,   795, 10024,  5428,
      35, -1308,  5197,  8485,  1731, -1308,  1548,  1043,  1046,  1549,
    1047, -1308, -1308,  1558, -1308,  1556, -1308,  1557,   797,   813,
    1559,  1068,  1560, 10367,  1561,  1562,  1069,  1308, 10046,  5428,
   10367, -1308,  1771, 10367,  1585, 10367,  1586,  5428,  5777,  5777,
    5428,  5777,  5777,  5777,  5777,  5428,  1567,  1563,  5777,  5777,
    5777,  5777,   603,   167,   168,   823, -1308,  1568,   836, -1308,
    1571,   712,  1203,  1072, -1308,  1580, 11000, -1308, 10367, -1308,
    1821,   872, -1308,   873, -1308, -1308,  8507,  8529,   913, -1308,
    5428, -1308, -1308, -1308, -1308,  7601,  7644,  7666, -1308, -1308,
    1587,  1590,  5428, -1308, -1308, -1308,  1592,  7688, -1308,  7710,
    7732,  1593,  7754,  1596,  2365,  1597,  5428,  5428,  1598,   174,
   -1308, 10367, -1308, -1308,  1601,   917,  1589,   173,  5428,  5428,
    8551,  1603,  5428,  5428,  8573, 10367, 10068,  5428, -1308, 10367,
   -1308,  1761,  1078,   924,  8649, -1308,  1082, -1308, -1308,  1825,
    1286,  1793, -1308,  1607,  1086,  1087,  1609, -1308, -1308,  4852,
    4852, -1308, -1308, -1308, -1308, -1308, -1308,  5428, -1308,  5428,
   10367, -1308,  1621,   132,  4390, -1308,  5428, -1308,   498,   712,
   -1308, -1308,  5428,  1852, -1308,  2369, -1308, -1308, -1308, -1308,
     158, -1308,   158,   158,   158, -1308,  1615,  1618,  5428,  9279,
   -1308,   223,  5428,  5428, 10367,  1627,  1630,    62,  1631,  1632,
    1633,  1634,   938, -1308,  5972,  1635,  1636,  1640,  1641,  1644,
    1645,  1555,   939,  1555,   943,  5428, -1308, -1308, -1308, -1308,
     705,   747,   786, -1308,   612,   889,   996,  1003,  1026, -1308,
   -1308, -1308,  1203,  2365, -1308,  1873,  1836,  1651, -1308,  1650,
   -1308, -1308, -1308,  1656,  8801,  1298,  2443,  2675,  2745,  3844,
    5428,  8823,  1298,  2365,  2365,  3844,  2365,  3844,  3844, -1308,
   -1308, -1308, 10367, 10367,  1604,  4504,  4504, -1308, -1308,  1657,
    5428,  1923,  8877,  8899, -1308,  5428,  8921,  8943, -1308,  5428,
   10098,  1090, -1308,  1896, -1308, -1308, -1308,  1660, -1308,  1101,
    1901, -1308, -1308, -1308, -1308, -1308,    78,   277,   950, 10323,
   -1308, -1308, -1308, -1308,  8965, -1308,  3435, -1308, -1308,   686,
   10367,  1669,  1663, -1308,  7830,  1105,  1115,  1126,  1135, -1308,
   -1308, 10345,  5428,  1876,  5972, 10367, 10367,  5428,  5428, -1308,
    1436,  1670,  1677,  5428,  5428,  5428,  5428,  5428,  1673,  1668,
    5428,  5428,  5428,  5428,  1555,  1555,   201, -1308,   201, -1308,
   -1308,  1298,  1908, -1308,  1917,  1922,  1312,  1926,  1927,  1931,
    1312,  1932,  1933,  1934,  1312,   468, -1308,  1697,  1255,  1255,
    1255,  1312,  1255,  1255,  1255,  1312,  1255,  1255,  1255,  1312,
   -1308,  1880,  1698,  1792,  5314, -1308, -1308, -1308, -1308,  1298,
   -1308,     1,  3725, -1308,  1996,   150,     4,  2067,   103,  2299,
   -1308,  8987, -1308, -1308,  1891,  1892, -1308, -1308, -1308, -1308,
    2365, -1308, -1308, -1308,  7983, -1308, -1308,  8005, -1308, -1308,
    5222,  5428, -1308,  1702,  5428,  1825, -1308,   419,  1136, -1308,
    1139, -1308, -1308, -1308, -1308,  5428, -1308,  5428,  6193,  6193,
    1942, -1308,  1894,  1705,  5428, -1308, -1308, -1308, -1308, -1308,
   -1308,  5428,  8059, -1308,  1726,    62,  1711,   255,  1718,  1436,
      62,    62,  1722,    62,  6370, -1308, -1308,  1725,  1728,    62,
      62,   201,   201, -1308, -1308, -1308,  5428,  5428,  2365, -1308,
   -1308, -1308,  1204, -1308, -1308, -1308,  1204, -1308, -1308, -1308,
    1204, -1308, -1308,  1298,  1140,  1143,  1150,  1204,  1153,  1163,
    1167,  1204,  1168,  1175,  1191,  1204, -1308,  1721, -1308, -1308,
    8081, -1308,  3113, -1308,  2365,  2365, -1308,  1740, -1308, -1308,
    2365, -1308, -1308, -1308, -1308,  3419,  3769,  2365,  2365, -1308,
    1724,  1724, -1308,  5570, -1308, 10367, -1308, -1308, -1308,  1965,
   -1308,  1729, 10367, -1308, -1308,  1732, -1308,  1298, 10367, 10367,
   -1308,  5428,  1737,  5428, -1308,   255,  1738,  1739,  5428,  1741,
    1742,  5428,  5428,  1743,  1744,  5428,  5428,  8103,  8125,  1911,
    1970,  1971,  1984,  2365, -1308, -1308, -1308,  1255, -1308, -1308,
   -1308,  1255, -1308, -1308, -1308,  1255, -1308, -1308, -1308, -1308,
   -1308, -1308, -1308,  1747,  9051, -1308, -1308, -1308,  5428,  5428,
   -1308,  1745, -1308, -1308,  5428,  3844, 10367,  1748,    62,  1749,
    1751,    62,  1752,  1753,    62,    62,  1755,  1766,  8147,  8169,
    1756,  1760, -1308, -1308, -1308, -1308,  1949,  1192,  1195,  1196,
      35,    41,  9215,  9237,  8234,  1937, -1308,  1767, -1308, -1308,
    1768, -1308, -1308,  1769,  1770, -1308, -1308,  1774,  1775, -1308,
   -1308, -1308, -1308, -1308, -1308,  1778,  1777,  1780, -1308, -1308,
   -1308, -1308,  1781,  1782,  1783,  1784, -1308, -1308,  5428,  3844,
    5428, 11140, -1308, -1308, -1308, -1308,  8398, -1308,  8420, -1308,
    3844,  3844, -1308, -1308
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
      12,     0,     0,     0,     0,     0,     0,     0,    12,     0,
      11,     4,    75,    74,    73,    71,    72,    19,    13,     0,
      18,     0,     0,     0,    78,    78,     1,     5,   301,   300,
       0,     0,     0,    14,     0,     0,     0,     0,    77,    79,
      87,   297,    15,     0,   264,   192,   191,     6,     7,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   189,    20,   139,   193,
      17,   721,   724,     0,     0,    97,     0,     0,   307,    16,
       0,     8,   150,   151,   152,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   145,
     154,   146,   143,   140,   141,   181,     0,     0,     0,     0,
     142,   153,   144,   188,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   723,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    82,     0,     0,     0,     0,     0,
       0,    90,     0,   306,   197,   188,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   148,   149,   147,     0,     0,   223,   174,
     175,   172,   176,   173,   177,   169,   170,   171,   156,   178,
     179,   164,   165,   166,     0,   163,   155,   162,   167,   168,
     160,   161,   157,   158,   159,   196,     0,   265,     0,   726,
     722,     0,     0,   108,    99,    98,     0,     0,     0,     0,
      80,    81,     0,     0,     0,     0,     0,    88,    89,     0,
      12,   303,   195,   219,   198,   199,   200,   201,   202,     0,
     203,   205,   206,   207,   208,   209,     0,   211,   212,     0,
       0,     0,   214,   215,   216,   217,   218,     0,     0,   187,
       0,   194,     0,     0,     0,   266,     0,     0,     0,     0,
       0,   719,   685,     0,     0,     0,    84,    83,    86,    85,
       0,     0,     0,     0,     0,   418,     0,   462,     0,     0,
       0,     0,     0,   278,   460,   276,   456,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   180,     0,     0,     0,
     725,     0,   270,     0,     0,     0,     0,     0,   684,     0,
     720,    76,   109,     0,     0,    96,     0,   100,    92,    93,
      95,    94,    91,   422,     9,    10,   423,   420,     0,   424,
       0,   419,     0,   308,     0,     0,   466,     0,   289,   289,
     289,   461,   304,    12,   282,   305,     0,   298,   204,   210,
     220,   221,   213,   182,     0,   224,   268,   269,   267,     0,
       0,     0,   715,   716,   717,     0,     0,   673,     0,   110,
       0,     0,   421,     0,     0,   309,   418,   310,     0,     0,
       0,     0,   458,   408,   412,   406,   411,   407,   410,   414,
     409,   405,   413,   415,   416,   291,   288,   291,   417,   291,
     291,   277,   280,   279,     0,     0,   225,   727,     0,     0,
     271,   718,     0,     0,   729,     0,   110,     0,   110,     0,
       0,     0,     0,   465,     0,   464,     0,     0,   467,   290,
     478,   478,   478,   478,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   475,   473,     0,   474,     0,     0,
       0,     0,   380,    51,     0,     0,     0,     0,     0,   323,
     389,     0,     0,     0,   291,     0,     0,     0,   691,   710,
     693,   694,   688,   689,   690,   692,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,     0,   678,   675,   676,   680,     0,   686,   111,   101,
       0,   106,     0,   106,     0,   432,   311,     0,     0,   457,
     477,     0,     0,     0,     0,     0,   373,     0,     0,     0,
     118,    63,     0,    53,     0,     0,     0,     0,     0,     0,
     379,   489,     0,   291,   291,     0,   291,     0,     0,     0,
     185,   239,     0,   185,     0,     0,   369,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   525,     0,     0,
       0,     0,     0,     0,     0,    50,   478,     0,     0,     0,
       0,     0,     0,   451,     0,   240,   246,   247,   248,   256,
       0,     0,   241,   252,   243,   249,   250,   251,   242,   254,
     257,     0,     0,     0,   253,   255,   259,   262,   263,     0,
     258,   260,   261,   245,   244,     0,     0,     0,   404,     0,
     396,   392,   395,   363,   388,   299,   478,   291,   728,     0,
     683,   674,   679,     0,   681,     0,     0,   687,   104,     0,
       0,   102,     0,   476,   445,   444,   429,   431,   434,     0,
     463,     0,   284,   283,   285,   286,     0,   322,     0,   375,
       0,     0,   122,   126,   121,   125,   120,   124,   123,   127,
       0,     0,     0,    62,     0,     0,     0,   324,     0,    54,
      27,     0,   376,   485,   486,   487,   488,     0,   483,     0,
       0,   478,   478,   372,   478,    35,     0,   425,     0,   233,
       0,     0,   184,     0,     0,   332,     0,     0,   331,   371,
       0,     0,     0,     0,     0,   552,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   544,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   530,   529,     0,   556,   370,
     526,   503,     0,   502,     0,     0,     0,     0,     0,    63,
       0,     0,     0,     0,   357,   358,    36,     0,     0,   427,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    12,   292,     0,   342,   343,
       0,   479,   492,     0,     0,   479,   496,     0,     0,     0,
       0,   402,   401,   400,   403,   291,     0,     0,     0,     0,
     344,   185,     0,     0,     0,   185,     0,     0,   291,     0,
       0,   361,    63,   478,   730,     0,     0,   714,   688,   689,
     690,     0,     0,   107,   105,   103,   439,   433,     0,     0,
     459,     0,     0,     0,     0,     0,     0,     0,    70,    68,
      69,     0,    58,   292,     0,   296,     0,   364,    55,    52,
       0,   484,     0,   381,     0,     0,     0,     0,    28,     0,
       0,     0,   472,     0,     0,     0,     0,     0,   186,   232,
     238,     0,     0,     0,     0,   507,   506,     0,     0,     0,
     501,     0,     0,     0,   564,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   524,   521,   522,   523,     0,
       0,     0,     0,   543,   556,   554,   555,     0,     0,   528,
       0,   539,     0,   347,   345,    49,    48,    47,     0,     0,
       0,   367,     0,     0,     0,    29,   450,   448,   449,   185,
       0,     0,     0,     0,   628,   185,   624,     0,     0,     0,
     578,     0,   632,     0,     0,     0,     0,     0,     0,     0,
       0,   590,     0,   583,     0,     0,     0,     0,     0,     0,
       0,     0,    56,    12,     0,   128,     0,   634,   633,   608,
       0,     0,   627,     0,     0,    31,     0,     0,   490,   480,
       0,    23,    33,     0,   494,     0,    25,    34,    26,    30,
       0,    32,    24,     0,     0,     0,     0,     0,   325,     0,
     329,   478,     0,   393,     0,     0,     0,   711,   712,   713,
       0,   677,   441,     0,     0,   440,     0,     0,   287,   302,
     374,     0,     0,     0,     0,     0,     0,     0,    66,     0,
       0,   341,     0,     0,     0,   352,     0,     0,     0,   272,
       0,   426,   236,     0,   230,     0,   234,     0,     0,     0,
       0,     0,     0,   183,     0,     0,     0,     0,   548,     0,
     550,   553,     0,   558,   139,   557,   139,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   546,     0,     0,
       0,     0,     0,     0,     0,     0,    64,     0,     0,   351,
       0,     0,   655,     0,   378,     0,     0,   366,   430,   428,
       0,     0,   454,     0,   340,   339,     0,     0,     0,   589,
       0,   582,   580,   579,   631,     0,     0,     0,   575,   588,
       0,     0,     0,   587,   585,   584,     0,     0,   577,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     131,   136,   293,   609,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   491,     0,     0,   493,   495,
     497,     0,     0,     0,     0,   326,     0,   327,   330,     0,
      63,     0,   362,     0,     0,     0,     0,   442,   443,     0,
       0,   117,   116,   114,   112,   115,   113,     0,    59,     0,
     294,   295,     0,     0,     0,   383,     0,   356,    12,     0,
     320,   319,     0,     0,   318,     0,   471,   237,   231,   235,
       0,   336,     0,     0,     0,   333,     0,     0,     0,   181,
     566,     0,     0,     0,   563,     0,     0,   567,     0,     0,
       0,     0,     0,   545,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   527,   540,   538,   349,
     639,   639,   639,   669,     0,   639,   639,   639,     0,   636,
     653,   637,   654,     0,   315,     0,     0,     0,   446,     0,
     447,   615,   613,     0,     0,    40,     0,     0,     0,     0,
       0,     0,    40,     0,     0,     0,     0,     0,     0,    57,
     610,   130,   135,   134,    12,     0,     0,   129,   626,     0,
       0,     0,     0,     0,   614,     0,     0,     0,   612,     0,
       0,     0,    22,     0,   138,   635,   328,     0,   399,     0,
       0,   394,   321,   316,   317,   682,     0,     0,     0,     0,
     386,   384,   365,   382,     0,   229,     0,   226,   228,     0,
     273,   274,     0,   470,     0,     0,     0,     0,     0,   505,
     504,     0,     0,     0,     0,   560,   559,     0,     0,   573,
     569,     0,   568,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   541,     0,   542,
      65,    40,     0,   638,     0,     0,   291,     0,     0,     0,
     291,     0,     0,     0,   291,   671,   672,     0,     0,     0,
       0,   291,     0,     0,     0,   291,     0,     0,     0,   291,
     652,     0,     0,     0,     0,   455,   623,   574,    37,    39,
     630,     0,     0,    46,     0,     0,     0,     0,     0,     0,
     605,     0,   576,   630,   600,   598,   591,   622,   607,   606,
       0,   132,   133,   625,     0,   617,   620,     0,   616,   618,
       0,     0,    21,     0,     0,     0,   314,   479,     0,   499,
       0,   438,   437,   436,   435,     0,    60,     0,     0,     0,
       0,   227,     0,     0,     0,   469,   468,   338,   337,   335,
     334,     0,     0,   565,   561,   567,     0,   570,     0,   571,
     567,   567,     0,   567,   567,   520,   547,     0,     0,   567,
     567,     0,     0,   535,   536,   537,     0,     0,     0,   661,
     664,   667,   478,   659,   662,   665,   478,   660,   663,   666,
     478,   670,   668,    40,     0,     0,     0,   478,     0,     0,
       0,   478,     0,     0,     0,   478,   346,     0,   368,   453,
       0,    38,     0,   595,     0,     0,    43,     0,   592,    45,
       0,   596,   593,   597,   594,     0,     0,     0,     0,   611,
       0,     0,   481,     0,   137,   397,   398,   498,   313,     0,
     312,     0,    67,   387,   385,     0,   353,    40,   275,   549,
     551,     0,     0,     0,   511,   572,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   645,   648,   651,     0,   643,   646,
     649,     0,   644,   647,   650,     0,   377,   452,   581,   629,
      44,    42,    41,     0,     0,   586,   601,   599,     0,     0,
     482,   479,   500,    61,     0,     0,   562,     0,   567,     0,
       0,   567,     0,     0,   567,   567,     0,     0,     0,     0,
       0,     0,   350,   658,   656,   657,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   509,     0,   512,   515,
       0,   517,   519,     0,     0,   514,   518,     0,     0,   531,
     533,   348,   642,   640,   641,     0,     0,     0,   621,   619,
     359,   355,     0,     0,     0,     0,   532,   534,     0,     0,
       0,     0,   510,   516,   508,   513,     0,   603,     0,   360,
       0,     0,   604,   602
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1308, -1308, -1308,  1564,  -278,     5, -1308,  1990,  1995, -1091,
   -1308, -1307,  -709,  -582, -1308, -1308,  -546, -1308,  -243,  -625,
    -783,  1051,  -801,  -416,  2022,  2007, -1308, -1308, -1308,  1850,
   -1308, -1308, -1308,  1844, -1308, -1308, -1308, -1308,  1474,     3,
     975,  -661, -1308,  -564,  -580, -1019, -1308,  -503, -1308,   -32,
   -1308,  -726,   -67,   155, -1308,   633,  1271,  -489, -1308, -1308,
    -227,  -336, -1308, -1308, -1308,  1637,   531,  -306,  -685,   941,
   -1308, -1308, -1308, -1308, -1308, -1308, -1308, -1308, -1308,  -520,
   -1308, -1308, -1308, -1308, -1308, -1308, -1308, -1308, -1308,  1533,
   -1308, -1308,   780, -1308, -1308, -1308,  -496, -1071,  -589,   513,
     657, -1308,  1376,   138,   404,   -17, -1308, -1308,  -381,  1058,
   -1308, -1308,  1348,  -882, -1308, -1308,   709, -1308, -1308,  1652,
      -3,  1574,   948,  1122, -1308,  -289,  -433,  -501, -1308, -1308,
    1008,  -665,  1007,  1402,   426, -1308,  1441, -1308,  -602, -1308,
   -1308, -1206,  -596, -1308,  -612,  1117, -1308,  1093,  -314, -1308,
    -941, -1308,  -634, -1308, -1308,   570,  1265,  -984, -1308,   742,
    -346, -1225, -1308, -1308,   636,   834,  1578, -1308, -1308,  1554,
   -1308, -1308,  1569, -1308, -1308,   487,  -528,  1037,  1796, -1308,
   -1308, -1308, -1308, -1308, -1308
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     7,     8,    86,   389,   518,    10,    19,    20,   519,
    1489,  1490,  1493,  1494,   635,   636,   583,   584,   844,   733,
     734,  1155,  1156,   912,    11,    39,    12,    96,   183,   184,
      13,    97,   190,   191,    14,   179,   325,   377,   700,   265,
     475,   580,   581,   730,   731,   845,  1209,  1210,   869,  1098,
     136,   763,  1495,    88,  1406,  1407,   601,   602,   676,   677,
      89,   363,  1110,   341,   342,   343,   455,   490,   847,   915,
     916,    15,    98,   465,    30,   348,   281,   193,   336,   520,
    1162,  1161,  1451,  1268,  1106,  1771,  1074,  1102,  1166,   591,
     521,  1264,  1265,  1539,  1538,   522,   523,   682,   683,  1388,
    1389,   864,   865,   456,   460,   390,   756,   818,   435,   819,
     706,   707,   708,  1086,   709,   821,  1172,  1173,   344,   345,
     346,   397,   932,   933,   524,   570,   571,  1637,  1049,   749,
     852,   853,   856,   857,  1529,  1530,   627,   628,   629,   797,
     630,  1576,   631,   632,   786,   775,   776,   977,   955,  1291,
    1431,  1432,  1038,  1345,  1352,  1612,  1013,  1039,   870,  1330,
    1456,  1331,  1332,  1333,  1323,  1324,   428,   473,   551,   552,
     553,   554,   555,   368,   369,   556,   557,   892,   321,   322,
      93,   175,   317,   420,    16
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      87,   681,   684,  1242,   867,     9,   771,   787,   788,   789,
     848,   437,   772,     9,   798,   873,   849,  1087,   144,   639,
     761,   604,   414,   767,  1219,  1223,   988,  1190,   697,    44,
      44,   337,   931,   196,  1043,    33,   760,   263,    44,   766,
     739,    21,  1756,  1408,    44,  1503,   391,    99,   851,   914,
     135,   872,   876,   143,  1613,   337,  1213,  1621,   572,   573,
     574,   578,  1000,  -119,   599,  1429,    22,   860,   195,  -404,
     599,  1329,   599,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   558,   432,  1075,
     558,   566,   599,   773,   256,   718,   719,   774,   982,   558,
    1097,   599,   434,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   195,
    1008,   258,   813,   154,  1578,  1017,   758,   391,  1020,   431,
      44,   491,  1027,   492,   493,   597,  1623,  -418,   388,   308,
     577,   599,  1104,   861,   587,   697,   996,   697,   891,    17,
     785,   785,   908,   337,   997,   998,    44,  1405,   909,   910,
     640,  1408,    91,   880,   318,   974,    23,   874,   877,   307,
     918,   462,  1012,    18,   195,   309,     1,   436,    17,   319,
    1021,  1012,  1002,   809,  1002,   102,   103,   104,  1118,   908,
     586,   320,   862,   863,     1,   909,   910,   757,   686,   391,
    1360,   227,    42,  -404,  1573,  1574,  1614,   383,   391,  1614,
    1203,   228,   129,   131,   132,   133,   134,   908,   140,   142,
     330,  1329,  1577,   909,   910,  1181,   365,    34,  1066,   908,
     898,   384,   385,   882,  1488,   909,   910,   349,  1002,    34,
    1365,  1488,   899,  1044,   350,  1193,    92,   351,   352,   353,
     415,   386,   585,  1171,   843,   264,   486,   388,   356,  1178,
     357,   358,   359,   843,   360,   340,  1673,   751,   752,   843,
     754,    -3,   223,   224,   225,   388,   338,   579,   579,   875,
     339,  1430,   748,  -119,   589,   600,  -380,   871,  -119,   388,
     759,   387,   732,    24,   861,  1405,  -404,     1,   924,   925,
    1531,   926,   413,   373,  1091,   641,  1094,  -418,  1614,  1532,
     366,   421,  1001,   422,  1191,   559,   396,   875,   698,  1297,
    1705,  1092,   732,  1096,  1302,   983,   603,   701,   984,  1481,
    1048,   168,   169,   170,  1054,  1120,   433,  1401,   891,   585,
    1488,  1124,   439,   862,   863,  1665,  1666,  1396,  1397,  1504,
    1505,   227,  1507,  1122,   154,  1620,  -380,   430,  1125,  1184,
    1033,   883,     2,  1065,  1067,  1034,   979,  1069,   981,   227,
     704,  1184,    47,    48,   705,  1232,   875,   383,  1611,  -354,
    -380,  -380,  1105,   999,   388,  1311,  1313,   911,   340,  -461,
    1239,  1371,  -461,  1366,   338,   914,  1367,   846,   339,   482,
    -380,   384,   385,   846,    26,  1032,  1575,  -281,    25,  -281,
    -281,  1003,  1004,  1003,  1004,    35,     3,   487,   488,   374,
     964,   386,   375,   227,   978,   376,    31,  1121,   564,   565,
    1076,   590,   567,   355,  1126,     4,  1398,  1390,   921,    28,
    -380,    29,  1423,    36,   956,   957,   958,   959,   960,   961,
     962,  1591,   980,   794,  1424,   785,   969,   970,   971,   972,
     561,   387,   563,   396,  1031,    32,     5,  1003,  1004,   145,
     146,   598,   147,   148,   149,   150,   151,   152,   153,   172,
     642,    -2,  1488,   154,     6,   173,   171,   913,  1616,   585,
     441,   806,   172,   807,  1450,   151,   152,   153,   173,  1533,
     442,   478,   154,   479,     1,  1286,  1629,     1,  1534,   145,
     146,  1287,   147,   148,   149,   150,   151,   152,   153,  1320,
    1321,  1312,  1314,   154,   808,    37,  1111,   738,   157,    38,
     735,   172,   795,  -380,   681,  1322,  1488,   173,   500,  1060,
     750,   367,   796,   318,  1179,   441,  1381,   172,   762,  1325,
    1326,   762,  1071,   173,   388,   711,  1241,  1236,   319,  1153,
     166,   167,   168,   169,   170,  1327,   508,  1154,  1107,  1108,
     320,   476,     2,   477,  1669,   172,   180,  1007,   913,   846,
     266,   173,   181,   913,  1018,   267,   913,   846,   846,    41,
     913,  1698,  1699,   182,  1652,  1035,  1309,   846,    17,  1656,
    1657,  1093,  1659,  1660,  1310,    94,  1555,  1556,  1663,  1664,
    1690,  1691,  1560,  1561,  1562,  1563,  1692,   101,  1240,  1567,
    1568,  1569,  1570,  1696,  1697,    95,     3,   723,   398,   399,
     517,  1046,  1163,  1053,   180,   270,   678,   227,  1095,  1524,
     181,  1047,   687,  1047,   400,     4,   725,  1212,   727,  1047,
    1336,   182,   896,   176,   145,   146,   177,   147,   148,   149,
     150,   151,   152,   153,   722,   729,   903,   227,   154,  1726,
     282,   155,   156,   157,   158,   159,     5,   100,   887,  1446,
    1779,  1448,   421,   724,   717,   726,   919,   164,   165,   166,
     167,   168,   169,   170,     6,  1500,   720,   721,  1077,  1078,
    1079,  1506,   728,  1508,  1509,   736,   762,   737,   166,   167,
     168,   169,   170,   383,  1641,   743,   975,   976,   944,  1244,
    1245,   105,   722,   723,   964,   106,   163,   164,   165,   166,
     167,   168,   169,   170,   107,   185,   186,   384,   385,   744,
     745,   724,   725,   726,   727,  1497,  1499,  1737,   723,   187,
    1740,  1231,  1542,  1743,  1744,   108,  1036,   386,  1452,   746,
     728,   729,   188,  1320,  1321,  1619,   846,   725,  1619,   727,
    1619,  1415,   913,  1416,  1417,  1418,   109,   189,   846,  1322,
    1218,  1222,   384,   385,  1453,   110,   729,   145,   146,  1189,
     111,   195,   172,   846,   151,   152,   153,   387,   173,   747,
    1457,   154,  1454,   227,  1295,  1296,   311,  1298,  1299,  1300,
    1301,   112,  1571,  1572,  1305,  1306,  1307,  1308,   403,   762,
     404,   405,   113,   762,   384,   385,  1453,   421,   114,   740,
    1040,  1465,  1708,  1466,  1467,   392,   115,  1711,   393,  1461,
    1714,  1715,  1511,  1512,  1458,  1041,  1085,  1085,  1042,  1088,
     116,   172,   130,   913,    44,    45,    46,   173,   117,    47,
      48,    49,   118,   384,   385,  1453,   722,   160,  1103,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   185,
     186,   174,   762,  1462,   119,   724,  1123,   726,   593,   594,
     388,   596,   388,   187,   416,  1128,  1130,   120,   277,   401,
    1133,  1135,   402,   121,   728,  1465,   188,  1466,  1543,   458,
     457,   459,   954,   954,   954,   954,   954,   954,   954,   954,
     764,   189,   765,   443,   444,   954,   954,   954,   954,  1643,
    1644,   445,   446,   447,   448,   449,   764,   468,   768,   450,
     469,  1168,  1468,   451,   452,   935,   938,   762,   936,   939,
    1176,  1177,   122,   762,  1215,  1460,  1464,   846,  1689,  1471,
    1475,  1479,  1185,  1186,  1187,   178,   384,   385,  1453,   810,
    1035,   811,  1689,   421,  1197,   815,  1199,  1200,  1202,   850,
     123,   851,  1211,   453,   454,   942,  1469,  1005,   943,   195,
    1006,  1220,  1224,   938,  1225,  1226,  1114,  1115,   681,   681,
    1116,  1229,   854,   124,   855,   164,   165,   166,   167,   168,
     169,   170,  1234,   192,  1257,  1263,   938,  1258,  1204,  1278,
     693,   695,  1455,  1459,  1463,  1755,  1757,  1470,  1474,  1478,
      53,   222,  1115,    54,    55,  1279,    56,    57,    58,    59,
      60,    61,  1315,    62,    63,  1316,   858,  1260,   855,  1472,
     195,  1735,    64,    65,   257,  1315,  1476,    66,  1318,   125,
      67,    68,    69,    70,   126,   127,    71,    72,    73,    74,
     128,    75,    76,   384,   385,  1453,   866,  1289,   851,   651,
     384,   385,  1453,   259,   261,  1294,   846,  1134,  1136,    82,
     260,   938,  1339,  1473,  1338,  1340,   262,   268,  1146,    85,
    1477,   269,   846,   661,   662,   663,   846,   846,   846,   846,
     846,   846,  1594,  1595,  1596,  1777,  1598,  1599,  1600,   272,
    1602,  1603,  1604,   669,   273,   274,  1782,  1783,  1344,  1670,
    1582,   275,   938,  1671,  1586,  1343,   227,  1672,  1590,  1369,
    1351,   276,   154,  1383,  1677,  1597,  1384,  1328,  1681,  1601,
     279,   280,  1685,  1605,  1362,  1363,   316,  1437,   964,   846,
    1438,  1447,   964,   323,   324,  1449,  1372,  1373,   326,  1535,
    1376,  1377,  1536,   327,   927,  1380,   928,  1263,   949,   964,
     950,   965,   964,  1557,   966,   145,   146,   328,   147,   148,
     149,   150,   151,   152,   153,   329,   331,  1085,  1085,   154,
     332,   333,   155,   156,   157,   158,   159,  1399,   964,     1,
     967,   964,   195,   968,  1404,  1243,   334,   362,   133,   134,
    1410,   347,   335,  1414,   994,  1050,   995,  1051,  1055,   361,
    1056,   681,  1055,  1050,  1058,  1062,  1421,   764,   362,  1068,
    1425,  1426,   764,   500,  1070,   846,  1100,   764,  1101,  1175,
     764,   364,  1235,  1328,  1325,  1326,   -12,   764,   764,  1237,
    1238,   372,   421,   846,  1270,   421,  1273,  1271,  1274,   379,
    1327,   508,   371,   954,   954,   380,   954,   954,   954,   954,
     -12,   -12,   -12,   954,   954,   954,   954,   764,   764,  1281,
    1285,   421,   394,  1334,   195,   195,   195,  1050,  1501,  1382,
     -12,   764,   381,  1386,     1,   421,   421,  1393,  1394,  1050,
     382,  1522,  1655,  1211,  1211,   395,   337,  1328,  1514,  1211,
    1525,  1727,  1526,  1517,   764,  1728,  1547,  1520,   406,  1729,
    1328,   846,   443,   444,   764,   517,  1548,  1328,   500,   419,
     445,   446,   447,   448,   449,   764,   407,  1549,   450,  1510,
     423,   -12,   451,   452,   764,  1525,  1550,  1638,  1639,   421,
    1640,  1674,   421,   424,  1675,   846,   508,   846,   846,   421,
    1552,  1676,   421,   846,  1678,   -12,   -12,   -12,   425,   846,
     846,   846,   421,   426,  1679,  1564,   421,   421,  1680,  1682,
     427,  1328,   453,   454,   421,   -12,  1683,   429,   160,   484,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     421,   421,  1684,  1752,   421,   421,  1753,  1754,   263,    44,
     141,   434,    44,    45,    46,   485,   846,    47,    48,    49,
     517,   560,  1610,   562,   388,   464,  1328,   440,   466,  1439,
     467,   470,   195,   471,   472,   195,   474,   195,   481,   489,
     494,   483,   569,   525,   526,   575,   582,   576,   846,   145,
     146,   588,   147,   148,   149,   150,   151,   152,   153,  1633,
     592,   458,  1635,   154,  1328,   595,   155,   156,   157,   158,
     159,   590,   634,   913,   913,  1642,   443,   444,   637,   685,
     688,   691,  1648,   690,   445,   446,   447,   448,   449,  1649,
     712,   699,   450,   713,   714,   715,   451,   452,   716,   732,
     741,   742,   929,   753,    44,    45,    46,   769,   755,    47,
      48,    49,   846,   770,  1667,  1668,   626,   777,   778,   779,
     489,   780,   781,   846,   846,   782,   783,   784,   785,   790,
     791,    50,    51,    52,   792,   793,   453,   454,   805,   801,
     802,   814,   803,   817,   804,   868,   816,   881,   893,  1554,
     820,   884,   894,   895,   901,   900,   904,   902,   905,   906,
     907,   922,   920,  1694,   934,   945,   937,   941,  1328,   990,
     946,   947,   948,   991,   992,   963,  1117,   973,    44,    45,
      46,   985,   986,    47,    48,    49,   987,   989,    53,  1706,
     993,    54,    55,  1014,    56,    57,    58,    59,    60,    61,
       1,    62,    63,  1718,  1719,    50,    51,    52,  1045,  1052,
      64,    65,  1015,  1016,  1019,    66,  1026,  1028,    67,    68,
      69,    70,  1328,  1029,    71,    72,    73,    74,  1030,    75,
      76,  1064,  1057,  1063,  1059,  1061,  1732,  1733,  1072,  1073,
    -711,  -712,  1734,  -713,  1080,  1081,  1205,    82,    44,    45,
      46,  1089,  1099,    47,    48,    49,  1109,    85,  1112,  1113,
    1132,  1138,   160,  1137,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,  1139,    50,    51,    52,  1140,   378,
      53,  1141,  1142,    54,    55,  1143,    56,    57,    58,    59,
      60,    61,  1144,    62,    63,  1145,  1147,  1148,  1149,  1150,
    1151,  1159,    64,    65,  1160,  1165,  1776,    66,  1778,  1164,
      67,    68,    69,    70,  1167,  1174,    71,    72,    73,    74,
    1180,    75,    76,  1182,  1188,  1206,  1192,    77,    78,    79,
    1194,  1227,    80,    81,   851,  1207,   855,  1233,  1249,    82,
    -185,  1198,  1250,  -185,  1251,   930,  1252,    83,    84,    85,
    1253,  1254,  1255,  1256,    53,  1267,  1269,    54,    55,  1272,
      56,    57,    58,    59,    60,    61,  1275,    62,    63,  1277,
     930,  1280,  1282,  1283,  1284,  1290,    64,    65,  1292,  1293,
    1317,    66,  1319,  1304,    67,    68,    69,    70,  1303,  1335,
      71,    72,    73,    74,  1337,    75,    76,  1370,  1387,  1349,
    1350,    77,    78,    79,  1353,  1357,    80,    81,  1359,  1361,
    1364,  1375,  1368,    82,  -185,  1391,  1400,  -185,  1392,   930,
    1395,    83,    84,    85,    53,  1411,  1419,    54,    55,  1420,
      56,    57,    58,    59,    60,    61,  1427,    62,    63,  1428,
    1433,  1434,  1435,  1436,  1440,  1441,    64,    65,  1482,  1442,
    1443,    66,  1444,  1445,    67,    68,    69,    70,  1483,  1484,
      71,    72,    73,    74,  1170,    75,    76,  1486,  1513,  1523,
    1524,    77,    78,    79,  1527,  1545,    80,    81,  1208,  1544,
    1553,  1579,  1558,    82,  1565,   822,  1559,    44,   823,  1566,
    1580,    83,    84,    85,  1205,  1581,    44,    45,    46,  1583,
    1584,    47,    48,    49,  1585,  1587,  1588,  1589,  1593,  1606,
    1607,  1608,  1627,  1628,  1634,  1645,  1647,   824,  1646,  1651,
    1653,   825,   826,    50,    51,    52,   827,   828,   829,  1654,
     830,  1658,  1686,   831,  1661,  1614,  1183,  1662,  1701,  1217,
    1722,  1703,  1704,  1723,  1724,   832,   833,   834,   835,  1707,
    1709,  1710,   836,  1712,  1713,  1716,  1717,  1725,  1730,  1736,
    1738,  1761,  1739,  1741,  1742,  1047,  1745,  1617,  1749,    44,
      45,    46,  1750,  1206,    47,    48,    49,  1746,  1751,  1762,
    1763,  1764,  1765,  1207,   837,   838,  1766,  1767,  1768,  1769,
    1770,    43,  1772,  1773,  1774,  1775,    50,    51,    52,    90,
      27,  1158,    40,   271,   278,   940,   527,   702,  1636,  1541,
     463,  1261,   839,  1492,  1403,   633,   840,  1528,  1485,  1618,
     528,   696,  1169,   461,   878,   897,  1119,   529,  1228,   530,
     568,   531,  1230,  1276,   859,  1702,  1131,  1152,  1617,   800,
      44,    45,    46,  1626,  1480,    47,    48,    49,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,    50,    51,    52,
    1025,  1592,    53,  1409,   689,    54,    55,   692,    56,    57,
      58,    59,    60,    61,  1492,    62,    63,  1246,   370,     0,
    1622,     0,     0,   694,    64,    65,     0,     0,     0,    66,
       0,     0,    67,    68,    69,    70,     0,     0,    71,    72,
      73,    74,     0,    75,    76,     0,     0,     0,     0,    77,
      78,    79,     0,     0,    80,    81,     0,   841,     0,   842,
       0,    82,   843,     0,     0,     0,     0,     0,     0,    83,
      84,    85,     0,     0,     0,    53,     0,     0,    54,    55,
     605,    56,    57,    58,    59,    60,    61,     0,    62,    63,
       0,     0,     0,     0,     0,     0,     0,    64,    65,     0,
       0,     0,    66,     0,     0,    67,    68,    69,    70,     0,
       0,    71,    72,    73,    74,     0,    75,    76,     0,     0,
       0,     0,    77,    78,    79,     0,     0,    80,    81,     0,
       0,     0,     0,     0,    82,     0,   606,     0,     0,     0,
       0,     0,    83,    84,    85,     0,    53,   607,   608,    54,
      55,     0,    56,    57,    58,    59,    60,    61,     0,    62,
      63,     0,     0,     0,     0,     0,     0,     0,    64,    65,
       0,     0,     0,    66,     0,     0,    67,    68,    69,    70,
       0,     0,    71,    72,    73,    74,     0,    75,    76,   609,
       0,     0,     0,    77,    78,    79,     0,     0,    80,    81,
    1617,     0,    44,    45,    46,    82,     0,    47,    48,    49,
       0,     0,     0,    83,    84,    85,   610,   611,   612,   613,
     614,   615,   616,   617,     0,     0,     0,     0,     0,    50,
      51,    52,   618,   619,   620,   621,     0,     0,   622,   623,
     624,   625,     0,     0,     0,     0,  1492,     0,     0,     0,
       0,     0,  1624,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   822,     0,    44,   823,
    1412,     0,    44,    45,    46,     0,     0,    47,    48,    49,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   824,    50,
      51,    52,   825,   826,     0,     0,     0,   827,   828,   829,
       0,   830,     0,     0,   831,     0,     0,   626,     0,     0,
       0,     0,     0,     0,     0,     0,   832,   833,   834,   835,
       0,     0,     0,   836,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1491,     0,    44,    45,    46,     0,
       0,    47,    48,    49,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   837,   838,     0,     0,     0,
       0,     0,     0,    50,    51,    52,     0,     0,    53,     0,
       0,    54,    55,     0,    56,    57,    58,    59,    60,    61,
    1492,    62,    63,   839,     0,     0,     0,   840,     0,     0,
      64,    65,     0,     0,     0,    66,     0,     0,    67,    68,
      69,    70,     0,     0,    71,    72,    73,    74,     0,    75,
      76,     0,     0,     0,     0,    77,    78,    79,     0,     0,
      80,    81,     0,     0,     0,     0,     0,    82,     0,     0,
       0,     0,     0,     0,     0,    83,    84,    85,    53,     0,
       0,    54,    55,     0,    56,    57,    58,    59,    60,    61,
       0,    62,    63,     0,     0,     0,     0,     0,     0,     0,
      64,    65,     0,     0,     0,    66,     0,     0,    67,    68,
      69,    70,     0,     0,    71,    72,    73,    74,     0,    75,
      76,     0,     0,     0,     0,    77,    78,    79,     0,     0,
      80,    81,     0,     0,     0,     0,  1037,    82,   841,     0,
     842,  1413,   799,   843,     0,    83,    84,    85,     0,     0,
       0,     0,    53,   607,   608,    54,    55,     0,    56,    57,
      58,    59,    60,    61,     0,    62,    63,     0,     0,     0,
       0,     0,     0,     0,    64,    65,     0,     0,     0,    66,
       0,     0,    67,    68,    69,    70,     0,     0,    71,    72,
      73,    74,     0,    75,    76,   609,     0,     0,     0,    77,
      78,    79,     0,     0,    80,    81,  1496,     0,    44,    45,
      46,    82,     0,    47,    48,    49,     0,     0,     0,    83,
      84,    85,   610,   611,   612,   613,   614,   615,   616,   617,
       0,     0,     0,     0,     0,    50,    51,    52,   618,   619,
     620,   621,     0,     0,   622,   623,   624,   625,     0,     0,
       0,     0,  1492,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   822,     0,    44,   823,  1498,     0,    44,    45,
      46,     0,     0,    47,    48,    49,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   824,    50,    51,    52,   825,   826,
       0,     0,     0,   827,   828,   829,     0,   830,     0,     0,
     831,     0,  1492,   626,     0,     0,     0,     0,     0,     0,
       0,     0,   832,   833,   834,   835,     0,     0,     0,   836,
       0,     0,     0,     0,     0,  1195,   438,     0,    44,    45,
      46,     0,     0,    47,    48,    49,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   837,   838,     0,     0,    50,    51,    52,     0,     0,
       0,     0,     0,     0,    53,     0,     0,    54,    55,     0,
      56,    57,    58,    59,    60,    61,     0,    62,    63,   839,
       0,     0,     0,   840,     0,     0,    64,    65,     0,     0,
       0,    66,     0,     0,    67,    68,    69,    70,     0,     0,
      71,    72,    73,    74,     0,    75,    76,     0,     0,     0,
       0,    77,    78,    79,     0,     0,    80,    81,     0,     0,
       0,     0,     0,    82,     0,     0,     0,     0,     0,     0,
       0,    83,    84,    85,    53,     0,     0,    54,    55,     0,
      56,    57,    58,    59,    60,    61,     0,    62,    63,     0,
       0,     0,     0,     0,     0,     0,    64,    65,     0,     0,
       0,    66,     0,     0,    67,    68,    69,    70,     0,     0,
      71,    72,    73,    74,     0,    75,    76,     0,     0,     0,
       0,    77,    78,    79,     0,     0,    80,    81,     0,     0,
       0,     0,     0,    82,   841,     0,   842,     0,     0,   843,
       0,    83,    84,    85,    53,     0,     0,    54,    55,     0,
      56,    57,    58,    59,    60,    61,     0,    62,    63,     0,
       0,     0,     0,     0,     0,     0,    64,    65,     0,     0,
       0,    66,     0,     0,    67,    68,    69,    70,     0,     0,
      71,    72,    73,    74,     0,    75,    76,     0,     0,     0,
       0,    77,    78,    79,     0,     0,    80,    81,  1157,     0,
      44,    45,    46,    82,     0,    47,    48,    49,   528,   885,
       0,    83,    84,    85,     0,   529,     0,   530,     0,   531,
       0,     0,     0,     0,     0,     0,     0,    50,    51,    52,
       0,     0,     0,     0,     0,     0,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   822,     0,    44,   823,  1196,     0,
      44,    45,    46,     0,     0,    47,    48,    49,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   824,    50,    51,    52,
     825,   826,     0,     0,     0,   827,   828,   829,     0,   830,
       0,     0,   831,     0,     0,  1688,     0,     0,     0,     0,
       0,     0,     0,     0,   832,   833,   834,   835,     0,     0,
       0,   836,     0,     0,     0,     0,     0,     0,  1201,     0,
      44,    45,    46,     0,     0,    47,    48,    49,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   837,   838,     0,     0,    50,    51,    52,
       0,     0,     0,     0,     0,     0,    53,     0,     0,    54,
      55,     0,    56,    57,    58,    59,    60,    61,     0,    62,
      63,   839,     0,     0,     0,   840,     0,     0,    64,    65,
       0,     0,     0,    66,     0,     0,    67,    68,    69,    70,
       0,     0,    71,    72,    73,    74,     0,    75,    76,     0,
       0,     0,     0,    77,    78,    79,     0,     0,    80,    81,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,     0,     0,    83,    84,    85,    53,     0,     0,    54,
      55,     0,    56,    57,    58,    59,    60,    61,     0,    62,
      63,     0,     0,     0,     0,     0,     0,     0,    64,    65,
       0,     0,     0,    66,     0,     0,    67,    68,    69,    70,
       0,     0,    71,    72,    73,    74,     0,    75,    76,     0,
       0,     0,     0,    77,    78,    79,     0,     0,    80,    81,
       0,     0,     0,     0,     0,    82,   841,     0,   842,     0,
       0,   843,     0,    83,    84,    85,    53,     0,     0,    54,
      55,     0,    56,    57,    58,    59,    60,    61,     0,    62,
      63,     0,     0,     0,     0,     0,     0,     0,    64,    65,
       0,     0,     0,    66,     0,     0,    67,    68,    69,    70,
       0,     0,    71,    72,    73,    74,     0,    75,    76,     0,
       0,     0,     0,    77,    78,    79,     0,     0,    80,    81,
    1693,     0,    44,    45,    46,    82,     0,    47,    48,    49,
       0,     0,     0,    83,    84,    85,   822,     0,    44,   823,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    50,
      51,    52,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     1,     0,     0,     0,     0,     0,     0,   824,     0,
       0,     0,   825,   826,     0,     0,     0,   827,   828,   829,
       0,   830,     0,     0,   831,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   500,   832,   833,   834,   835,
       0,     0,     0,   836,     0,     0,  1325,  1326,   -12,     0,
       0,     0,     0,     0,     0,     0,     0,  1009,     0,    44,
     823,     0,  1327,   508,     0,     0,     0,     0,     0,     0,
       0,     0,   -12,   -12,   -12,   837,   838,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   824,
       0,     0,   -12,   825,   826,     0,     0,     0,   827,   828,
     829,     0,   830,   839,     0,   831,     0,   840,  1010,     0,
       0,     0,     0,     0,     0,     0,     0,   832,   833,   834,
     835,     0,     0,     0,   836,     0,     0,   517,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    53,     0,
       0,    54,    55,     0,    56,    57,    58,    59,    60,    61,
       0,    62,    63,     0,     0,     0,   837,   838,     0,     0,
      64,    65,     0,     0,     0,    66,     0,     0,    67,    68,
      69,    70,     0,     0,    71,    72,    73,    74,     0,    75,
      76,     0,     0,     0,   839,    77,    78,    79,   840,     0,
      80,    81,  1022,     0,    44,   823,     0,    82,     0,     0,
       0,     0,     0,     0,     0,    83,    84,    85,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   841,     0,
     842,     0,     0,   843,   824,     0,     0,     0,   825,   826,
       0,     0,     0,   827,   828,   829,     0,   830,     0,     0,
     831,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   832,   833,   834,   835,     0,     0,     0,   836,
       0,     0,     0,     0,     0,  1023,   822,     0,    44,   823,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1011,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   837,   838,     0,     0,     0,     0,     0,   824,   841,
       0,   842,   825,   826,   843,     0,     0,   827,   828,   829,
     822,   830,    44,   823,   831,     0,     0,     0,     0,   839,
       0,     0,     0,   840,     0,     0,   832,   833,   834,   835,
       0,     0,     0,   836,     0,     0,     0,     0,     0,     0,
       0,     0,   824,     0,     0,     0,   825,   826,     0,     0,
       0,   827,   828,   829,     0,   830,     0,     0,   831,     0,
       0,     0,     0,     0,     0,   837,   838,     0,     0,     0,
     832,   833,   834,   835,     0,     0,     0,   836,     0,     0,
       0,     0,     0,  1695,     0,   822,     0,    44,   823,     0,
       0,     0,     0,   839,     0,     0,     0,   840,     0,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,   837,
     838,     0,     0,   154,     0,     0,  1024,   824,   157,   158,
     159,   825,   826,     0,     0,     0,   827,   828,   829,     0,
     830,     0,     0,   831,   841,     0,   842,   839,     0,   843,
       0,   840,     0,     0,     0,   832,   833,   834,   835,     0,
       0,     0,   836,     0,    44,    45,    46,     0,     0,    47,
      48,    49,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    50,    51,    52,   837,   838,     0,     0,     0,     0,
    1615,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1037,     0,   841,     0,
     842,     0,   839,   843,     0,     0,   840,   720,   721,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,     0,
       0,   312,   313,   154,     0,     0,   155,   156,   157,   158,
     159,     0,     0,   722,   723,     0,     0,     0,     0,     0,
       0,     0,   841,     0,   842,     0,     0,   843,     0,     0,
       0,     0,   724,   725,   726,   727,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   728,   729,     0,    44,    45,    46,     0,     0,    47,
      48,    49,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    50,    51,    52,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,   841,     0,   842,
      53,     0,   843,    54,    55,     0,    56,    57,    58,    59,
      60,    61,     0,    62,    63,     0,     0,     0,     0,     0,
       0,     0,    64,    65,     0,     0,     0,    66,     0,     0,
      67,    68,    69,    70,     0,     0,    71,    72,    73,    74,
       0,    75,    76,   722,   723,     0,     0,    77,    78,    79,
       0,     0,    80,    81,     0,     0,     0,     0,     0,    82,
       0,     0,   724,   725,   726,   727,     0,    83,    84,    85,
       0,     0,    44,    45,    46,     0,     0,    47,    48,    49,
       0,   728,   729,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    50,
      51,    52,   160,   314,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   315,
      53,     0,     0,    54,    55,     0,    56,    57,    58,    59,
      60,    61,     0,    62,    63,     0,     0,     0,     0,     0,
       0,     0,    64,    65,     0,     0,     0,    66,     0,     0,
      67,    68,    69,    70,     0,     0,    71,    72,    73,    74,
    1216,    75,    76,     0,     0,     0,     0,    77,    78,    79,
       0,     0,    80,    81,     0,    44,    45,    46,     0,    82,
      47,    48,    49,     0,     0,     0,     0,    83,    84,    85,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    50,    51,    52,     0,     0,     0,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
       0,     0,     0,     0,     0,     0,     0,     0,    53,     0,
       0,    54,    55,     0,    56,    57,    58,    59,    60,    61,
       0,    62,    63,     0,     0,     0,     0,     0,     0,     0,
      64,    65,     0,     0,     0,    66,     0,     0,    67,    68,
      69,    70,     0,  1221,    71,    72,    73,    74,     0,    75,
      76,     0,     0,     0,     0,    77,    78,    79,     0,     0,
      80,    81,     0,    44,    45,    46,     0,    82,    47,    48,
      49,     0,   841,     0,  1217,    83,    84,    85,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      50,    51,    52,     0,     0,     0,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,  1262,     0,     0,
     154,     0,     0,  1402,   156,   157,   158,   159,     0,     0,
       0,    53,     0,     0,    54,    55,     0,    56,    57,    58,
      59,    60,    61,     0,    62,    63,     0,     0,     0,     0,
       0,     0,     0,    64,    65,     0,     0,     0,    66,     0,
       0,    67,    68,    69,    70,     0,     0,    71,    72,    73,
      74,     0,    75,    76,     0,     0,     0,     0,    77,    78,
      79,     0,     0,    80,    81,     0,     0,    44,    45,    46,
      82,     0,    47,    48,    49,   841,     0,  1217,    83,    84,
      85,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,    50,    51,    52,   145,   146,     0,
     147,   148,   149,   150,   151,   152,   153,     0,   417,     0,
       0,   154,     0,     0,     0,     0,   157,   158,   159,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    53,
       0,     0,    54,    55,     0,    56,    57,    58,    59,    60,
      61,     0,    62,    63,  1206,     0,     0,     0,     0,     0,
       0,    64,    65,     0,  1207,     0,    66,     0,     0,    67,
      68,    69,    70,     0,     0,    71,    72,    73,    74,     0,
      75,    76,     0,     0,     0,     0,    77,    78,    79,     0,
       0,    80,    81,     0,    44,    45,    46,     0,    82,    47,
      48,    49,     0,     0,     0,     0,    83,    84,    85,     0,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,    50,    51,    52,     0,     0,     0,   145,   146,     0,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,     0,
       0,     0,     0,    53,     0,     0,    54,    55,     0,    56,
      57,    58,    59,    60,    61,     0,    62,    63,     0,     0,
       0,     0,     0,     0,     0,    64,    65,     0,     0,     0,
      66,     0,     0,    67,    68,    69,    70,     0,     0,    71,
      72,    73,    74,     0,    75,    76,     0,     0,     0,     0,
      77,    78,    79,     0,     0,    80,    81,     0,    44,    45,
      46,     0,    82,    47,    48,    49,     0,     0,     0,     0,
      83,    84,    85,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,    50,    51,    52,     0,     0,
       0,   145,   146,     0,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,     0,     0,   155,   156,
     157,   158,   159,     0,     0,     0,     0,     0,     0,     0,
      53,     0,     0,    54,    55,     0,    56,    57,    58,    59,
      60,    61,     0,    62,    63,     0,     0,     0,     0,     0,
       0,     0,    64,    65,     0,     0,     0,    66,     0,     0,
      67,    68,    69,    70,     0,     0,    71,    72,    73,    74,
       0,    75,    76,     0,     0,     0,     0,    77,    78,    79,
       0,     0,    80,    81,     0,    44,    45,    46,     0,    82,
      47,    48,    49,   194,     0,     0,     0,    83,    84,    85,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    50,    51,    52,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   418,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    53,     0,     0,    54,    55,     0,
      56,    57,    58,    59,    60,    61,     0,    62,    63,     0,
       0,     0,     0,     0,     0,     0,    64,    65,     0,     0,
       0,    66,     0,     0,    67,    68,    69,    70,     0,     0,
      71,    72,    73,    74,     0,    75,    76,     0,     0,     0,
       0,    77,    78,    79,     0,     0,    80,    81,     0,    44,
      45,    46,     0,    82,    47,    48,    49,   255,     0,     0,
       0,    83,    84,    85,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,    50,    51,    52,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   703,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    53,     0,     0,    54,    55,     0,    56,    57,    58,
      59,    60,    61,     0,    62,    63,     0,     0,     0,     0,
       0,     0,     0,    64,    65,     0,     0,     0,    66,     0,
    1082,    67,    68,    69,    70,     0,     0,    71,    72,    73,
      74,     0,    75,    76,     0,     0,     0,     0,    77,    78,
      79,     0,     0,  1083,  1084,     0,    44,    45,    46,     0,
      82,    47,    48,    49,     0,     0,     0,     0,    83,    84,
      85,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    50,    51,    52,     0,     0,     0,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,     0,     0,     0,     0,    53,     0,     0,    54,    55,
       0,    56,    57,    58,    59,    60,    61,     0,    62,    63,
       0,     0,     0,     0,     0,     0,     0,    64,    65,     0,
       0,     0,    66,     0,     0,    67,    68,    69,    70,     0,
       0,    71,    72,    73,    74,     0,    75,    76,     0,     0,
       0,     0,    77,    78,    79,     0,     0,    80,    81,     0,
      44,    45,    46,     0,    82,    47,    48,    49,     0,     0,
    1170,     0,    83,    84,    85,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    50,    51,    52,
       0,     0,     0,   145,   146,     0,   147,   148,   149,   150,
     151,   152,   153,     0,  1262,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,     0,     0,     0,     0,     0,
       0,     0,    53,     0,     0,    54,    55,     0,    56,    57,
      58,    59,    60,    61,     0,    62,    63,     0,     0,     0,
       0,     0,     0,     0,    64,    65,     0,     0,     0,    66,
       0,     0,    67,    68,    69,    70,     0,     0,    71,    72,
      73,    74,     0,    75,    76,     0,     0,     0,     0,    77,
      78,    79,     0,     0,    80,    81,     0,    44,    45,    46,
       0,    82,    47,    48,    49,  1214,     0,     0,     0,    83,
      84,    85,   160,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    50,    51,    52,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   710,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    53,     0,     0,    54,
      55,     0,    56,    57,    58,    59,    60,    61,     0,    62,
      63,     0,     0,     0,     0,     0,     0,     0,    64,    65,
       0,     0,     0,    66,     0,     0,    67,    68,    69,    70,
       0,     0,    71,    72,    73,    74,     0,    75,    76,     0,
       0,     0,     0,    77,    78,    79,     0,     0,    80,    81,
       0,    44,    45,    46,     0,    82,    47,    48,    49,     0,
       0,     0,     0,    83,    84,    85,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    50,    51,
      52,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1632,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    53,     0,     0,    54,    55,     0,    56,
      57,    58,    59,    60,    61,     0,    62,    63,     0,     0,
       0,     0,     0,     0,     0,    64,    65,     0,     0,     0,
      66,     0,     0,    67,    68,    69,    70,     0,     0,    71,
      72,    73,    74,     0,    75,    76,     0,     0,     0,     0,
      77,    78,    79,     0,     0,    80,    81,     0,    44,    45,
      46,     0,    82,    47,    48,    49,  1609,     0,     0,     0,
      83,    84,    85,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    50,    51,    52,     0,     0,
       0,   145,   146,     0,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,     0,     0,   155,   156,
     157,   158,   159,     0,     0,     0,     0,    53,     0,     0,
      54,    55,     0,    56,    57,    58,    59,    60,    61,     0,
      62,    63,     0,     0,     0,     0,     0,     0,     0,    64,
      65,     0,     0,     0,    66,     0,     0,    67,    68,    69,
      70,     0,     0,    71,    72,    73,    74,     0,    75,    76,
       0,     0,     0,     0,    77,    78,    79,     0,     0,    80,
      81,     0,    44,    45,    46,     0,    82,    47,    48,    49,
       0,     0,     0,     0,    83,    84,    85,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    50,
      51,    52,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    44,    45,    46,     0,     0,    47,    48,
      49,     0,     0,     0,    53,     0,     0,    54,    55,     0,
      56,    57,    58,    59,    60,    61,     0,    62,    63,     0,
       0,     0,     0,     0,     0,     0,    64,    65,     0,     0,
       0,    66,     0,     0,    67,    68,    69,    70,     0,     0,
      71,    72,    73,    74,     0,    75,    76,     0,     0,     0,
       0,    77,    78,    79,     0,     0,    80,    81,     0,     0,
      44,    45,    46,  1129,     0,    47,    48,    49,     0,     0,
       0,    83,    84,    85,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1700,     0,    44,    45,    46,     0,   951,    47,    48,
      49,     0,     0,     0,     0,     0,     0,     0,    53,     0,
       0,    54,    55,     0,    56,    57,    58,    59,    60,    61,
       0,    62,    63,     0,     0,     0,     0,   952,     0,     0,
      64,    65,     0,     0,     0,    66,     0,   953,    67,    68,
      69,    70,     0,     0,    71,    72,    73,    74,     0,    75,
      76,     0,     0,     0,     0,    77,    78,    79,     0,    53,
      80,    81,    54,    55,     0,    56,    57,    58,    59,    60,
      61,     0,    62,    63,     0,    83,    84,    85,    44,    45,
      46,    64,    65,    47,    48,    49,    66,     0,     0,    67,
      68,    69,    70,     0,     0,    71,    72,    73,    74,     0,
      75,    76,     0,     0,     0,     0,   137,   138,   139,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    82,     0,
       0,     0,     0,     0,     0,     0,    53,     0,    85,    54,
      55,     0,    56,    57,    58,    59,    60,    61,     0,    62,
      63,     0,     0,     0,     0,    44,    45,    46,    64,    65,
      47,    48,    49,    66,     0,     0,    67,    68,    69,    70,
       0,     0,    71,    72,    73,    74,     0,    75,    76,    53,
       0,     0,    54,    55,     0,    56,    57,    58,    59,    60,
      61,     0,    62,    63,     0,    82,     0,     0,     0,     0,
       0,    64,    65,     0,     0,    85,    66,     0,  1247,    67,
      68,    69,    70,     0,     0,    71,    72,    73,    74,     0,
      75,    76,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    82,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    85,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    53,     0,     0,    54,    55,     0,
      56,    57,    58,    59,    60,    61,     0,    62,    63,     0,
       0,     0,     0,     0,     0,     0,    64,    65,     0,     0,
       0,    66,     0,  1248,    67,    68,    69,    70,     0,     0,
      71,    72,    73,    74,     0,    75,    76,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    82,     0,     0,     0,     0,     0,     0,
       0,    53,     0,    85,    54,    55,     0,    56,    57,    58,
      59,    60,    61,     0,    62,    63,     0,     0,     0,     0,
       0,     0,     0,    64,    65,     0,     0,     0,    66,     0,
       0,    67,    68,    69,    70,     0,     0,    71,    72,    73,
      74,     0,    75,    76,   495,     0,   -12,   145,   146,   496,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
      82,   154,     0,     0,   155,   156,   157,   158,   159,     1,
      85,     0,     0,     0,     0,     0,     0,     0,   -12,   -12,
     497,   679,   -12,   -12,   -12,   498,     0,     0,   -12,     0,
       0,   499,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   500,   501,     0,     0,     0,   502,     0,
       0,   503,     0,   -12,   504,   505,   -12,     0,     0,     0,
       0,   506,   -12,     0,   -12,   -12,   -12,   -12,   -12,   -12,
     507,   508,   -12,     0,     0,     0,     0,   509,   510,   -12,
     -12,   -12,   -12,     0,     0,   -12,   -12,   -12,   -12,   -12,
       0,     0,   511,     0,     0,     0,   -12,   -12,     0,   512,
     -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   513,
       0,     0,   -12,     0,     0,     0,   -12,   -12,   -12,   -12,
       0,     0,     0,     0,     0,     0,     0,     0,   514,     0,
       0,     0,     0,   515,   516,   517,     0,     0,     0,     0,
       0,   145,   146,     0,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,   -12,   -12,   155,   156,
     157,   158,   159,  1429,     0,     0,     0,   -12,     0,     0,
       0,   145,   146,     0,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,     0,     0,   155,   156,
     157,   158,   159,     0,     0,     0,     0,     0,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,     0,     0,   283,     0,
       0,     0,   145,   146,   680,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   226,     0,
       0,     0,     0,     0,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,   145,   146,  1430,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,     0,   284,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,     0,   285,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,     0,   286,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,     0,   287,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
       0,   288,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,   145,   146,   290,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,     0,     0,   155,   156,
     157,   158,   159,   145,   146,     0,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,     0,     0,     0,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,   145,   146,   291,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,     0,     0,     0,
       0,     0,   292,     0,     0,     0,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,   145,   146,   293,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,     0,     0,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,     0,   294,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,     0,   295,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
       0,   297,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,     0,   298,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,     0,   302,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,   145,   146,   303,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,   145,   146,     0,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,   145,   146,   304,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,     0,     0,   155,   156,
     157,   158,   159,   145,   146,     0,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,   145,   146,     0,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,   145,   146,     0,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,   145,   146,     0,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,     0,     0,   155,   156,
     157,   158,   159,     0,     0,     0,     0,     0,   160,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,     0,     0,   305,     0,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,   145,   146,   306,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,     0,     0,     0,
       0,     0,   408,     0,     0,     0,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,     0,     0,   409,     0,     0,     0,   160,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,     0,     0,   410,     0,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,     0,     0,   411,     0,
       0,     0,   160,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,     0,     0,
     412,     0,     0,     0,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,     0,     0,     0,
     145,   146,   917,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,     0,     0,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,   145,   146,   923,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,   145,   146,     0,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,   145,   146,     0,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,     0,     0,   155,   156,
     157,   158,   159,   145,   146,     0,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,   145,   146,     0,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
       0,  1127,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,   145,   146,  1346,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,     0,     0,   155,   156,
     157,   158,   159,     0,     0,     0,     0,     0,   160,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,     0,     0,  1347,     0,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,     0,     0,  1348,     0,
       0,     0,   160,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,     0,     0,
    1354,     0,     0,     0,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,     0,     0,     0,
       0,     0,  1355,     0,     0,     0,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,     0,     0,  1356,     0,     0,     0,   160,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,   145,   146,  1358,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,     0,     0,     0,
     145,   146,  1546,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,     0,     0,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,     0,  1630,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,   145,   146,  1631,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
       0,  1650,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,     0,  1687,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,     0,  1720,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,     0,  1721,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,     0,  1747,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,   145,
     146,  1748,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,   145,   146,     0,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,     0,     0,   155,   156,
     157,   158,   159,     0,     0,     0,     0,     0,   160,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,   145,   146,  1760,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   160,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,     0,     0,
    1780,     0,     0,     0,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,     0,     0,     0,
     145,   146,  1781,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,     0,     0,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,  1090,     0,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,  1266,     0,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,  1341,     0,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
    1342,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,  1374,     0,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,   145,   146,  1378,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,   145,   146,
    1385,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
       0,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,  1487,     0,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,   145,   146,  1502,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,  1515,     0,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
    1516,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,  1518,     0,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,  1519,     0,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,  1540,     0,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,   145,   146,  1625,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
       0,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
     145,   146,  1731,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   528,   886,     0,     0,     0,  1758,     0,   529,     0,
     530,   160,   531,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,  1759,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,     0,
       0,     0,     0,   160,   221,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,  1422,     0,
       0,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
     289,     0,     0,     0,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,   296,     0,     0,     0,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,   299,     0,     0,     0,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,   495,   300,   -12,     0,     0,
     496,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,   301,     0,
       1,     0,     0,     0,     0,     0,     0,     0,     0,   -12,
     -12,   497,     0,   -12,   -12,   -12,   498,     0,     0,   -12,
       0,     0,   499,     0,     0,     0,  -391,     0,     0,     0,
       0,     0,     0,     0,   500,   501,     0,     0,     0,   502,
       0,     0,   503,     0,   -12,   504,   505,   -12,     0,     0,
       0,     0,   506,   -12,     0,   -12,   -12,   -12,   -12,   -12,
     -12,   507,   508,   -12,     0,     0,     0,     0,   509,   510,
     -12,   -12,   -12,   -12,     0,     0,   -12,   -12,   -12,   -12,
     -12,     0,     0,   511,     0,     0,     0,   -12,   -12,     0,
     512,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,
     513,     0,     0,   -12,     0,     0,     0,   -12,   -12,   -12,
     -12,     0,     0,     0,     0,     0,     0,     0,     0,   514,
       0,     0,     0,     0,   515,   516,   517,     0,     0,     0,
       0,   495,     0,   -12,     0,     0,   496,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   -12,   -12,     0,
       0,     0,     0,     0,     0,     0,     1,     0,   -12,     0,
       0,     0,     0,     0,     0,   -12,   -12,   497,     0,   -12,
     -12,   -12,   498,     0,     0,   -12,     0,     0,   499,     0,
       0,     0,  -391,     0,     0,     0,     0,     0,     0,     0,
     500,   501,     0,     0,     0,   502,     0,     0,   503,   812,
     -12,   504,   505,   -12,     0,     0,     0,     0,   506,   -12,
       0,   -12,   -12,   -12,   -12,   -12,   -12,   507,   508,   -12,
       0,     0,     0,     0,   509,   510,   -12,   -12,   -12,   -12,
       0,     0,   -12,   -12,   -12,   -12,   -12,     0,     0,   511,
       0,     0,     0,   -12,   -12,     0,   512,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   -12,   -12,   513,     0,     0,   -12,
       0,     0,     0,   -12,   -12,   -12,   -12,     0,     0,     0,
       0,     0,     0,     0,     0,   514,     0,     0,     0,     0,
     515,   516,   517,     0,     0,     0,     0,     0,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,   -12,   -12,   155,   156,   157,   158,   159,
       0,     0,   145,   146,   -12,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,     0,     0,     0,     0,     0,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,   879,   155,   156,   157,   158,
     159,   145,   146,     0,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,     0,     0,   155,   156,
     157,   158,   159,   145,   146,     0,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,   145,   146,     0,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,   145,   146,     0,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,     0,     0,     0,     0,     0,     0,   704,     0,   145,
     146,   705,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   160,   221,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   160,   310,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   160,   354,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   160,   480,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   160,  1259,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     160,  1288,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   160,  1379,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   160,  1521,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,   528,     0,   155,   156,   157,   158,   159,
     529,   887,   530,     0,   531,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   888,   889,   890,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     528,     0,     0,     0,     0,     0,     0,   529,     0,   530,
       0,   531,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   160,  1537,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   160,
    1551,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   495,     0,   -12,     0,     0,   496,     0,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     1,     0,     0,     0,
       0,     0,     0,     0,     0,   -12,   -12,   497,     0,   -12,
     -12,   -12,   498,     0,     0,   -12,     0,     0,   499,     0,
       0,     0,  -390,     0,     0,  -390,     0,     0,     0,     0,
     500,   501,     0,     0,     0,   502,     0,     0,   503,     0,
     -12,   504,   505,   -12,     0,     0,     0,     0,   506,   -12,
       0,   -12,   -12,   -12,   -12,   -12,   -12,   507,   508,   -12,
       0,     0,     0,     0,   509,   510,   -12,   -12,   -12,   -12,
       0,     0,   -12,   -12,   -12,   -12,   -12,     0,     0,   511,
       0,     0,     0,   -12,   -12,     0,   512,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   -12,   -12,   513,     0,     0,   -12,
       0,     0,     0,   -12,   -12,   -12,   -12,     0,     0,     0,
       0,   495,     0,   -12,     0,   514,   496,     0,     0,  -390,
     515,   516,   517,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     1,     0,     0,     0,
       0,     0,     0,   -12,   -12,   -12,   -12,   497,   638,   -12,
     -12,   -12,   498,     0,   -12,   -12,     0,     0,   499,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     500,   501,     0,     0,     0,   502,     0,     0,   503,     0,
     -12,   504,   505,   -12,     0,     0,     0,     0,   506,   -12,
       0,   -12,   -12,   -12,   -12,   -12,   -12,   507,   508,   -12,
       0,     0,     0,     0,   509,   510,   -12,   -12,   -12,   -12,
       0,     0,   -12,   -12,   -12,   -12,   -12,     0,     0,   511,
       0,     0,     0,   -12,   -12,     0,   512,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   -12,   -12,   513,     0,     0,   -12,
       0,     0,     0,   -12,   -12,   -12,   -12,     0,     0,     0,
       0,   495,     0,   -12,     0,   514,   496,     0,     0,  -391,
     515,   516,   517,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     1,     0,     0,     0,
       0,     0,     0,   -12,   -12,   -12,   -12,   497,     0,   -12,
     -12,   -12,   498,     0,   -12,   -12,     0,     0,   499,     0,
       0,     0,     0,     0,     0,  -391,     0,     0,     0,     0,
     500,   501,     0,     0,     0,   502,     0,     0,   503,     0,
     -12,   504,   505,   -12,     0,     0,     0,     0,   506,   -12,
       0,   -12,   -12,   -12,   -12,   -12,   -12,   507,   508,   -12,
       0,     0,     0,     0,   509,   510,   -12,   -12,   -12,   -12,
       0,     0,   -12,   -12,   -12,   -12,   -12,     0,     0,   511,
       0,     0,     0,   -12,   -12,     0,   512,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   -12,   -12,   513,     0,     0,   -12,
       0,     0,     0,   -12,   -12,   -12,   -12,     0,     0,     0,
       0,   495,     0,   -12,     0,   514,   496,     0,     0,     0,
     515,   516,   517,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     1,     0,     0,     0,
       0,     0,     0,   -12,   -12,   -12,   -12,   497,     0,   -12,
     -12,   -12,   498,     0,   -12,   -12,     0,     0,   499,     0,
       0,     0,  -391,     0,     0,     0,     0,     0,     0,     0,
     500,   501,     0,     0,     0,   502,     0,     0,   503,     0,
     -12,   504,   505,   -12,     0,     0,     0,     0,   506,   -12,
       0,   -12,   -12,   -12,   -12,   -12,   -12,   507,   508,   -12,
       0,     0,     0,     0,   509,   510,   -12,   -12,   -12,   -12,
       0,     0,   -12,   -12,   -12,   -12,   -12,     0,     0,   511,
       0,     0,     0,   -12,   -12,     0,   512,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   -12,   -12,   513,     0,     0,   -12,
       0,     0,     0,   -12,   -12,   -12,   -12,     0,     0,     0,
       0,   495,     0,   -12,     0,   514,   496,     0,     0,     0,
     515,   516,   517,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     1,     0,     0,     0,
       0,     0,     0,   -12,   -12,   -12,   -12,   497,   679,   -12,
     -12,   -12,   498,     0,   -12,   -12,     0,     0,   499,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     500,   501,     0,     0,     0,   502,     0,     0,   503,     0,
     -12,   504,   505,   -12,     0,     0,     0,     0,   506,   -12,
       0,   -12,   -12,   -12,   -12,   -12,   -12,   507,   508,   -12,
       0,     0,     0,     0,   509,   510,   -12,   -12,   -12,   -12,
       0,     0,   -12,   -12,   -12,   -12,   -12,     0,     0,   511,
       0,   643,     0,   -12,   -12,     0,   512,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   -12,   -12,   513,     0,     0,   -12,
       0,     0,     0,   -12,   -12,   -12,   -12,     0,     0,     0,
       0,     0,     0,   644,   645,   514,     0,   646,   647,   648,
     515,   516,   517,   649,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   -12,   -12,     0,     0,     0,   650,     0,
       0,   651,     0,     0,   -12,     0,     0,   652,     0,   653,
     654,   655,   656,   657,   658,     0,     0,   659,     0,     0,
       0,     0,     0,     0,   660,   661,   662,   663,     0,     0,
     664,   665,   666,   667,   668,     0,     0,     0,     0,     0,
       0,   443,   444,     0,     0,   669,   670,   671,   672,   445,
     446,   447,   448,   449,     0,     0,     0,   450,     0,     0,
       0,   451,   452,   673,   674,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   453,   454,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   675
};

static const yytype_int16 yycheck[] =
{
      32,   521,   522,  1074,   669,     0,   608,   619,   620,   621,
     644,   392,   608,     8,   626,   676,   650,   899,    85,   515,
     600,   510,     1,   603,  1043,  1044,   809,     1,   556,     3,
       3,     3,   758,   100,    11,    27,   600,     3,     3,   603,
     586,     3,     1,  1268,     3,  1352,   335,    27,     3,   734,
      82,   676,   677,    85,    53,     3,  1040,    53,   491,   492,
     493,     1,     1,     3,     3,     3,   238,     1,   100,     3,
       3,  1162,     3,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,     3,   387,   882,
       3,   482,     3,     3,   171,   240,   241,     7,     1,     3,
     911,     3,     3,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     825,   173,   638,    25,  1451,   830,   238,   436,   833,   376,
       3,   457,   837,   459,   460,     1,    53,     3,   250,   226,
     496,     3,     1,    97,   500,   693,     1,   695,   696,     3,
       3,     3,     3,     3,     9,    10,     3,  1268,     9,    10,
     516,  1406,     3,   679,    72,   797,     3,   676,   677,   221,
     736,     3,   826,    27,   226,   227,    26,    88,     3,    87,
     834,   835,    11,   636,    11,    50,    51,    52,   934,     3,
     499,    99,   146,   147,    26,     9,    10,   598,   524,   508,
    1204,   239,    27,   157,    23,    24,   225,    73,   517,   225,
    1031,   249,    77,    78,    79,    80,    81,     3,    83,    84,
     272,  1332,  1448,     9,    10,    52,     3,   239,   873,     3,
     238,    97,    98,   686,  1345,     9,    10,   289,    11,   239,
      86,  1352,   250,   240,   296,    74,    87,   299,   300,   301,
     249,   117,   499,   999,   248,   241,   248,   250,   310,  1005,
     312,   313,   314,   248,   316,   280,  1593,   593,   594,   248,
     596,     0,   137,   138,   139,   250,   244,   238,   238,   238,
     248,   239,   591,   243,     1,   238,     3,   238,   248,   250,
     599,   157,   243,     3,    97,  1406,   250,    26,   751,   752,
     242,   754,   354,    47,   904,     1,   906,     3,   225,   251,
      87,   239,   821,   241,  1019,   241,   339,   238,   241,  1140,
    1647,   905,   243,   907,  1145,   238,   238,   241,   241,  1333,
     851,   233,   234,   235,   855,   935,   388,   225,   886,   586,
    1451,   941,   394,   146,   147,  1571,  1572,  1249,  1250,  1353,
    1354,   239,  1356,   937,    25,   225,    73,   374,   942,  1013,
     233,   687,    91,   872,   873,   238,   802,   876,   804,   239,
     200,  1025,     8,     9,   204,  1060,   238,    73,  1489,   238,
      97,    98,   241,   238,   250,   238,   238,   238,   403,   239,
    1071,   238,   242,   239,   244,  1100,   242,   644,   248,   436,
     117,    97,    98,   650,     0,   841,   225,   239,     3,   241,
     242,   240,   241,   240,   241,   238,   145,   440,   441,   163,
     239,   117,   166,   239,   238,   169,    26,   936,   480,   481,
     883,   148,   484,   249,   943,   164,  1257,  1240,   747,    76,
     157,    78,   239,     3,   778,   779,   780,   781,   782,   783,
     784,     3,   238,     1,   251,     3,   790,   791,   792,   793,
     477,   157,   479,   486,   238,   240,   195,   240,   241,    11,
      12,   508,    14,    15,    16,    17,    18,    19,    20,   244,
     517,     0,  1593,    25,   213,   250,   238,   734,  1492,   736,
     239,    75,   244,    77,  1315,    18,    19,    20,   250,   242,
     249,   170,    25,   172,    26,  1127,  1510,    26,   251,    11,
      12,  1127,    14,    15,    16,    17,    18,    19,    20,    71,
      72,  1153,  1154,    25,   108,   241,   927,   240,    30,   241,
     582,   244,    80,   250,  1074,    87,  1647,   250,    60,   865,
     592,    70,    90,    72,   241,   239,  1231,   244,   600,    71,
      72,   603,   878,   250,   250,   249,  1072,  1066,    87,    13,
     231,   232,   233,   234,   235,    87,    88,    21,   924,   925,
      99,   170,    91,   172,  1578,   244,   197,   824,   825,   826,
     191,   250,   203,   830,   831,   196,   833,   834,   835,     3,
     837,  1630,  1631,   214,  1555,   842,    13,   844,     3,  1560,
    1561,    67,  1563,  1564,    21,   239,  1427,  1428,  1569,  1570,
    1614,  1615,  1433,  1434,  1435,  1436,  1620,     8,  1071,  1440,
    1441,  1442,  1443,  1627,  1628,   165,   145,    93,    71,    72,
     152,   240,   988,   240,   197,   198,   518,   239,    66,   240,
     203,   250,   524,   250,    87,   164,   112,   249,   114,   250,
    1166,   214,   704,   239,    11,    12,   242,    14,    15,    16,
      17,    18,    19,    20,    92,   131,   718,   239,    25,  1673,
     242,    28,    29,    30,    31,    32,   195,   238,   232,  1311,
    1771,  1313,   239,   111,   241,   113,   738,   229,   230,   231,
     232,   233,   234,   235,   213,  1349,    66,    67,   252,   253,
     254,  1355,   130,  1357,  1358,   239,   758,   241,   231,   232,
     233,   234,   235,    73,  1535,    73,   231,   232,   770,  1075,
    1076,   238,    92,    93,   239,   238,   228,   229,   230,   231,
     232,   233,   234,   235,   238,   180,   181,    97,    98,    97,
      98,   111,   112,   113,   114,  1347,  1348,  1708,    93,   194,
    1711,  1060,  1406,  1714,  1715,   238,   843,   117,    73,   117,
     130,   131,   207,    71,    72,  1494,  1013,   112,  1497,   114,
    1499,  1280,  1019,  1282,  1283,  1284,   238,   222,  1025,    87,
    1043,  1044,    97,    98,    99,   238,   131,    11,    12,   241,
     238,   843,   244,  1040,    18,    19,    20,   157,   250,   157,
      73,    25,   117,   239,  1138,  1139,   242,  1141,  1142,  1143,
    1144,   238,  1444,  1445,  1148,  1149,  1150,  1151,   239,   871,
     241,   242,   238,   875,    97,    98,    99,   239,   238,   241,
     845,   239,  1653,   241,   242,   239,   238,  1658,   242,    73,
    1661,  1662,  1365,  1366,   117,   238,   898,   899,   241,   901,
     238,   244,     1,  1100,     3,     4,     5,   250,   238,     8,
       9,    10,   238,    97,    98,    99,    92,   224,   920,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   180,
     181,    99,   934,   117,   238,   111,   938,   113,   504,   505,
     250,   507,   250,   194,   251,   947,   948,   238,   199,   239,
     952,   953,   242,   238,   130,   239,   207,   241,   242,    99,
     399,   400,   777,   778,   779,   780,   781,   782,   783,   784,
     239,   222,   241,   113,   114,   790,   791,   792,   793,  1538,
    1539,   121,   122,   123,   124,   125,   239,   239,   241,   129,
     242,   993,    73,   133,   134,   239,   239,   999,   242,   242,
    1002,  1003,   238,  1005,  1041,  1321,  1322,  1204,  1612,  1325,
    1326,  1327,  1014,  1015,  1016,     5,    97,    98,    99,     1,
    1217,     3,  1626,   239,  1026,   241,  1028,  1029,  1030,     1,
     238,     3,  1034,   173,   174,   239,   117,   238,   242,  1041,
     241,  1043,  1044,   239,  1046,  1047,   242,   239,  1538,  1539,
     242,  1053,     1,   238,     3,   229,   230,   231,   232,   233,
     234,   235,  1064,   243,   239,  1102,   239,   242,  1033,   242,
     553,   554,  1320,  1321,  1322,  1730,  1731,  1325,  1326,  1327,
     179,   242,   239,   182,   183,   242,   185,   186,   187,   188,
     189,   190,   239,   192,   193,   242,     1,  1099,     3,    73,
    1102,  1705,   201,   202,     3,   239,    73,   206,   242,   238,
     209,   210,   211,   212,   238,   238,   215,   216,   217,   218,
     238,   220,   221,    97,    98,    99,     1,  1129,     3,    73,
      97,    98,    99,     3,   241,  1137,  1333,   952,   953,   238,
       3,   239,   239,   117,   242,   242,   239,     3,   963,   248,
     117,     3,  1349,    97,    98,    99,  1353,  1354,  1355,  1356,
    1357,  1358,  1468,  1469,  1470,  1769,  1472,  1473,  1474,   240,
    1476,  1477,  1478,   117,   240,   240,  1780,  1781,  1180,  1582,
    1456,   240,   239,  1586,  1460,   242,   239,  1590,  1464,   242,
    1192,   240,    25,   239,  1597,  1471,   242,  1162,  1601,  1475,
     238,   238,  1605,  1479,  1206,  1207,   240,   239,   239,  1406,
     242,   242,   239,     5,   244,   242,  1218,  1219,   241,   239,
    1222,  1223,   242,   241,   239,  1227,   241,  1264,   239,   239,
     241,   241,   239,  1430,   241,    11,    12,   241,    14,    15,
      16,    17,    18,    19,    20,   241,     3,  1249,  1250,    25,
       3,     3,    28,    29,    30,    31,    32,  1259,   239,    26,
     241,   239,  1264,   241,  1266,     1,     5,     3,  1083,  1084,
    1272,    26,    88,  1275,   239,   239,   241,   241,   239,   239,
     241,  1771,   239,   239,   241,   241,  1288,   239,     3,   241,
    1292,  1293,   239,    60,   241,  1492,   239,   239,   241,   241,
     239,     3,   241,  1268,    71,    72,    73,   239,   239,   241,
     241,     3,   239,  1510,   241,   239,   239,   241,   241,   241,
      87,    88,   242,  1138,  1139,   241,  1141,  1142,  1143,  1144,
      97,    98,    99,  1148,  1149,  1150,  1151,   239,   239,   241,
     241,   239,   250,   241,  1346,  1347,  1348,   239,  1350,   241,
     117,   239,   241,   241,    26,   239,   239,   241,   241,   239,
     241,   241,  1559,  1365,  1366,     3,     3,  1332,  1370,  1371,
     239,  1677,   241,  1375,   239,  1681,   241,  1379,     3,  1685,
    1345,  1578,   113,   114,   239,   152,   241,  1352,    60,    72,
     121,   122,   123,   124,   125,   239,   241,   241,   129,  1364,
     241,    73,   133,   134,   239,   239,   241,   241,   239,   239,
     241,   241,   239,   241,   241,  1612,    88,  1614,  1615,   239,
    1422,   241,   239,  1620,   241,    97,    98,    99,     3,  1626,
    1627,  1628,   239,     3,   241,  1437,   239,   239,   241,   241,
     115,  1406,   173,   174,   239,   117,   241,   170,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     239,   239,   241,   241,   239,   239,   241,   241,     3,     3,
       1,     3,     3,     4,     5,   251,  1673,     8,     9,    10,
     152,   476,  1484,   478,   250,    73,  1451,   238,   249,  1304,
       3,     3,  1494,   241,   240,  1497,    56,  1499,   240,   157,
       3,   251,   242,    72,   241,   240,   238,   241,  1705,    11,
      12,   238,    14,    15,    16,    17,    18,    19,    20,  1521,
     238,    99,  1524,    25,  1489,     1,    28,    29,    30,    31,
      32,   148,   238,  1730,  1731,  1537,   113,   114,   238,    55,
       3,    58,  1544,   241,   121,   122,   123,   124,   125,  1551,
       3,   225,   129,     3,     3,     3,   133,   134,     5,   243,
       3,    54,     1,   241,     3,     4,     5,    57,   241,     8,
       9,    10,  1769,   238,  1576,  1577,   238,   238,   238,   238,
     157,   238,   238,  1780,  1781,   238,   238,   238,     3,   238,
     238,    30,    31,    32,   238,   238,   173,   174,     3,   241,
     240,   149,   241,     3,   240,     3,   241,    51,   164,  1424,
     243,    56,   241,   241,   240,   242,   239,   241,   239,   239,
     239,     3,   240,  1625,   238,   241,   239,   239,  1593,   239,
     241,   240,   240,     3,    52,   250,     1,   242,     3,     4,
       5,   242,   242,     8,     9,    10,   242,   242,   179,  1651,
     240,   182,   183,   238,   185,   186,   187,   188,   189,   190,
      26,   192,   193,  1665,  1666,    30,    31,    32,   241,   241,
     201,   202,   238,   238,   238,   206,   238,   238,   209,   210,
     211,   212,  1647,   238,   215,   216,   217,   218,   238,   220,
     221,    22,   241,   238,   241,   241,  1698,  1699,     3,    52,
     241,   241,  1704,   241,   225,   241,     1,   238,     3,     4,
       5,    27,   240,     8,     9,    10,     3,   248,   242,     3,
     250,   239,   224,   223,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   239,    30,    31,    32,   239,   241,
     179,   239,   239,   182,   183,   239,   185,   186,   187,   188,
     189,   190,   239,   192,   193,   239,     3,   239,   239,   239,
     239,    59,   201,   202,   242,     5,  1768,   206,  1770,   241,
     209,   210,   211,   212,   149,   241,   215,   216,   217,   218,
     240,   220,   221,     3,   241,    80,   240,   226,   227,   228,
       3,   250,   231,   232,     3,    90,     3,     3,   225,   238,
     239,   241,   225,   242,   242,   244,   242,   246,   247,   248,
     242,   242,   242,   242,   179,    54,   238,   182,   183,   240,
     185,   186,   187,   188,   189,   190,   238,   192,   193,   242,
     244,   242,   242,   242,   242,    34,   201,   202,   223,   223,
     242,   206,   241,   250,   209,   210,   211,   212,   251,   239,
     215,   216,   217,   218,     3,   220,   221,   238,     3,   242,
     240,   226,   227,   228,   242,   242,   231,   232,   242,   242,
     242,   238,   241,   238,   239,    52,   225,   242,   241,   244,
     241,   246,   247,   248,   179,     3,   241,   182,   183,   241,
     185,   186,   187,   188,   189,   190,   239,   192,   193,   239,
     239,   239,   239,   239,   239,   239,   201,   202,     5,   239,
     239,   206,   238,   238,   209,   210,   211,   212,    52,   238,
     215,   216,   217,   218,   244,   220,   221,   241,   241,     3,
     240,   226,   227,   228,     3,   242,   231,   232,   233,   240,
      34,     3,   242,   238,   241,     1,   239,     3,     4,   251,
       3,   246,   247,   248,     1,     3,     3,     4,     5,     3,
       3,     8,     9,    10,     3,     3,     3,     3,   241,    59,
     242,   149,    51,    51,   242,     3,   241,    33,    54,   223,
     239,    37,    38,    30,    31,    32,    42,    43,    44,   241,
      46,   239,   241,    49,   239,   225,    52,   239,     3,   245,
      59,   242,   240,     3,     3,    61,    62,    63,    64,   242,
     242,   242,    68,   242,   242,   242,   242,     3,   241,   241,
     241,    54,   241,   241,   241,   250,   241,     1,   242,     3,
       4,     5,   242,    80,     8,     9,    10,   241,    59,   242,
     242,   242,   242,    90,   100,   101,   242,   242,   240,   242,
     240,    31,   241,   241,   241,   241,    30,    31,    32,    34,
       8,   980,    25,   183,   190,   764,   472,   563,  1525,  1406,
     403,  1100,   128,    47,  1264,   512,   132,  1390,  1339,    53,
     224,   225,   994,   401,   678,   707,   934,   231,  1050,   233,
     486,   235,  1055,  1115,   662,  1639,   949,   974,     1,   628,
       3,     4,     5,  1503,  1332,     8,     9,    10,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    30,    31,    32,
     835,  1465,   179,  1269,   526,   182,   183,   553,   185,   186,
     187,   188,   189,   190,    47,   192,   193,  1080,   322,    -1,
      53,    -1,    -1,   554,   201,   202,    -1,    -1,    -1,   206,
      -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,   216,
     217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,
     227,   228,    -1,    -1,   231,   232,    -1,   243,    -1,   245,
      -1,   238,   248,    -1,    -1,    -1,    -1,    -1,    -1,   246,
     247,   248,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,
       1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,
      -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,    -1,   220,   221,    -1,    -1,
      -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,
      -1,    -1,    -1,    -1,   238,    -1,    57,    -1,    -1,    -1,
      -1,    -1,   246,   247,   248,    -1,   179,    68,    69,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,   110,
      -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
       1,    -1,     3,     4,     5,   238,    -1,     8,     9,    10,
      -1,    -1,    -1,   246,   247,   248,   137,   138,   139,   140,
     141,   142,   143,   144,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,   153,   154,   155,   156,    -1,    -1,   159,   160,
     161,   162,    -1,    -1,    -1,    -1,    47,    -1,    -1,    -1,
      -1,    -1,    53,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,
       1,    -1,     3,     4,     5,    -1,    -1,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    30,
      31,    32,    37,    38,    -1,    -1,    -1,    42,    43,    44,
      -1,    46,    -1,    -1,    49,    -1,    -1,   238,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    61,    62,    63,    64,
      -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,    -1,
      -1,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    -1,    -1,   179,    -1,
      -1,   182,   183,    -1,   185,   186,   187,   188,   189,   190,
      47,   192,   193,   128,    -1,    -1,    -1,   132,    -1,    -1,
     201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,    -1,   220,
     221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,
     231,   232,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   246,   247,   248,   179,    -1,
      -1,   182,   183,    -1,   185,   186,   187,   188,   189,   190,
      -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,    -1,   220,
     221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,
     231,   232,    -1,    -1,    -1,    -1,   241,   238,   243,    -1,
     245,   242,    57,   248,    -1,   246,   247,   248,    -1,    -1,
      -1,    -1,   179,    68,    69,   182,   183,    -1,   185,   186,
     187,   188,   189,   190,    -1,   192,   193,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,
      -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,   216,
     217,   218,    -1,   220,   221,   110,    -1,    -1,    -1,   226,
     227,   228,    -1,    -1,   231,   232,     1,    -1,     3,     4,
       5,   238,    -1,     8,     9,    10,    -1,    -1,    -1,   246,
     247,   248,   137,   138,   139,   140,   141,   142,   143,   144,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,   153,   154,
     155,   156,    -1,    -1,   159,   160,   161,   162,    -1,    -1,
      -1,    -1,    47,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,     3,     4,     1,    -1,     3,     4,
       5,    -1,    -1,     8,     9,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    30,    31,    32,    37,    38,
      -1,    -1,    -1,    42,    43,    44,    -1,    46,    -1,    -1,
      49,    -1,    47,   238,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    61,    62,    63,    64,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    74,     1,    -1,     3,     4,
       5,    -1,    -1,     8,     9,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,    -1,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,   128,
      -1,    -1,    -1,   132,    -1,    -1,   201,   202,    -1,    -1,
      -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,
      -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,    -1,
      -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   246,   247,   248,   179,    -1,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,
      -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,
      -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,    -1,
      -1,    -1,    -1,   238,   243,    -1,   245,    -1,    -1,   248,
      -1,   246,   247,   248,   179,    -1,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,
      -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,
      -1,   226,   227,   228,    -1,    -1,   231,   232,     1,    -1,
       3,     4,     5,   238,    -1,     8,     9,    10,   224,   225,
      -1,   246,   247,   248,    -1,   231,    -1,   233,    -1,   235,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    -1,     3,     4,     1,    -1,
       3,     4,     5,    -1,    -1,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    30,    31,    32,
      37,    38,    -1,    -1,    -1,    42,    43,    44,    -1,    46,
      -1,    -1,    49,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    61,    62,    63,    64,    -1,    -1,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
       3,     4,     5,    -1,    -1,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,   101,    -1,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,   128,    -1,    -1,    -1,   132,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,    -1,
      -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
      -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   246,   247,   248,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,    -1,
      -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
      -1,    -1,    -1,    -1,    -1,   238,   243,    -1,   245,    -1,
      -1,   248,    -1,   246,   247,   248,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,    -1,
      -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
       1,    -1,     3,     4,     5,   238,    -1,     8,     9,    10,
      -1,    -1,    -1,   246,   247,   248,     1,    -1,     3,     4,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,
      -1,    -1,    37,    38,    -1,    -1,    -1,    42,    43,    44,
      -1,    46,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    -1,    68,    -1,    -1,    71,    72,    73,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,
       4,    -1,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    97,    98,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      -1,    -1,   117,    37,    38,    -1,    -1,    -1,    42,    43,
      44,    -1,    46,   128,    -1,    49,    -1,   132,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    62,    63,
      64,    -1,    -1,    -1,    68,    -1,    -1,   152,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,
      -1,   182,   183,    -1,   185,   186,   187,   188,   189,   190,
      -1,   192,   193,    -1,    -1,    -1,   100,   101,    -1,    -1,
     201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,    -1,   220,
     221,    -1,    -1,    -1,   128,   226,   227,   228,   132,    -1,
     231,   232,     1,    -1,     3,     4,    -1,   238,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   246,   247,   248,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   243,    -1,
     245,    -1,    -1,   248,    33,    -1,    -1,    -1,    37,    38,
      -1,    -1,    -1,    42,    43,    44,    -1,    46,    -1,    -1,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    61,    62,    63,    64,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    74,     1,    -1,     3,     4,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,    -1,    -1,    -1,    -1,    -1,    33,   243,
      -1,   245,    37,    38,   248,    -1,    -1,    42,    43,    44,
       1,    46,     3,     4,    49,    -1,    -1,    -1,    -1,   128,
      -1,    -1,    -1,   132,    -1,    -1,    61,    62,    63,    64,
      -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    -1,    -1,    -1,    37,    38,    -1,    -1,
      -1,    42,    43,    44,    -1,    46,    -1,    -1,    49,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,    -1,    -1,    -1,
      61,    62,    63,    64,    -1,    -1,    -1,    68,    -1,    -1,
      -1,    -1,    -1,    74,    -1,     1,    -1,     3,     4,    -1,
      -1,    -1,    -1,   128,    -1,    -1,    -1,   132,    -1,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,   100,
     101,    -1,    -1,    25,    -1,    -1,   225,    33,    30,    31,
      32,    37,    38,    -1,    -1,    -1,    42,    43,    44,    -1,
      46,    -1,    -1,    49,   243,    -1,   245,   128,    -1,   248,
      -1,   132,    -1,    -1,    -1,    61,    62,    63,    64,    -1,
      -1,    -1,    68,    -1,     3,     4,     5,    -1,    -1,     8,
       9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    30,    31,    32,   100,   101,    -1,    -1,    -1,    -1,
     225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   241,    -1,   243,    -1,
     245,    -1,   128,   248,    -1,    -1,   132,    66,    67,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    23,    24,    25,    -1,    -1,    28,    29,    30,    31,
      32,    -1,    -1,    92,    93,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   243,    -1,   245,    -1,    -1,   248,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   130,   131,    -1,     3,     4,     5,    -1,    -1,     8,
       9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    30,    31,    32,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,   243,    -1,   245,
     179,    -1,   248,   182,   183,    -1,   185,   186,   187,   188,
     189,   190,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,
     209,   210,   211,   212,    -1,    -1,   215,   216,   217,   218,
      -1,   220,   221,    92,    93,    -1,    -1,   226,   227,   228,
      -1,    -1,   231,   232,    -1,    -1,    -1,    -1,    -1,   238,
      -1,    -1,   111,   112,   113,   114,    -1,   246,   247,   248,
      -1,    -1,     3,     4,     5,    -1,    -1,     8,     9,    10,
      -1,   130,   131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
     179,    -1,    -1,   182,   183,    -1,   185,   186,   187,   188,
     189,   190,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,
     209,   210,   211,   212,    -1,    -1,   215,   216,   217,   218,
     101,   220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,
      -1,    -1,   231,   232,    -1,     3,     4,     5,    -1,   238,
       8,     9,    10,    -1,    -1,    -1,    -1,   246,   247,   248,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    30,    31,    32,    -1,    -1,    -1,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,
      -1,   182,   183,    -1,   185,   186,   187,   188,   189,   190,
      -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,
     211,   212,    -1,   101,   215,   216,   217,   218,    -1,   220,
     221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,
     231,   232,    -1,     3,     4,     5,    -1,   238,     8,     9,
      10,    -1,   243,    -1,   245,   246,   247,   248,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      30,    31,    32,    -1,    -1,    -1,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    47,    -1,    -1,
      25,    -1,    -1,    53,    29,    30,    31,    32,    -1,    -1,
      -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,   187,
     188,   189,   190,    -1,   192,   193,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,
      -1,   209,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,
     228,    -1,    -1,   231,   232,    -1,    -1,     3,     4,     5,
     238,    -1,     8,     9,    10,   243,    -1,   245,   246,   247,
     248,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,   251,    -1,
      -1,    25,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,
      -1,    -1,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,    80,    -1,    -1,    -1,    -1,    -1,
      -1,   201,   202,    -1,    90,    -1,   206,    -1,    -1,   209,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,    -1,
     220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,
      -1,   231,   232,    -1,     3,     4,     5,    -1,   238,     8,
       9,    10,    -1,    -1,    -1,    -1,   246,   247,   248,    -1,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    30,    31,    32,    -1,    -1,    -1,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,
     206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,
     226,   227,   228,    -1,    -1,   231,   232,    -1,     3,     4,
       5,    -1,   238,     8,     9,    10,    -1,    -1,    -1,    -1,
     246,   247,   248,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    30,    31,    32,    -1,    -1,
      -1,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     179,    -1,    -1,   182,   183,    -1,   185,   186,   187,   188,
     189,   190,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,
     209,   210,   211,   212,    -1,    -1,   215,   216,   217,   218,
      -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,
      -1,    -1,   231,   232,    -1,     3,     4,     5,    -1,   238,
       8,     9,    10,   242,    -1,    -1,    -1,   246,   247,   248,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,
      -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,
      -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,     3,
       4,     5,    -1,   238,     8,     9,    10,   242,    -1,    -1,
      -1,   246,   247,   248,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,   187,
     188,   189,   190,    -1,   192,   193,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,
     208,   209,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,
     228,    -1,    -1,   231,   232,    -1,     3,     4,     5,    -1,
     238,     8,     9,    10,    -1,    -1,    -1,    -1,   246,   247,
     248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    -1,    -1,    -1,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,
      -1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,
      -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,    -1,   220,   221,    -1,    -1,
      -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,
       3,     4,     5,    -1,   238,     8,     9,    10,    -1,    -1,
     244,    -1,   246,   247,   248,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      -1,    -1,    -1,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    47,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,
     187,   188,   189,   190,    -1,   192,   193,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,
      -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,   216,
     217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,
     227,   228,    -1,    -1,   231,   232,    -1,     3,     4,     5,
      -1,   238,     8,     9,    10,   242,    -1,    -1,    -1,   246,
     247,   248,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,    -1,
      -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
      -1,     3,     4,     5,    -1,   238,     8,     9,    10,    -1,
      -1,    -1,    -1,   246,   247,   248,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,
     206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,
     226,   227,   228,    -1,    -1,   231,   232,    -1,     3,     4,
       5,    -1,   238,     8,     9,    10,   242,    -1,    -1,    -1,
     246,   247,   248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,    -1,
      -1,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,   179,    -1,    -1,
     182,   183,    -1,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,
     202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,    -1,   220,   221,
      -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,
     232,    -1,     3,     4,     5,    -1,   238,     8,     9,    10,
      -1,    -1,    -1,    -1,   246,   247,   248,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,    -1,    -1,     8,     9,
      10,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,
      -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,
      -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,    -1,
       3,     4,     5,   238,    -1,     8,     9,    10,    -1,    -1,
      -1,   246,   247,   248,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    -1,     3,     4,     5,    -1,    50,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,
      -1,   182,   183,    -1,   185,   186,   187,   188,   189,   190,
      -1,   192,   193,    -1,    -1,    -1,    -1,    80,    -1,    -1,
     201,   202,    -1,    -1,    -1,   206,    -1,    90,   209,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,    -1,   220,
     221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,   179,
     231,   232,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,    -1,   246,   247,   248,     3,     4,
       5,   201,   202,     8,     9,    10,   206,    -1,    -1,   209,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,    -1,
     220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,   248,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,     3,     4,     5,   201,   202,
       8,     9,    10,   206,    -1,    -1,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,   179,
      -1,    -1,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,    -1,   238,    -1,    -1,    -1,    -1,
      -1,   201,   202,    -1,    -1,   248,   206,    -1,   208,   209,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,    -1,
     220,   221,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   248,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,
      -1,   206,    -1,   208,   209,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   179,    -1,   248,   182,   183,    -1,   185,   186,   187,
     188,   189,   190,    -1,   192,   193,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,
      -1,   209,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,    -1,   220,   221,     1,    -1,     3,    11,    12,     6,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
     238,    25,    -1,    -1,    28,    29,    30,    31,    32,    26,
     248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    36,
      37,    38,    39,    40,    41,    42,    -1,    -1,    45,    -1,
      -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    -1,
      -1,    68,    -1,    70,    71,    72,    73,    -1,    -1,    -1,
      -1,    78,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,    -1,    -1,   102,   103,   104,   105,   106,
      -1,    -1,   109,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
      -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,   136,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,
      -1,    -1,    -1,   150,   151,   152,    -1,    -1,    -1,    -1,
      -1,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,   173,   174,    28,    29,
      30,    31,    32,     3,    -1,    -1,    -1,   184,    -1,    -1,
      -1,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,    -1,    11,    12,   241,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   248,    -1,
      -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    11,    12,   239,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    11,    12,   242,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    11,    12,   242,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    11,    12,   242,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
     242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      11,    12,   242,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    11,    12,   242,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
     242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    11,    12,   242,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      11,    12,   242,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    11,
      12,   242,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    11,    12,   242,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
     242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      11,    12,   242,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,   241,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
     241,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,   241,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    11,    12,   241,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    11,    12,
     241,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,   241,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    11,    12,   241,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,   241,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
     241,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,   241,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    11,    12,   241,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      11,    12,   241,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   224,   225,    -1,    -1,    -1,   241,    -1,   231,    -1,
     233,   224,   235,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,   241,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,    -1,
      -1,    -1,    -1,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,   239,    -1,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
     239,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,   239,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,   239,    -1,    -1,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,     1,   239,     3,    -1,    -1,
       6,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,   239,    -1,
      26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
      36,    37,    -1,    39,    40,    41,    42,    -1,    -1,    45,
      -1,    -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,
      -1,    -1,    68,    -1,    70,    71,    72,    73,    -1,    -1,
      -1,    -1,    78,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,    -1,    -1,   102,   103,   104,   105,
     106,    -1,    -1,   109,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,
     136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,
      -1,    -1,    -1,    -1,   150,   151,   152,    -1,    -1,    -1,
      -1,     1,    -1,     3,    -1,    -1,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   173,   174,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    26,    -1,   184,    -1,
      -1,    -1,    -1,    -1,    -1,    35,    36,    37,    -1,    39,
      40,    41,    42,    -1,    -1,    45,    -1,    -1,    48,    -1,
      -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    61,    -1,    -1,    -1,    65,    -1,    -1,    68,   225,
      70,    71,    72,    73,    -1,    -1,    -1,    -1,    78,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
      -1,    -1,   102,   103,   104,   105,   106,    -1,    -1,   109,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,    -1,    -1,   129,
      -1,    -1,    -1,   133,   134,   135,   136,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,    -1,
     150,   151,   152,    -1,    -1,    -1,    -1,    -1,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,   173,   174,    28,    29,    30,    31,    32,
      -1,    -1,    11,    12,   184,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,   225,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,   200,    -1,    11,
      12,   204,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,   224,    -1,    28,    29,    30,    31,    32,
     231,   232,   233,    -1,   235,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     224,    -1,    -1,    -1,    -1,    -1,    -1,   231,    -1,   233,
      -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,     1,    -1,     3,    -1,    -1,     6,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    26,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    35,    36,    37,    -1,    39,
      40,    41,    42,    -1,    -1,    45,    -1,    -1,    48,    -1,
      -1,    -1,    52,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      60,    61,    -1,    -1,    -1,    65,    -1,    -1,    68,    -1,
      70,    71,    72,    73,    -1,    -1,    -1,    -1,    78,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
      -1,    -1,   102,   103,   104,   105,   106,    -1,    -1,   109,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,    -1,    -1,   129,
      -1,    -1,    -1,   133,   134,   135,   136,    -1,    -1,    -1,
      -1,     1,    -1,     3,    -1,   145,     6,    -1,    -1,   149,
     150,   151,   152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,
      -1,    -1,    -1,   173,   174,    35,    36,    37,    38,    39,
      40,    41,    42,    -1,   184,    45,    -1,    -1,    48,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    61,    -1,    -1,    -1,    65,    -1,    -1,    68,    -1,
      70,    71,    72,    73,    -1,    -1,    -1,    -1,    78,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
      -1,    -1,   102,   103,   104,   105,   106,    -1,    -1,   109,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,    -1,    -1,   129,
      -1,    -1,    -1,   133,   134,   135,   136,    -1,    -1,    -1,
      -1,     1,    -1,     3,    -1,   145,     6,    -1,    -1,   149,
     150,   151,   152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,
      -1,    -1,    -1,   173,   174,    35,    36,    37,    -1,    39,
      40,    41,    42,    -1,   184,    45,    -1,    -1,    48,    -1,
      -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      60,    61,    -1,    -1,    -1,    65,    -1,    -1,    68,    -1,
      70,    71,    72,    73,    -1,    -1,    -1,    -1,    78,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
      -1,    -1,   102,   103,   104,   105,   106,    -1,    -1,   109,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,    -1,    -1,   129,
      -1,    -1,    -1,   133,   134,   135,   136,    -1,    -1,    -1,
      -1,     1,    -1,     3,    -1,   145,     6,    -1,    -1,    -1,
     150,   151,   152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,
      -1,    -1,    -1,   173,   174,    35,    36,    37,    -1,    39,
      40,    41,    42,    -1,   184,    45,    -1,    -1,    48,    -1,
      -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    61,    -1,    -1,    -1,    65,    -1,    -1,    68,    -1,
      70,    71,    72,    73,    -1,    -1,    -1,    -1,    78,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
      -1,    -1,   102,   103,   104,   105,   106,    -1,    -1,   109,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,    -1,    -1,   129,
      -1,    -1,    -1,   133,   134,   135,   136,    -1,    -1,    -1,
      -1,     1,    -1,     3,    -1,   145,     6,    -1,    -1,    -1,
     150,   151,   152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,
      -1,    -1,    -1,   173,   174,    35,    36,    37,    38,    39,
      40,    41,    42,    -1,   184,    45,    -1,    -1,    48,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    61,    -1,    -1,    -1,    65,    -1,    -1,    68,    -1,
      70,    71,    72,    73,    -1,    -1,    -1,    -1,    78,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
      -1,    -1,   102,   103,   104,   105,   106,    -1,    -1,   109,
      -1,     3,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,    -1,    -1,   129,
      -1,    -1,    -1,   133,   134,   135,   136,    -1,    -1,    -1,
      -1,    -1,    -1,    35,    36,   145,    -1,    39,    40,    41,
     150,   151,   152,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   173,   174,    -1,    -1,    -1,    70,    -1,
      -1,    73,    -1,    -1,   184,    -1,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    -1,    -1,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    96,    97,    98,    99,    -1,    -1,
     102,   103,   104,   105,   106,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
     122,   123,   124,   125,    -1,    -1,    -1,   129,    -1,    -1,
      -1,   133,   134,   135,   136,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   173,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   184
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    26,    91,   145,   164,   195,   213,   272,   273,   276,
     277,   295,   297,   301,   305,   342,   455,     3,    27,   278,
     279,     3,   238,     3,     3,     3,     0,   295,    76,    78,
     345,    26,   240,    27,   239,   238,     3,   241,   241,   296,
     296,     3,    27,   278,     3,     4,     5,     8,     9,    10,
      30,    31,    32,   179,   182,   183,   185,   186,   187,   188,
     189,   190,   192,   193,   201,   202,   206,   209,   210,   211,
     212,   215,   216,   217,   218,   220,   221,   226,   227,   228,
     231,   232,   238,   246,   247,   248,   274,   320,   324,   331,
     279,     3,    87,   451,   239,   165,   298,   302,   343,    27,
     238,     8,   324,   324,   324,   238,   238,   238,   238,   238,
     238,   238,   238,   238,   238,   238,   238,   238,   238,   238,
     238,   238,   238,   238,   238,   238,   238,   238,   238,   324,
       1,   324,   324,   324,   324,   320,   321,   226,   227,   228,
     324,     1,   324,   320,   323,    11,    12,    14,    15,    16,
      17,    18,    19,    20,    25,    28,    29,    30,    31,    32,
     224,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   238,   244,   250,    99,   452,   239,   242,     5,   306,
     197,   203,   214,   299,   300,   180,   181,   194,   207,   222,
     303,   304,   243,   348,   242,   320,   323,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   225,   242,   324,   324,   324,   248,   239,   249,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   242,   323,     3,   320,     3,
       3,   241,   239,     3,   241,   310,   191,   196,     3,     3,
     198,   300,   240,   240,   240,   240,   240,   199,   304,   238,
     238,   347,   242,   242,   242,   242,   242,   242,   242,   239,
     242,   242,   242,   242,   242,   242,   239,   242,   242,   239,
     239,   239,   242,   242,   242,   242,   242,   320,   323,   320,
     225,   242,    23,    24,   225,   251,   240,   453,    72,    87,
      99,   449,   450,     5,   244,   307,   241,   241,   241,   241,
     320,     3,     3,     3,     5,    88,   349,     3,   244,   248,
     276,   334,   335,   336,   389,   390,   391,    26,   346,   320,
     320,   320,   320,   320,   225,   249,   320,   320,   320,   320,
     320,   239,     3,   332,     3,     3,    87,    70,   444,   445,
     449,   242,     3,    47,   163,   166,   169,   308,   241,   241,
     241,   241,   241,    73,    97,    98,   117,   157,   250,   275,
     376,   396,   239,   242,   250,     3,   391,   392,    71,    72,
      87,   239,   242,   239,   241,   242,     3,   241,   242,   242,
     242,   242,   242,   320,     1,   249,   251,   251,   251,    72,
     454,   239,   241,   241,   241,     3,     3,   115,   437,   170,
     310,   331,   396,   320,     3,   379,    88,   379,     1,   320,
     238,   239,   249,   113,   114,   121,   122,   123,   124,   125,
     129,   133,   134,   173,   174,   337,   374,   337,    99,   337,
     375,   390,     3,   336,    73,   344,   249,     3,   239,   242,
       3,   241,   240,   438,    56,   311,   170,   172,   170,   172,
     225,   240,   376,   251,   225,   251,   248,   391,   391,   157,
     338,   338,   338,   338,     3,     1,     6,    37,    42,    48,
      60,    61,    65,    68,    71,    72,    78,    87,    88,    94,
      95,   109,   116,   126,   145,   150,   151,   152,   276,   280,
     350,   361,   366,   367,   395,    72,   241,   274,   224,   231,
     233,   235,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   439,   440,   441,   442,   443,   446,   447,     3,   241,
     311,   310,   311,   310,   320,   320,   379,   320,   392,   242,
     396,   397,   397,   397,   397,   240,   241,   332,     1,   238,
     312,   313,   238,   287,   288,   331,   396,   332,   238,     1,
     148,   360,   238,   375,   375,     1,   375,     1,   376,     3,
     238,   327,   328,   238,   328,     1,    57,    68,    69,   110,
     137,   138,   139,   140,   141,   142,   143,   144,   153,   154,
     155,   156,   159,   160,   161,   162,   238,   407,   408,   409,
     411,   413,   414,   360,   238,   285,   286,   238,    38,   367,
     332,     1,   376,     3,    35,    36,    39,    40,    41,    45,
      70,    73,    79,    81,    82,    83,    84,    85,    86,    89,
      96,    97,    98,    99,   102,   103,   104,   105,   106,   117,
     118,   119,   120,   135,   136,   184,   329,   330,   374,    38,
     241,   350,   368,   369,   350,    55,   338,   374,     3,   437,
     241,    58,   440,   446,   443,   446,   225,   447,   241,   225,
     309,   241,   309,   251,   200,   204,   381,   382,   383,   385,
     251,   249,     3,     3,     3,     3,     5,   241,   240,   241,
      66,    67,    92,    93,   111,   112,   113,   114,   130,   131,
     314,   315,   243,   290,   291,   320,   239,   241,   240,   287,
     241,     3,    54,    73,    97,    98,   117,   157,   396,   400,
     320,   338,   338,   241,   338,   241,   377,   379,   238,   396,
     314,   315,   320,   322,   239,   241,   314,   315,   241,    57,
     238,   409,   413,     3,     7,   416,   417,   238,   238,   238,
     238,   238,   238,   238,   238,     3,   415,   415,   415,   415,
     238,   238,   238,   238,     1,    80,    90,   410,   415,    57,
     407,   241,   240,   241,   240,     3,    75,    77,   108,   397,
       1,     3,   225,   367,   149,   241,   241,     3,   378,   380,
     243,   386,     1,     4,    33,    37,    38,    42,    43,    44,
      46,    49,    61,    62,    63,    64,    68,   100,   101,   128,
     132,   243,   245,   248,   289,   316,   331,   339,   423,   423,
       1,     3,   401,   402,     1,     3,   403,   404,     1,   404,
       1,    97,   146,   147,   372,   373,     1,   402,     3,   319,
     429,   238,   290,   312,   328,   238,   290,   328,   373,   225,
     367,    51,   397,   338,    56,   225,   225,   232,   252,   253,
     254,   447,   448,   164,   241,   241,   320,   383,   238,   250,
     242,   240,   241,   320,   239,   239,   239,   239,     3,     9,
      10,   238,   294,   331,   339,   340,   341,   242,   287,   320,
     240,   396,     3,   242,   397,   397,   397,   239,   241,     1,
     244,   322,   393,   394,   238,   239,   242,   239,   239,   242,
     327,   239,   239,   242,   320,   241,   241,   240,   240,   239,
     241,    50,    80,    90,   324,   419,   419,   419,   419,   419,
     419,   419,   419,   250,   239,   241,   241,   241,   241,   419,
     419,   419,   419,   242,   415,   231,   232,   418,   238,   294,
     238,   294,     1,   238,   241,   242,   242,   242,   291,   242,
     239,     3,    52,   240,   239,   241,     1,     9,    10,   238,
       1,   328,    11,   240,   241,   238,   241,   331,   339,     1,
      52,   225,   423,   427,   238,   238,   238,   339,   331,   238,
     339,   423,     1,    74,   225,   427,   238,   339,   238,   238,
     238,   238,   294,   233,   238,   331,   323,   241,   423,   428,
     276,   238,   241,    11,   240,   241,   240,   250,   398,   399,
     239,   241,   241,   240,   398,   239,   241,   241,   241,   241,
     338,   241,   241,   238,    22,   328,   290,   328,   241,   328,
     241,   338,     3,    52,   357,   291,   397,   252,   253,   254,
     225,   241,   208,   231,   232,   320,   384,   384,   320,    27,
     241,   315,   314,    67,   315,    66,   314,   293,   320,   240,
     239,   241,   358,   320,     1,   241,   355,   332,   332,     3,
     333,   379,   242,     3,   242,   239,   242,     1,   322,   394,
     315,   328,   314,   320,   315,   314,   328,   242,   320,   238,
     320,   416,   250,   320,   324,   320,   324,   223,   239,   239,
     239,   239,   239,   239,   239,   239,   324,     3,   239,   239,
     239,   239,   418,    13,    21,   292,   293,     1,   292,    59,
     242,   352,   351,   332,   241,     5,   359,   149,   320,   380,
     244,   322,   387,   388,   241,   241,   320,   320,   322,   241,
     240,    52,     3,    52,   423,   320,   320,   320,   241,   241,
       1,   339,   240,    74,     3,    74,     1,   320,   241,   320,
     320,     1,   320,   293,   276,     1,    80,    90,   233,   317,
     318,   320,   249,   428,   242,   323,   101,   245,   289,   316,
     320,   101,   289,   316,   320,   320,   320,   250,   401,   320,
     403,   396,   402,     3,   320,   241,   328,   241,   241,   312,
     397,   367,   368,     1,   332,   332,   448,   208,   208,   225,
     225,   242,   242,   242,   242,   242,   242,   239,   242,   225,
     320,   340,    47,   323,   362,   363,   241,    54,   354,   238,
     241,   241,   240,   239,   241,   238,   393,   242,   242,   242,
     242,   241,   242,   242,   242,   241,   409,   413,   225,   320,
      34,   420,   223,   223,   320,   419,   419,   293,   419,   419,
     419,   419,   293,   251,   250,   419,   419,   419,   419,    13,
      21,   238,   415,   238,   415,   239,   242,   242,   242,   241,
      71,    72,    87,   435,   436,    71,    72,    87,   276,   280,
     430,   432,   433,   434,   241,   239,   367,     3,   242,   239,
     242,   241,   241,   242,   320,   424,   242,   242,   242,   242,
     240,   320,   425,   242,   242,   242,   242,   242,   242,   242,
     428,   242,   320,   320,   242,    86,   239,   242,   241,   242,
     238,   238,   320,   320,   241,   238,   320,   320,   241,   225,
     320,   402,   241,   239,   242,   241,   241,     3,   370,   371,
     291,    52,   241,   241,   241,   241,   384,   384,   293,   320,
     225,   225,    53,   363,   320,   280,   325,   326,   432,   436,
     320,     3,     1,   242,   320,   328,   328,   328,   328,   241,
     241,   320,   239,   239,   251,   320,   320,   239,   239,     3,
     239,   421,   422,   239,   239,   239,   239,   239,   242,   324,
     239,   239,   239,   239,   238,   238,   415,   242,   415,   242,
     293,   353,    73,    99,   117,   275,   431,    73,   117,   275,
     431,    73,   117,   275,   431,   239,   241,   242,    73,   117,
     275,   431,    73,   117,   275,   431,    73,   117,   275,   431,
     430,   428,     5,    52,   238,   387,   241,   241,   280,   281,
     282,     1,    47,   283,   284,   323,     1,   284,     1,   284,
     423,   320,   241,   282,   428,   428,   423,   428,   423,   423,
     276,   318,   318,   241,   320,   241,   241,   320,   241,   241,
     320,   225,   241,     3,   240,   239,   241,     3,   371,   405,
     406,   242,   251,   242,   251,   239,   242,   225,   365,   364,
     241,   326,   423,   242,   240,   242,   242,   241,   241,   241,
     241,   225,   320,    34,   324,   293,   293,   331,   242,   239,
     293,   293,   293,   293,   320,   241,   251,   293,   293,   293,
     293,   415,   415,    23,    24,   225,   412,   412,   282,     3,
       3,     3,   338,     3,     3,     3,   338,     3,     3,     3,
     338,     3,   435,   241,   332,   332,   332,   338,   332,   332,
     332,   338,   332,   332,   332,   338,    59,   242,   149,   242,
     320,   280,   426,    53,   225,   225,   428,     1,    53,   283,
     225,    53,    53,    53,    53,   241,   426,    51,    51,   428,
     242,   242,   251,   320,   242,   320,   370,   398,   241,   239,
     241,   293,   320,   369,   369,     3,    54,   241,   320,   320,
     242,   223,   421,   239,   241,   331,   421,   421,   239,   421,
     421,   239,   239,   421,   421,   412,   412,   320,   320,   428,
     397,   397,   397,   282,   241,   241,   241,   397,   241,   241,
     241,   397,   241,   241,   241,   397,   241,   242,    52,   423,
     428,   428,   428,     1,   320,    74,   428,   428,   316,   316,
     251,     3,   405,   242,   240,   282,   320,   242,   293,   242,
     242,   293,   242,   242,   293,   293,   242,   242,   320,   320,
     242,   242,    59,     3,     3,     3,   428,   332,   332,   332,
     241,   241,   320,   320,   320,   423,   241,   421,   241,   241,
     421,   241,   241,   421,   421,   241,   241,   242,   242,   242,
     242,    59,   241,   241,   241,   339,     1,   339,   241,   241,
     242,    54,   242,   242,   242,   242,   242,   242,   240,   242,
     240,   356,   241,   241,   241,   241,   320,   423,   320,   368,
     242,   242,   423,   423
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   271,   272,   272,   273,   273,   274,   274,   274,   275,
     275,   276,   276,   277,   277,   277,   277,   278,   278,   279,
     279,   280,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   280,   280,   280,   280,   280,   280,   281,   281,   282,
     282,   283,   283,   283,   283,   284,   284,   285,   285,   285,
     286,   286,   287,   288,   288,   288,   289,   289,   290,   290,
     290,   290,   291,   291,   292,   292,   293,   293,   294,   294,
     294,   295,   295,   295,   295,   295,   295,   296,   296,   298,
     297,   299,   299,   300,   300,   300,   300,   302,   301,   303,
     303,   304,   304,   304,   304,   304,   305,   306,   306,   307,
     307,   308,   308,   308,   308,   308,   309,   309,   310,   310,
     311,   311,   312,   312,   312,   312,   312,   312,   313,   313,
     314,   314,   314,   314,   315,   315,   315,   315,   316,   316,
     316,   317,   317,   317,   318,   318,   318,   319,   319,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   321,   321,   322,   322,   322,   322,   323,   323,   324,
     324,   324,   324,   324,   324,   324,   324,   324,   324,   324,
     324,   324,   324,   324,   324,   324,   324,   324,   324,   324,
     324,   324,   324,   324,   324,   324,   324,   324,   324,   324,
     324,   324,   324,   324,   324,   324,   325,   325,   326,   326,
     327,   327,   327,   327,   327,   327,   327,   327,   328,   328,
     329,   329,   329,   329,   329,   329,   329,   329,   329,   329,
     329,   329,   330,   330,   330,   330,   330,   330,   330,   330,
     330,   330,   330,   330,   331,   331,   331,   331,   331,   331,
     332,   332,   333,   333,   333,   333,   334,   334,   335,   335,
     335,   335,   335,   336,   336,   336,   336,   336,   337,   337,
     338,   338,   339,   339,   340,   341,   341,   343,   344,   342,
     345,   345,   346,   346,   347,   347,   347,   348,   348,   349,
     349,   349,   350,   350,   350,   350,   350,   350,   350,   350,
     350,   350,   350,   350,   350,   350,   350,   350,   350,   350,
     350,   350,   350,   350,   350,   350,   350,   350,   350,   350,
     350,   350,   350,   350,   350,   351,   350,   352,   350,   353,
     350,   350,   354,   350,   355,   350,   350,   350,   350,   356,
     350,   357,   350,   350,   358,   350,   350,   359,   350,   350,
     350,   350,   350,   350,   350,   350,   350,   350,   350,   360,
     360,   361,   362,   362,   364,   363,   365,   363,   366,   366,
     367,   367,   368,   368,   368,   369,   369,   370,   371,   371,
     372,   372,   372,   373,   373,   374,   374,   374,   374,   374,
     374,   374,   374,   374,   374,   374,   374,   375,   376,   376,
     376,   376,   376,   376,   376,   377,   377,   378,   378,   379,
     380,   381,   381,   382,   382,   383,   383,   383,   383,   383,
     384,   384,   384,   384,   385,   385,   386,   386,   386,   386,
     386,   386,   387,   387,   388,   388,   389,   389,   389,   389,
     390,   390,   391,   391,   391,   391,   392,   392,   393,   393,
     393,   394,   394,   395,   395,   395,   396,   397,   397,   398,
     398,   399,   399,   400,   400,   400,   400,   400,   400,   400,
     401,   401,   402,   402,   403,   403,   404,   404,   405,   406,
     406,   407,   407,   407,   407,   407,   407,   407,   407,   407,
     407,   407,   407,   407,   407,   407,   407,   407,   407,   407,
     407,   407,   407,   407,   407,   408,   408,   409,   409,   410,
     410,   411,   411,   411,   411,   412,   412,   412,   413,   413,
     413,   414,   414,   414,   415,   415,   415,   415,   416,   416,
     416,   416,   417,   417,   418,   418,   418,   419,   419,   419,
     419,   419,   419,   419,   419,   420,   420,   421,   421,   422,
     422,   422,   422,   422,   423,   423,   423,   423,   423,   423,
     424,   423,   423,   423,   423,   425,   423,   423,   423,   423,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   423,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   423,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   423,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   426,
     426,   427,   427,   428,   428,   429,   430,   430,   431,   431,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   433,   433,   434,   434,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   436,   436,
     436,   436,   436,   438,   437,   439,   439,   440,   441,   441,
     442,   442,   443,   444,   445,   445,   446,   446,   447,   447,
     447,   447,   447,   447,   447,   447,   447,   447,   447,   447,
     447,   447,   447,   447,   447,   447,   447,   447,   447,   447,
     447,   448,   448,   448,   448,   449,   449,   449,   449,   450,
     450,   451,   451,   452,   452,   453,   453,   454,   454,   455,
     455
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     1,     2,     1,     1,     2,     1,
       1,     1,     0,     2,     3,     3,     4,     3,     1,     1,
       3,     7,     6,     4,     4,     4,     4,     3,     4,     4,
       4,     4,     4,     4,     4,     3,     3,     1,     2,     1,
       0,     3,     3,     2,     3,     2,     1,     3,     3,     3,
       1,     0,     3,     1,     2,     3,     2,     4,     2,     4,
       6,     8,     1,     0,     1,     3,     1,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     8,     1,     0,     0,
       6,     2,     1,     3,     3,     3,     3,     0,     6,     2,
       1,     4,     4,     4,     4,     4,     8,     0,     2,     0,
       2,     4,     5,     6,     5,     6,     0,     2,     1,     3,
       0,     2,     5,     5,     5,     5,     5,     5,     1,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     4,
       4,     1,     3,     3,     2,     2,     1,     6,     4,     1,
       2,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       2,     2,     2,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       5,     1,     5,     3,     1,     0,     2,     3,     1,     1,
       1,     1,     1,     1,     4,     4,     3,     3,     4,     4,
       4,     4,     4,     4,     6,     4,     4,     4,     4,     4,
       6,     4,     4,     6,     4,     4,     4,     4,     4,     4,
       6,     6,     3,     3,     6,     7,     1,     2,     1,     1,
       4,     5,     3,     2,     4,     5,     4,     5,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     4,     6,     6,     6,
       1,     3,     1,     3,     3,     5,     1,     3,     1,     3,
       3,     2,     2,     6,     6,     6,     6,     8,     1,     0,
       1,     0,     1,     3,     3,     3,     1,     0,     0,    11,
       1,     1,     8,     0,     3,     3,     0,     0,     4,     3,
       3,     5,     8,     8,     7,     6,     6,     6,     6,     6,
       6,     6,     3,     1,     3,     4,     5,     5,     6,     4,
       5,     3,     3,     6,     8,     8,     6,     8,     8,     5,
       5,     5,     3,     3,     3,     0,     8,     0,    11,     0,
      10,     5,     0,     9,     0,    12,     6,     3,     3,     0,
      14,     0,     5,     2,     0,     7,     5,     0,     8,     2,
       3,     3,     3,     2,     5,     3,     3,     9,     5,     1,
       0,     4,     2,     1,     0,     4,     0,     4,     2,     1,
       1,     0,     1,     3,     5,     1,     1,     3,     3,     1,
       1,     1,     1,     1,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       1,     2,     1,     1,     1,     1,     3,     1,     3,     4,
       3,     1,     0,     2,     1,     6,     6,     6,     6,     2,
       1,     1,     2,     2,     1,     1,     4,     4,     2,     2,
       2,     0,     5,     4,     1,     3,     1,     5,     3,     7,
       1,     0,     1,     6,     4,     4,     1,     3,     5,     5,
       4,     3,     1,     1,     1,     1,     5,     1,     0,     0,
       1,     5,     6,     1,     2,     1,     1,     1,     1,     0,
       2,     3,     1,     3,     2,     3,     1,     3,     2,     1,
       3,     3,     2,     2,     6,     6,     3,     3,    12,    10,
      12,     8,    10,    12,    10,    10,    12,    10,    10,    10,
       7,     3,     3,     3,     3,     1,     2,     5,     3,     1,
       1,    10,    11,    10,    11,     1,     1,     1,     5,     3,
       5,     6,     6,     3,     1,     4,     3,     6,     3,     7,
       3,     7,     1,     3,     1,     1,     0,     2,     2,     4,
       4,     5,     7,     3,     1,     3,     1,     0,     1,     1,
       2,     2,     3,     1,     5,     3,     5,     3,     2,     3,
       0,     7,     3,     2,     3,     0,     7,     3,     3,     3,
       2,     5,     6,     6,     6,     6,     6,     6,     5,     7,
       5,     7,    13,    11,    13,     5,     5,     5,     2,     3,
       4,     6,     4,     4,     4,     4,     5,     5,     5,     9,
       5,     9,     5,     5,     2,     5,     4,     2,     2,     2,
       0,     2,     1,     1,     1,     4,     1,     1,     1,     0,
       6,     6,     6,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     2,     1,     1,     0,     5,     5,     5,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       3,     2,     2,     0,     4,     1,     1,     4,     1,     2,
       1,     2,     6,     5,     1,     0,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     4,     1,
       2,     1,     3,     1,     0,     2,     0,     2,     4,    10,
      13
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:
#line 402 "parse.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[0].number); based_size = 0;}
#line 4977 "parse.cc" /* yacc.c:1646  */
    break;

  case 7:
#line 404 "parse.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[0].number); based_size = 0;}
#line 4983 "parse.cc" /* yacc.c:1646  */
    break;

  case 8:
#line 406 "parse.y" /* yacc.c:1646  */
    { (yyval.number) = pform_verinum_with_size((yyvsp[-1].number),(yyvsp[0].number), (yylsp[0]).text, (yylsp[0]).first_line);
	       based_size = 0; }
#line 4990 "parse.cc" /* yacc.c:1646  */
    break;

  case 12:
#line 422 "parse.y" /* yacc.c:1646  */
    { (yyval.named_pexprs) = 0; }
#line 4996 "parse.cc" /* yacc.c:1646  */
    break;

  case 13:
#line 426 "parse.y" /* yacc.c:1646  */
    { (yyval.named_pexprs) = 0; }
#line 5002 "parse.cc" /* yacc.c:1646  */
    break;

  case 14:
#line 427 "parse.y" /* yacc.c:1646  */
    { (yyval.named_pexprs) = (yyvsp[-1].named_pexprs); }
#line 5008 "parse.cc" /* yacc.c:1646  */
    break;

  case 15:
#line 428 "parse.y" /* yacc.c:1646  */
    { (yyval.named_pexprs) = (yyvsp[-2].named_pexprs); }
#line 5014 "parse.cc" /* yacc.c:1646  */
    break;

  case 16:
#line 430 "parse.y" /* yacc.c:1646  */
    { if ((yyvsp[-3].named_pexprs)) {
	    svector<named_pexpr_t*>*tmp;
	    tmp = new svector<named_pexpr_t*>(*(yyvsp[-3].named_pexprs), *(yyvsp[-1].named_pexprs));
	    delete (yyvsp[-3].named_pexprs);
	    delete (yyvsp[-1].named_pexprs);
	    (yyval.named_pexprs) = tmp;
	} else (yyval.named_pexprs) = (yyvsp[-1].named_pexprs);
      }
#line 5027 "parse.cc" /* yacc.c:1646  */
    break;

  case 17:
#line 442 "parse.y" /* yacc.c:1646  */
    { svector<named_pexpr_t*>*tmp =
			new svector<named_pexpr_t*>(*(yyvsp[-2].named_pexprs),(yyvsp[0].named_pexpr));
		  delete (yyvsp[-2].named_pexprs);
		  (yyval.named_pexprs) = tmp;
		}
#line 5037 "parse.cc" /* yacc.c:1646  */
    break;

  case 18:
#line 448 "parse.y" /* yacc.c:1646  */
    { svector<named_pexpr_t*>*tmp = new svector<named_pexpr_t*>(1);
		  (*tmp)[0] = (yyvsp[0].named_pexpr);
		  (yyval.named_pexprs) = tmp;
		}
#line 5046 "parse.cc" /* yacc.c:1646  */
    break;

  case 19:
#line 457 "parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[0].text));
		  tmp->parm = 0;
		  delete[](yyvsp[0].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 5057 "parse.cc" /* yacc.c:1646  */
    break;

  case 20:
#line 464 "parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[0].expr);
		  named_pexpr_t*tmp2 = new named_pexpr_t;
		  tmp2->name = lex_strings.make((yyvsp[-2].text));
		  tmp2->parm = tmp;
		  delete[](yyvsp[-2].text);
		  (yyval.named_pexpr) = tmp2;
		}
#line 5069 "parse.cc" /* yacc.c:1646  */
    break;

  case 21:
#line 484 "parse.y" /* yacc.c:1646  */
    { ivl_variable_type_t dtype = (yyvsp[-4].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_set_net_range((yyvsp[-1].perm_strings), (yyvsp[-2].exprs), (yyvsp[-3].flag), dtype);
		  if ((yyvsp[-6].named_pexprs)) delete (yyvsp[-6].named_pexprs);
		}
#line 5080 "parse.cc" /* yacc.c:1646  */
    break;

  case 22:
#line 497 "parse.y" /* yacc.c:1646  */
    { ivl_variable_type_t dtype = (yyvsp[-3].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_set_net_range((yyvsp[-1].perm_strings), 0, (yyvsp[-2].flag), dtype);
		  if ((yyvsp[-5].named_pexprs)) delete (yyvsp[-5].named_pexprs);
		}
#line 5091 "parse.cc" /* yacc.c:1646  */
    break;

  case 23:
#line 509 "parse.y" /* yacc.c:1646  */
    { pform_set_reg_integer((yyvsp[-1].perm_strings));
		  if ((yyvsp[-3].named_pexprs)) delete (yyvsp[-3].named_pexprs);
		}
#line 5099 "parse.cc" /* yacc.c:1646  */
    break;

  case 24:
#line 514 "parse.y" /* yacc.c:1646  */
    { pform_set_reg_time((yyvsp[-1].perm_strings));
		}
#line 5106 "parse.cc" /* yacc.c:1646  */
    break;

  case 25:
#line 523 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings); }
#line 5112 "parse.cc" /* yacc.c:1646  */
    break;

  case 26:
#line 525 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings); }
#line 5118 "parse.cc" /* yacc.c:1646  */
    break;

  case 27:
#line 528 "parse.y" /* yacc.c:1646  */
    { pform_make_events((yyvsp[-1].perm_strings), (yylsp[-2]).text, (yylsp[-2]).first_line);
		}
#line 5125 "parse.cc" /* yacc.c:1646  */
    break;

  case 30:
#line 538 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in reg variable list.");
		  yyerrok;
		  if ((yyvsp[-3].named_pexprs)) delete (yyvsp[-3].named_pexprs);
		}
#line 5134 "parse.cc" /* yacc.c:1646  */
    break;

  case 31:
#line 543 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in integer variable list.");
		  yyerrok;
		  if ((yyvsp[-3].named_pexprs)) delete (yyvsp[-3].named_pexprs);
		}
#line 5143 "parse.cc" /* yacc.c:1646  */
    break;

  case 32:
#line 548 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in time variable list.");
		  yyerrok;
		}
#line 5151 "parse.cc" /* yacc.c:1646  */
    break;

  case 33:
#line 552 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in real variable list.");
		  yyerrok;
		}
#line 5159 "parse.cc" /* yacc.c:1646  */
    break;

  case 34:
#line 556 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in realtime variable list.");
		  yyerrok;
		}
#line 5167 "parse.cc" /* yacc.c:1646  */
    break;

  case 35:
#line 560 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in parameter list.");
		  yyerrok;
		}
#line 5175 "parse.cc" /* yacc.c:1646  */
    break;

  case 36:
#line 564 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error localparam list.");
		  yyerrok;
		}
#line 5183 "parse.cc" /* yacc.c:1646  */
    break;

  case 41:
#line 581 "parse.y" /* yacc.c:1646  */
    { PCase::Item*tmp = new PCase::Item;
		  tmp->expr = *(yyvsp[-2].exprs);
		  tmp->stat = (yyvsp[0].statement);
		  delete (yyvsp[-2].exprs);
		  (yyval.citem) = tmp;
		}
#line 5194 "parse.cc" /* yacc.c:1646  */
    break;

  case 42:
#line 588 "parse.y" /* yacc.c:1646  */
    { PCase::Item*tmp = new PCase::Item;
		  tmp->stat = (yyvsp[0].statement);
		  (yyval.citem) = tmp;
		}
#line 5203 "parse.cc" /* yacc.c:1646  */
    break;

  case 43:
#line 593 "parse.y" /* yacc.c:1646  */
    { PCase::Item*tmp = new PCase::Item;
		  tmp->stat = (yyvsp[0].statement);
		  (yyval.citem) = tmp;
		}
#line 5212 "parse.cc" /* yacc.c:1646  */
    break;

  case 44:
#line 598 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: Incomprehensible case expression.");
		  yyerrok;
		}
#line 5220 "parse.cc" /* yacc.c:1646  */
    break;

  case 45:
#line 605 "parse.y" /* yacc.c:1646  */
    { svector<PCase::Item*>*tmp;
		  tmp = new svector<PCase::Item*>(*(yyvsp[-1].citems), (yyvsp[0].citem));
		  delete (yyvsp[-1].citems);
		  (yyval.citems) = tmp;
		}
#line 5230 "parse.cc" /* yacc.c:1646  */
    break;

  case 46:
#line 611 "parse.y" /* yacc.c:1646  */
    { svector<PCase::Item*>*tmp = new svector<PCase::Item*>(1);
		  (*tmp)[0] = (yyvsp[0].citem);
		  (yyval.citems) = tmp;
		}
#line 5239 "parse.cc" /* yacc.c:1646  */
    break;

  case 52:
#line 630 "parse.y" /* yacc.c:1646  */
    { pform_set_defparam(*(yyvsp[-2].pform_name), (yyvsp[0].expr));
		  delete (yyvsp[-2].pform_name);
		}
#line 5247 "parse.cc" /* yacc.c:1646  */
    break;

  case 54:
#line 638 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: defparam may not include a range.");
		  delete (yyvsp[-1].exprs);
		}
#line 5255 "parse.cc" /* yacc.c:1646  */
    break;

  case 56:
#line 646 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[0].expr);
		  (yyval.exprs) = tmp;
		}
#line 5264 "parse.cc" /* yacc.c:1646  */
    break;

  case 57:
#line 651 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[-1].expr);
		  (yyval.exprs) = tmp;
		}
#line 5273 "parse.cc" /* yacc.c:1646  */
    break;

  case 58:
#line 659 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[0].expr);
		  (yyval.exprs) = tmp;
		}
#line 5282 "parse.cc" /* yacc.c:1646  */
    break;

  case 59:
#line 664 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[-1].expr);
		  (yyval.exprs) = tmp;
		}
#line 5291 "parse.cc" /* yacc.c:1646  */
    break;

  case 60:
#line 669 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(2);
		  (*tmp)[0] = (yyvsp[-3].expr);
		  (*tmp)[1] = (yyvsp[-1].expr);
		  (yyval.exprs) = tmp;
		}
#line 5301 "parse.cc" /* yacc.c:1646  */
    break;

  case 61:
#line 675 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(3);
		  (*tmp)[0] = (yyvsp[-5].expr);
		  (*tmp)[1] = (yyvsp[-3].expr);
		  (*tmp)[2] = (yyvsp[-1].expr);
		  (yyval.exprs) = tmp;
		}
#line 5312 "parse.cc" /* yacc.c:1646  */
    break;

  case 62:
#line 684 "parse.y" /* yacc.c:1646  */
    { (yyval.exprs) = (yyvsp[0].exprs); }
#line 5318 "parse.cc" /* yacc.c:1646  */
    break;

  case 63:
#line 685 "parse.y" /* yacc.c:1646  */
    { (yyval.exprs) = 0; }
#line 5324 "parse.cc" /* yacc.c:1646  */
    break;

  case 64:
#line 690 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
	        (*tmp)[0] = (yyvsp[0].expr);
		(yyval.exprs) = tmp;
	      }
#line 5333 "parse.cc" /* yacc.c:1646  */
    break;

  case 65:
#line 695 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[-2].exprs), (yyvsp[0].expr));
		delete (yyvsp[-2].exprs);
		(yyval.exprs) = tmp;
	      }
#line 5342 "parse.cc" /* yacc.c:1646  */
    break;

  case 66:
#line 703 "parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[0].expr);
		  (yyval.expr) = tmp;
		}
#line 5350 "parse.cc" /* yacc.c:1646  */
    break;

  case 67:
#line 707 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = pform_select_mtm_expr((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 5356 "parse.cc" /* yacc.c:1646  */
    break;

  case 68:
#line 713 "parse.y" /* yacc.c:1646  */
    { verinum*tmp = (yyvsp[0].number);
		  if (tmp == 0) {
			yyerror((yylsp[0]), "internal error: delay.");
			(yyval.expr) = 0;
		  } else {
			(yyval.expr) = new PENumber(tmp);
			FILE_NAME((yyval.expr), (yylsp[0]));
		  }
		  based_size = 0;
		}
#line 5371 "parse.cc" /* yacc.c:1646  */
    break;

  case 69:
#line 724 "parse.y" /* yacc.c:1646  */
    { verireal*tmp = (yyvsp[0].realtime);
		  if (tmp == 0) {
			yyerror((yylsp[0]), "internal error: delay.");
			(yyval.expr) = 0;
		  } else {
			(yyval.expr) = new PEFNumber(tmp);
			FILE_NAME((yyval.expr), (yylsp[0]));
		  }
		}
#line 5385 "parse.cc" /* yacc.c:1646  */
    break;

  case 70:
#line 734 "parse.y" /* yacc.c:1646  */
    { PEIdent*tmp = new PEIdent(lex_strings.make((yyvsp[0].text)));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 5395 "parse.cc" /* yacc.c:1646  */
    break;

  case 76:
#line 748 "parse.y" /* yacc.c:1646  */
    { perm_string tmp3 = lex_strings.make((yyvsp[-5].text));
	pform_set_type_attrib(tmp3, (yyvsp[-3].text), (yyvsp[-1].text));
	delete[] (yyvsp[-5].text);
	delete[] (yyvsp[-3].text);
      }
#line 5405 "parse.cc" /* yacc.c:1646  */
    break;

  case 79:
#line 763 "parse.y" /* yacc.c:1646  */
    { pform_start_discipline((yyvsp[-1].text)); }
#line 5411 "parse.cc" /* yacc.c:1646  */
    break;

  case 80:
#line 765 "parse.y" /* yacc.c:1646  */
    { pform_end_discipline((yylsp[-5])); delete[] (yyvsp[-4].text); }
#line 5417 "parse.cc" /* yacc.c:1646  */
    break;

  case 83:
#line 775 "parse.y" /* yacc.c:1646  */
    { pform_discipline_domain((yylsp[-2]), IVL_DIS_DISCRETE); }
#line 5423 "parse.cc" /* yacc.c:1646  */
    break;

  case 84:
#line 777 "parse.y" /* yacc.c:1646  */
    { pform_discipline_domain((yylsp[-2]), IVL_DIS_CONTINUOUS); }
#line 5429 "parse.cc" /* yacc.c:1646  */
    break;

  case 85:
#line 779 "parse.y" /* yacc.c:1646  */
    { pform_discipline_potential((yylsp[-2]), (yyvsp[-1].text)); delete[] (yyvsp[-1].text); }
#line 5435 "parse.cc" /* yacc.c:1646  */
    break;

  case 86:
#line 781 "parse.y" /* yacc.c:1646  */
    { pform_discipline_flow((yylsp[-2]), (yyvsp[-1].text)); delete[] (yyvsp[-1].text); }
#line 5441 "parse.cc" /* yacc.c:1646  */
    break;

  case 87:
#line 786 "parse.y" /* yacc.c:1646  */
    { pform_start_nature((yyvsp[-1].text)); }
#line 5447 "parse.cc" /* yacc.c:1646  */
    break;

  case 88:
#line 789 "parse.y" /* yacc.c:1646  */
    { pform_end_nature((yylsp[-5])); delete[] (yyvsp[-4].text); }
#line 5453 "parse.cc" /* yacc.c:1646  */
    break;

  case 91:
#line 799 "parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[-1].text); }
#line 5459 "parse.cc" /* yacc.c:1646  */
    break;

  case 93:
#line 802 "parse.y" /* yacc.c:1646  */
    { pform_nature_access((yylsp[-3]), (yyvsp[-1].text)); delete[] (yyvsp[-1].text); }
#line 5465 "parse.cc" /* yacc.c:1646  */
    break;

  case 94:
#line 804 "parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[-1].text); }
#line 5471 "parse.cc" /* yacc.c:1646  */
    break;

  case 95:
#line 806 "parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[-1].text); }
#line 5477 "parse.cc" /* yacc.c:1646  */
    break;

  case 96:
#line 814 "parse.y" /* yacc.c:1646  */
    { cerr << (yylsp[-7]) << ": sorry: config declarations are not supported and "
                "will be skipped." << endl;
	delete[] (yyvsp[-6].text);
      }
#line 5486 "parse.cc" /* yacc.c:1646  */
    break;

  case 102:
#line 834 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].pform_name); }
#line 5492 "parse.cc" /* yacc.c:1646  */
    break;

  case 103:
#line 836 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-4].pform_name); }
#line 5498 "parse.cc" /* yacc.c:1646  */
    break;

  case 108:
#line 848 "parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[0].text); }
#line 5504 "parse.cc" /* yacc.c:1646  */
    break;

  case 109:
#line 850 "parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[-2].text); delete[] (yyvsp[0].text); }
#line 5510 "parse.cc" /* yacc.c:1646  */
    break;

  case 111:
#line 856 "parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[0].text); }
#line 5516 "parse.cc" /* yacc.c:1646  */
    break;

  case 112:
#line 861 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = (yyvsp[-3].drive).str0;
		  (yyval.drive).str1 = (yyvsp[-1].drive).str1;
		}
#line 5524 "parse.cc" /* yacc.c:1646  */
    break;

  case 113:
#line 865 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = (yyvsp[-1].drive).str0;
		  (yyval.drive).str1 = (yyvsp[-3].drive).str1;
		}
#line 5532 "parse.cc" /* yacc.c:1646  */
    break;

  case 114:
#line 869 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = (yyvsp[-3].drive).str0;
		  (yyval.drive).str1 = PGate::HIGHZ;
		}
#line 5540 "parse.cc" /* yacc.c:1646  */
    break;

  case 115:
#line 873 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::HIGHZ;
		  (yyval.drive).str1 = (yyvsp[-3].drive).str1;
		}
#line 5548 "parse.cc" /* yacc.c:1646  */
    break;

  case 116:
#line 877 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = (yyvsp[-1].drive).str0;
		  (yyval.drive).str1 = PGate::HIGHZ;
		}
#line 5556 "parse.cc" /* yacc.c:1646  */
    break;

  case 117:
#line 881 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::HIGHZ;
		  (yyval.drive).str1 = (yyvsp[-1].drive).str1;
		}
#line 5564 "parse.cc" /* yacc.c:1646  */
    break;

  case 118:
#line 887 "parse.y" /* yacc.c:1646  */
    { (yyval.drive) = (yyvsp[0].drive); }
#line 5570 "parse.cc" /* yacc.c:1646  */
    break;

  case 119:
#line 888 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::STRONG; (yyval.drive).str1 = PGate::STRONG; }
#line 5576 "parse.cc" /* yacc.c:1646  */
    break;

  case 120:
#line 892 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::SUPPLY; }
#line 5582 "parse.cc" /* yacc.c:1646  */
    break;

  case 121:
#line 893 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::STRONG; }
#line 5588 "parse.cc" /* yacc.c:1646  */
    break;

  case 122:
#line 894 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::PULL; }
#line 5594 "parse.cc" /* yacc.c:1646  */
    break;

  case 123:
#line 895 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::WEAK; }
#line 5600 "parse.cc" /* yacc.c:1646  */
    break;

  case 124:
#line 899 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str1 = PGate::SUPPLY; }
#line 5606 "parse.cc" /* yacc.c:1646  */
    break;

  case 125:
#line 900 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str1 = PGate::STRONG; }
#line 5612 "parse.cc" /* yacc.c:1646  */
    break;

  case 126:
#line 901 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str1 = PGate::PULL; }
#line 5618 "parse.cc" /* yacc.c:1646  */
    break;

  case 127:
#line 902 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str1 = PGate::WEAK; }
#line 5624 "parse.cc" /* yacc.c:1646  */
    break;

  case 128:
#line 907 "parse.y" /* yacc.c:1646  */
    { PEIdent*tmpi = new PEIdent(*(yyvsp[0].pform_name));
		  PEEvent*tmpe = new PEEvent(PEEvent::ANYEDGE, tmpi);
		  PEventStatement*tmps = new PEventStatement(tmpe);
		  FILE_NAME(tmps, (yylsp[-1]));
		  (yyval.event_statement) = tmps;
		  delete (yyvsp[0].pform_name);
		}
#line 5636 "parse.cc" /* yacc.c:1646  */
    break;

  case 129:
#line 915 "parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp = new PEventStatement(*(yyvsp[-1].event_expr));
		  FILE_NAME(tmp, (yylsp[-3]));
		  delete (yyvsp[-1].event_expr);
		  (yyval.event_statement) = tmp;
		}
#line 5646 "parse.cc" /* yacc.c:1646  */
    break;

  case 130:
#line 921 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: Malformed event control expression.");
		  (yyval.event_statement) = 0;
		}
#line 5654 "parse.cc" /* yacc.c:1646  */
    break;

  case 131:
#line 928 "parse.y" /* yacc.c:1646  */
    { (yyval.event_expr) = (yyvsp[0].event_expr); }
#line 5660 "parse.cc" /* yacc.c:1646  */
    break;

  case 132:
#line 930 "parse.y" /* yacc.c:1646  */
    { svector<PEEvent*>*tmp = new svector<PEEvent*>(*(yyvsp[-2].event_expr), *(yyvsp[0].event_expr));
		  delete (yyvsp[-2].event_expr);
		  delete (yyvsp[0].event_expr);
		  (yyval.event_expr) = tmp;
		}
#line 5670 "parse.cc" /* yacc.c:1646  */
    break;

  case 133:
#line 936 "parse.y" /* yacc.c:1646  */
    { svector<PEEvent*>*tmp = new svector<PEEvent*>(*(yyvsp[-2].event_expr), *(yyvsp[0].event_expr));
		  delete (yyvsp[-2].event_expr);
		  delete (yyvsp[0].event_expr);
		  (yyval.event_expr) = tmp;
		}
#line 5680 "parse.cc" /* yacc.c:1646  */
    break;

  case 134:
#line 945 "parse.y" /* yacc.c:1646  */
    { PEEvent*tmp = new PEEvent(PEEvent::POSEDGE, (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		}
#line 5691 "parse.cc" /* yacc.c:1646  */
    break;

  case 135:
#line 952 "parse.y" /* yacc.c:1646  */
    { PEEvent*tmp = new PEEvent(PEEvent::NEGEDGE, (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		}
#line 5702 "parse.cc" /* yacc.c:1646  */
    break;

  case 136:
#line 959 "parse.y" /* yacc.c:1646  */
    { PEEvent*tmp = new PEEvent(PEEvent::ANYEDGE, (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		}
#line 5713 "parse.cc" /* yacc.c:1646  */
    break;

  case 137:
#line 973 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = pform_make_branch_probe_expression((yylsp[-5]), (yyvsp[-5].text), (yyvsp[-3].text), (yyvsp[-1].text)); }
#line 5719 "parse.cc" /* yacc.c:1646  */
    break;

  case 138:
#line 975 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = pform_make_branch_probe_expression((yylsp[-3]), (yyvsp[-3].text), (yyvsp[-1].text)); }
#line 5725 "parse.cc" /* yacc.c:1646  */
    break;

  case 139:
#line 980 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 5731 "parse.cc" /* yacc.c:1646  */
    break;

  case 140:
#line 982 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 5737 "parse.cc" /* yacc.c:1646  */
    break;

  case 141:
#line 984 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('-', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5746 "parse.cc" /* yacc.c:1646  */
    break;

  case 142:
#line 989 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('~', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5755 "parse.cc" /* yacc.c:1646  */
    break;

  case 143:
#line 994 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('&', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5764 "parse.cc" /* yacc.c:1646  */
    break;

  case 144:
#line 999 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('!', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5773 "parse.cc" /* yacc.c:1646  */
    break;

  case 145:
#line 1004 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('|', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5782 "parse.cc" /* yacc.c:1646  */
    break;

  case 146:
#line 1009 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('^', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5791 "parse.cc" /* yacc.c:1646  */
    break;

  case 147:
#line 1014 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: '~' '&'  is not a valid expression. "
			  "Please use operator '~&' instead.");
		  (yyval.expr) = 0;
		}
#line 5800 "parse.cc" /* yacc.c:1646  */
    break;

  case 148:
#line 1019 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: '~' '|'  is not a valid expression. "
			  "Please use operator '~|' instead.");
		  (yyval.expr) = 0;
		}
#line 5809 "parse.cc" /* yacc.c:1646  */
    break;

  case 149:
#line 1024 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: '~' '^'  is not a valid expression. "
			  "Please use operator '~^' instead.");
		  (yyval.expr) = 0;
		}
#line 5818 "parse.cc" /* yacc.c:1646  */
    break;

  case 150:
#line 1029 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('A', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5827 "parse.cc" /* yacc.c:1646  */
    break;

  case 151:
#line 1034 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('N', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5836 "parse.cc" /* yacc.c:1646  */
    break;

  case 152:
#line 1039 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('X', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5845 "parse.cc" /* yacc.c:1646  */
    break;

  case 153:
#line 1044 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: Operand of unary ! "
			  "is not a primary expression.");
		  (yyval.expr) = 0;
		}
#line 5854 "parse.cc" /* yacc.c:1646  */
    break;

  case 154:
#line 1049 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: Operand of reduction ^ "
			  "is not a primary expression.");
		  (yyval.expr) = 0;
		}
#line 5863 "parse.cc" /* yacc.c:1646  */
    break;

  case 155:
#line 1054 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('^', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5872 "parse.cc" /* yacc.c:1646  */
    break;

  case 156:
#line 1059 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBPower('p', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5881 "parse.cc" /* yacc.c:1646  */
    break;

  case 157:
#line 1064 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('*', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5890 "parse.cc" /* yacc.c:1646  */
    break;

  case 158:
#line 1069 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('/', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5899 "parse.cc" /* yacc.c:1646  */
    break;

  case 159:
#line 1074 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('%', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5908 "parse.cc" /* yacc.c:1646  */
    break;

  case 160:
#line 1079 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('+', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5917 "parse.cc" /* yacc.c:1646  */
    break;

  case 161:
#line 1084 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('-', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5926 "parse.cc" /* yacc.c:1646  */
    break;

  case 162:
#line 1089 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('&', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5935 "parse.cc" /* yacc.c:1646  */
    break;

  case 163:
#line 1094 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('|', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5944 "parse.cc" /* yacc.c:1646  */
    break;

  case 164:
#line 1099 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('A', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5953 "parse.cc" /* yacc.c:1646  */
    break;

  case 165:
#line 1104 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('O', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5962 "parse.cc" /* yacc.c:1646  */
    break;

  case 166:
#line 1109 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('X', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5971 "parse.cc" /* yacc.c:1646  */
    break;

  case 167:
#line 1114 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('<', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5980 "parse.cc" /* yacc.c:1646  */
    break;

  case 168:
#line 1119 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('>', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5989 "parse.cc" /* yacc.c:1646  */
    break;

  case 169:
#line 1124 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBShift('l', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5998 "parse.cc" /* yacc.c:1646  */
    break;

  case 170:
#line 1129 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBShift('r', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6007 "parse.cc" /* yacc.c:1646  */
    break;

  case 171:
#line 1134 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBShift('R', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6016 "parse.cc" /* yacc.c:1646  */
    break;

  case 172:
#line 1139 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('e', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6025 "parse.cc" /* yacc.c:1646  */
    break;

  case 173:
#line 1144 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('E', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6034 "parse.cc" /* yacc.c:1646  */
    break;

  case 174:
#line 1149 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('L', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6043 "parse.cc" /* yacc.c:1646  */
    break;

  case 175:
#line 1154 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('G', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6052 "parse.cc" /* yacc.c:1646  */
    break;

  case 176:
#line 1159 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('n', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6061 "parse.cc" /* yacc.c:1646  */
    break;

  case 177:
#line 1164 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('N', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6070 "parse.cc" /* yacc.c:1646  */
    break;

  case 178:
#line 1169 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBLogic('o', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6079 "parse.cc" /* yacc.c:1646  */
    break;

  case 179:
#line 1174 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBLogic('a', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6088 "parse.cc" /* yacc.c:1646  */
    break;

  case 180:
#line 1179 "parse.y" /* yacc.c:1646  */
    { PETernary*tmp = new PETernary((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-3]));
		  (yyval.expr) = tmp;
		}
#line 6097 "parse.cc" /* yacc.c:1646  */
    break;

  case 181:
#line 1187 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 6103 "parse.cc" /* yacc.c:1646  */
    break;

  case 182:
#line 1189 "parse.y" /* yacc.c:1646  */
    { switch (min_typ_max_flag) {
		      case MIN:
			(yyval.expr) = (yyvsp[-4].expr);
			delete (yyvsp[-2].expr);
			delete (yyvsp[0].expr);
			break;
		      case TYP:
			delete (yyvsp[-4].expr);
			(yyval.expr) = (yyvsp[-2].expr);
			delete (yyvsp[0].expr);
			break;
		      case MAX:
			delete (yyvsp[-4].expr);
			delete (yyvsp[-2].expr);
			(yyval.expr) = (yyvsp[0].expr);
			break;
		  }
		  if (min_typ_max_warn > 0) {
		        cerr << (yyval.expr)->get_fileline() << ": warning: choosing ";
		        switch (min_typ_max_flag) {
		            case MIN:
		              cerr << "min";
		              break;
		            case TYP:
		              cerr << "typ";
		              break;
		            case MAX:
		              cerr << "max";
		              break;
		        }
		        cerr << " expression." << endl;
		        min_typ_max_warn -= 1;
		  }
		}
#line 6142 "parse.cc" /* yacc.c:1646  */
    break;

  case 183:
#line 1236 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[-2].exprs), (yyvsp[0].expr));
		  delete (yyvsp[-2].exprs);
		  (yyval.exprs) = tmp;
		}
#line 6151 "parse.cc" /* yacc.c:1646  */
    break;

  case 184:
#line 1241 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[0].expr);
		  (yyval.exprs) = tmp;
		}
#line 6160 "parse.cc" /* yacc.c:1646  */
    break;

  case 185:
#line 1246 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = 0;
		  (yyval.exprs) = tmp;
		}
#line 6169 "parse.cc" /* yacc.c:1646  */
    break;

  case 186:
#line 1252 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[-1].exprs), 0);
		  delete (yyvsp[-1].exprs);
		  (yyval.exprs) = tmp;
		}
#line 6178 "parse.cc" /* yacc.c:1646  */
    break;

  case 187:
#line 1260 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[-2].exprs), (yyvsp[0].expr));
		  delete (yyvsp[-2].exprs);
		  (yyval.exprs) = tmp;
		}
#line 6187 "parse.cc" /* yacc.c:1646  */
    break;

  case 188:
#line 1265 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[0].expr);
		  (yyval.exprs) = tmp;
		}
#line 6196 "parse.cc" /* yacc.c:1646  */
    break;

  case 189:
#line 1273 "parse.y" /* yacc.c:1646  */
    { assert((yyvsp[0].number));
		  PENumber*tmp = new PENumber((yyvsp[0].number));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 6206 "parse.cc" /* yacc.c:1646  */
    break;

  case 190:
#line 1279 "parse.y" /* yacc.c:1646  */
    { PEFNumber*tmp = new PEFNumber((yyvsp[0].realtime));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 6215 "parse.cc" /* yacc.c:1646  */
    break;

  case 191:
#line 1284 "parse.y" /* yacc.c:1646  */
    { PEString*tmp = new PEString((yyvsp[0].text));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 6224 "parse.cc" /* yacc.c:1646  */
    break;

  case 192:
#line 1289 "parse.y" /* yacc.c:1646  */
    { perm_string tn = lex_strings.make((yyvsp[0].text));
		  PECallFunction*tmp = new PECallFunction(tn);
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 6235 "parse.cc" /* yacc.c:1646  */
    break;

  case 193:
#line 1300 "parse.y" /* yacc.c:1646  */
    { PEIdent*tmp = new PEIdent(*(yyvsp[0].pform_name));
	  FILE_NAME(tmp, (yylsp[0]));
	  (yyval.expr) = tmp;
	  delete (yyvsp[0].pform_name);
	}
#line 6245 "parse.cc" /* yacc.c:1646  */
    break;

  case 194:
#line 1311 "parse.y" /* yacc.c:1646  */
    { PECallFunction*tmp = new PECallFunction(*(yyvsp[-3].pform_name), *(yyvsp[-1].exprs));
	FILE_NAME(tmp, (yylsp[-3]));
	delete (yyvsp[-3].pform_name);
	(yyval.expr) = tmp;
      }
#line 6255 "parse.cc" /* yacc.c:1646  */
    break;

  case 195:
#line 1317 "parse.y" /* yacc.c:1646  */
    { perm_string tn = lex_strings.make((yyvsp[-3].text));
	PECallFunction*tmp = new PECallFunction(tn, *(yyvsp[-1].exprs));
	FILE_NAME(tmp, (yylsp[-3]));
	delete[](yyvsp[-3].text);
	(yyval.expr) = tmp;
      }
#line 6266 "parse.cc" /* yacc.c:1646  */
    break;

  case 196:
#line 1324 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: function calls must have at least one "
			  "input argument.");
		  yyerrok;
      }
#line 6275 "parse.cc" /* yacc.c:1646  */
    break;

  case 197:
#line 1329 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: system function calls must have at least one "
			  "input argument.");
		  yyerrok;
      }
#line 6284 "parse.cc" /* yacc.c:1646  */
    break;

  case 198:
#line 1338 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$acos");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6294 "parse.cc" /* yacc.c:1646  */
    break;

  case 199:
#line 1345 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$acosh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6304 "parse.cc" /* yacc.c:1646  */
    break;

  case 200:
#line 1352 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$asin");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6314 "parse.cc" /* yacc.c:1646  */
    break;

  case 201:
#line 1359 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$asinh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6324 "parse.cc" /* yacc.c:1646  */
    break;

  case 202:
#line 1366 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$atan");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6334 "parse.cc" /* yacc.c:1646  */
    break;

  case 203:
#line 1373 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$atanh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6344 "parse.cc" /* yacc.c:1646  */
    break;

  case 204:
#line 1380 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$atan2");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 6354 "parse.cc" /* yacc.c:1646  */
    break;

  case 205:
#line 1387 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$ceil");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6364 "parse.cc" /* yacc.c:1646  */
    break;

  case 206:
#line 1394 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$cos");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6374 "parse.cc" /* yacc.c:1646  */
    break;

  case 207:
#line 1401 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$cosh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6384 "parse.cc" /* yacc.c:1646  */
    break;

  case 208:
#line 1408 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$exp");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6394 "parse.cc" /* yacc.c:1646  */
    break;

  case 209:
#line 1415 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$floor");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6404 "parse.cc" /* yacc.c:1646  */
    break;

  case 210:
#line 1422 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$hypot");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 6414 "parse.cc" /* yacc.c:1646  */
    break;

  case 211:
#line 1429 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$ln");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6424 "parse.cc" /* yacc.c:1646  */
    break;

  case 212:
#line 1436 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$log10");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6434 "parse.cc" /* yacc.c:1646  */
    break;

  case 213:
#line 1443 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$pow");
        PECallFunction*tmp = make_call_function(tn, (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 6444 "parse.cc" /* yacc.c:1646  */
    break;

  case 214:
#line 1450 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$sin");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6454 "parse.cc" /* yacc.c:1646  */
    break;

  case 215:
#line 1457 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$sinh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6464 "parse.cc" /* yacc.c:1646  */
    break;

  case 216:
#line 1464 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$sqrt");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6474 "parse.cc" /* yacc.c:1646  */
    break;

  case 217:
#line 1471 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$tan");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6484 "parse.cc" /* yacc.c:1646  */
    break;

  case 218:
#line 1478 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$tanh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6494 "parse.cc" /* yacc.c:1646  */
    break;

  case 219:
#line 1489 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('m', (yyvsp[-1].expr));
        FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6503 "parse.cc" /* yacc.c:1646  */
    break;

  case 220:
#line 1495 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('M', (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 6512 "parse.cc" /* yacc.c:1646  */
    break;

  case 221:
#line 1501 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('m', (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 6521 "parse.cc" /* yacc.c:1646  */
    break;

  case 222:
#line 1509 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 6527 "parse.cc" /* yacc.c:1646  */
    break;

  case 223:
#line 1514 "parse.y" /* yacc.c:1646  */
    { PEConcat*tmp = new PEConcat(*(yyvsp[-1].exprs));
		  FILE_NAME(tmp, (yylsp[-2]));
		  delete (yyvsp[-1].exprs);
		  (yyval.expr) = tmp;
		}
#line 6537 "parse.cc" /* yacc.c:1646  */
    break;

  case 224:
#line 1520 "parse.y" /* yacc.c:1646  */
    { PExpr*rep = (yyvsp[-4].expr);
		  PEConcat*tmp = new PEConcat(*(yyvsp[-2].exprs), rep);
		  FILE_NAME(tmp, (yylsp[-5]));
		  delete (yyvsp[-2].exprs);
		  (yyval.expr) = tmp;
		}
#line 6548 "parse.cc" /* yacc.c:1646  */
    break;

  case 225:
#line 1527 "parse.y" /* yacc.c:1646  */
    { PExpr*rep = (yyvsp[-5].expr);
		  PEConcat*tmp = new PEConcat(*(yyvsp[-3].exprs), rep);
		  FILE_NAME(tmp, (yylsp[-6]));
		  delete (yyvsp[-3].exprs);
		  (yyval.expr) = tmp;
		  yyerror((yylsp[-2]), "error: Syntax error between internal '}' "
			  "and closing '}' of repeat concatenation.");
		  yyerrok;
		}
#line 6562 "parse.cc" /* yacc.c:1646  */
    break;

  case 226:
#line 1543 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 6568 "parse.cc" /* yacc.c:1646  */
    break;

  case 227:
#line 1545 "parse.y" /* yacc.c:1646  */
    { if ((yyvsp[-1].wires) && (yyvsp[0].wires)) {
		        svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[-1].wires), *(yyvsp[0].wires));
			delete (yyvsp[-1].wires);
			delete (yyvsp[0].wires);
			(yyval.wires) = tmp;
		  } else if ((yyvsp[-1].wires)) {
			(yyval.wires) = (yyvsp[-1].wires);
		  } else {
			(yyval.wires) = (yyvsp[0].wires);
		  }
		}
#line 6584 "parse.cc" /* yacc.c:1646  */
    break;

  case 228:
#line 1560 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 6590 "parse.cc" /* yacc.c:1646  */
    break;

  case 229:
#line 1562 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = 0; }
#line 6596 "parse.cc" /* yacc.c:1646  */
    break;

  case 230:
#line 1569 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[-3].text);
		  tmp->parms = (yyvsp[-1].exprs);
		  tmp->file  = (yylsp[-3]).text;
		  tmp->lineno = (yylsp[-3]).first_line;
		  delete[](yyvsp[-3].text);
		  (yyval.gate) = tmp;
		}
#line 6609 "parse.cc" /* yacc.c:1646  */
    break;

  case 231:
#line 1579 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  svector<PExpr*>*rng = (yyvsp[-3].exprs);
		  tmp->name = (yyvsp[-4].text);
		  tmp->parms = (yyvsp[-1].exprs);
		  tmp->range[0] = (*rng)[0];
		  tmp->range[1] = (*rng)[1];
		  tmp->file  = (yylsp[-4]).text;
		  tmp->lineno = (yylsp[-4]).first_line;
		  delete[](yyvsp[-4].text);
		  delete rng;
		  (yyval.gate) = tmp;
		}
#line 6626 "parse.cc" /* yacc.c:1646  */
    break;

  case 232:
#line 1592 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = "";
		  tmp->parms = (yyvsp[-1].exprs);
		  tmp->file  = (yylsp[-2]).text;
		  tmp->lineno = (yylsp[-2]).first_line;
		  (yyval.gate) = tmp;
		}
#line 6638 "parse.cc" /* yacc.c:1646  */
    break;

  case 233:
#line 1603 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  svector<PExpr*>*rng = (yyvsp[0].exprs);
		  tmp->name = (yyvsp[-1].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->range[0] = (*rng)[0];
		  tmp->range[1] = (*rng)[1];
		  tmp->file  = (yylsp[-1]).text;
		  tmp->lineno = (yylsp[-1]).first_line;
		  delete[](yyvsp[-1].text);
		  delete rng;
		  (yyval.gate) = tmp;
		}
#line 6656 "parse.cc" /* yacc.c:1646  */
    break;

  case 234:
#line 1620 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[-3].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = (yyvsp[-1].named_pexprs);
		  tmp->file  = (yylsp[-3]).text;
		  tmp->lineno = (yylsp[-3]).first_line;
		  delete[](yyvsp[-3].text);
		  (yyval.gate) = tmp;
		}
#line 6670 "parse.cc" /* yacc.c:1646  */
    break;

  case 235:
#line 1631 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  svector<PExpr*>*rng = (yyvsp[-3].exprs);
		  tmp->name = (yyvsp[-4].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = (yyvsp[-1].named_pexprs);
		  tmp->range[0] = (*rng)[0];
		  tmp->range[1] = (*rng)[1];
		  tmp->file  = (yylsp[-4]).text;
		  tmp->lineno = (yylsp[-4]).first_line;
		  delete[](yyvsp[-4].text);
		  delete rng;
		  (yyval.gate) = tmp;
		}
#line 6688 "parse.cc" /* yacc.c:1646  */
    break;

  case 236:
#line 1646 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[-3].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->file  = (yylsp[-3]).text;
		  tmp->lineno = (yylsp[-3]).first_line;
		  yyerror((yylsp[-2]), "error: Syntax error in instance port "
			  "expression(s).");
		  delete[](yyvsp[-3].text);
		  (yyval.gate) = tmp;
		}
#line 6704 "parse.cc" /* yacc.c:1646  */
    break;

  case 237:
#line 1659 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[-4].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->file  = (yylsp[-4]).text;
		  tmp->lineno = (yylsp[-4]).first_line;
		  yyerror((yylsp[-2]), "error: Syntax error in instance port "
			  "expression(s).");
		  delete[](yyvsp[-4].text);
		  (yyval.gate) = tmp;
		}
#line 6720 "parse.cc" /* yacc.c:1646  */
    break;

  case 238:
#line 1674 "parse.y" /* yacc.c:1646  */
    { svector<lgate>*tmp1 = (yyvsp[-2].gates);
		  lgate*tmp2 = (yyvsp[0].gate);
		  svector<lgate>*out = new svector<lgate> (*tmp1, *tmp2);
		  delete tmp1;
		  delete tmp2;
		  (yyval.gates) = out;
		}
#line 6732 "parse.cc" /* yacc.c:1646  */
    break;

  case 239:
#line 1682 "parse.y" /* yacc.c:1646  */
    { svector<lgate>*tmp = new svector<lgate>(1);
		  (*tmp)[0] = *(yyvsp[0].gate);
		  delete (yyvsp[0].gate);
		  (yyval.gates) = tmp;
		}
#line 6742 "parse.cc" /* yacc.c:1646  */
    break;

  case 240:
#line 1690 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::AND; }
#line 6748 "parse.cc" /* yacc.c:1646  */
    break;

  case 241:
#line 1691 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NAND; }
#line 6754 "parse.cc" /* yacc.c:1646  */
    break;

  case 242:
#line 1692 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::OR; }
#line 6760 "parse.cc" /* yacc.c:1646  */
    break;

  case 243:
#line 1693 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NOR; }
#line 6766 "parse.cc" /* yacc.c:1646  */
    break;

  case 244:
#line 1694 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::XOR; }
#line 6772 "parse.cc" /* yacc.c:1646  */
    break;

  case 245:
#line 1695 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::XNOR; }
#line 6778 "parse.cc" /* yacc.c:1646  */
    break;

  case 246:
#line 1696 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::BUF; }
#line 6784 "parse.cc" /* yacc.c:1646  */
    break;

  case 247:
#line 1697 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::BUFIF0; }
#line 6790 "parse.cc" /* yacc.c:1646  */
    break;

  case 248:
#line 1698 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::BUFIF1; }
#line 6796 "parse.cc" /* yacc.c:1646  */
    break;

  case 249:
#line 1699 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NOT; }
#line 6802 "parse.cc" /* yacc.c:1646  */
    break;

  case 250:
#line 1700 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NOTIF0; }
#line 6808 "parse.cc" /* yacc.c:1646  */
    break;

  case 251:
#line 1701 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NOTIF1; }
#line 6814 "parse.cc" /* yacc.c:1646  */
    break;

  case 252:
#line 1705 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NMOS; }
#line 6820 "parse.cc" /* yacc.c:1646  */
    break;

  case 253:
#line 1706 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RNMOS; }
#line 6826 "parse.cc" /* yacc.c:1646  */
    break;

  case 254:
#line 1707 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::PMOS; }
#line 6832 "parse.cc" /* yacc.c:1646  */
    break;

  case 255:
#line 1708 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RPMOS; }
#line 6838 "parse.cc" /* yacc.c:1646  */
    break;

  case 256:
#line 1709 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::CMOS; }
#line 6844 "parse.cc" /* yacc.c:1646  */
    break;

  case 257:
#line 1710 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RCMOS; }
#line 6850 "parse.cc" /* yacc.c:1646  */
    break;

  case 258:
#line 1711 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::TRAN; }
#line 6856 "parse.cc" /* yacc.c:1646  */
    break;

  case 259:
#line 1712 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RTRAN; }
#line 6862 "parse.cc" /* yacc.c:1646  */
    break;

  case 260:
#line 1713 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::TRANIF0; }
#line 6868 "parse.cc" /* yacc.c:1646  */
    break;

  case 261:
#line 1714 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::TRANIF1; }
#line 6874 "parse.cc" /* yacc.c:1646  */
    break;

  case 262:
#line 1715 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RTRANIF0; }
#line 6880 "parse.cc" /* yacc.c:1646  */
    break;

  case 263:
#line 1716 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RTRANIF1; }
#line 6886 "parse.cc" /* yacc.c:1646  */
    break;

  case 264:
#line 1727 "parse.y" /* yacc.c:1646  */
    { (yyval.pform_name) = new pform_name_t;
	  (yyval.pform_name)->push_back(name_component_t(lex_strings.make((yyvsp[0].text))));
	  delete[](yyvsp[0].text);
	}
#line 6895 "parse.cc" /* yacc.c:1646  */
    break;

  case 265:
#line 1732 "parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-2].pform_name);
	  tmp->push_back(name_component_t(lex_strings.make((yyvsp[0].text))));
	  delete[](yyvsp[0].text);
	  (yyval.pform_name) = tmp;
	}
#line 6905 "parse.cc" /* yacc.c:1646  */
    break;

  case 266:
#line 1738 "parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-3].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_BIT;
	  itmp.msb = (yyvsp[-1].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
#line 6918 "parse.cc" /* yacc.c:1646  */
    break;

  case 267:
#line 1747 "parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-5].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_PART;
	  itmp.msb = (yyvsp[-3].expr);
	  itmp.lsb = (yyvsp[-1].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
#line 6932 "parse.cc" /* yacc.c:1646  */
    break;

  case 268:
#line 1757 "parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-5].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_IDX_UP;
	  itmp.msb = (yyvsp[-3].expr);
	  itmp.lsb = (yyvsp[-1].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
#line 6946 "parse.cc" /* yacc.c:1646  */
    break;

  case 269:
#line 1767 "parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-5].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_IDX_DO;
	  itmp.msb = (yyvsp[-3].expr);
	  itmp.lsb = (yyvsp[-1].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
#line 6960 "parse.cc" /* yacc.c:1646  */
    break;

  case 270:
#line 1783 "parse.y" /* yacc.c:1646  */
    { (yyval.perm_strings) = list_from_identifier((yyvsp[0].text)); }
#line 6966 "parse.cc" /* yacc.c:1646  */
    break;

  case 271:
#line 1785 "parse.y" /* yacc.c:1646  */
    { (yyval.perm_strings) = list_from_identifier((yyvsp[-2].perm_strings), (yyvsp[0].text)); }
#line 6972 "parse.cc" /* yacc.c:1646  */
    break;

  case 272:
#line 1790 "parse.y" /* yacc.c:1646  */
    { (yyval.port_list) = make_port_list((yyvsp[0].text), 0); }
#line 6978 "parse.cc" /* yacc.c:1646  */
    break;

  case 273:
#line 1792 "parse.y" /* yacc.c:1646  */
    { (yyval.port_list) = make_port_list((yyvsp[-2].text), (yyvsp[0].expr)); }
#line 6984 "parse.cc" /* yacc.c:1646  */
    break;

  case 274:
#line 1794 "parse.y" /* yacc.c:1646  */
    { (yyval.port_list) = make_port_list((yyvsp[-2].port_list), (yyvsp[0].text), 0); }
#line 6990 "parse.cc" /* yacc.c:1646  */
    break;

  case 275:
#line 1796 "parse.y" /* yacc.c:1646  */
    { (yyval.port_list) = make_port_list((yyvsp[-4].port_list), (yyvsp[-2].text), (yyvsp[0].expr)); }
#line 6996 "parse.cc" /* yacc.c:1646  */
    break;

  case 276:
#line 1818 "parse.y" /* yacc.c:1646  */
    { vector<Module::port_t*>*tmp
			  = new vector<Module::port_t*>(1);
		  (*tmp)[0] = (yyvsp[0].mport);
		  (yyval.mports) = tmp;
		}
#line 7006 "parse.cc" /* yacc.c:1646  */
    break;

  case 277:
#line 1824 "parse.y" /* yacc.c:1646  */
    { vector<Module::port_t*>*tmp = (yyvsp[-2].mports);
		  tmp->push_back((yyvsp[0].mport));
		  (yyval.mports) = tmp;
		}
#line 7015 "parse.cc" /* yacc.c:1646  */
    break;

  case 278:
#line 1832 "parse.y" /* yacc.c:1646  */
    { vector<Module::port_t*>*tmp
			  = new vector<Module::port_t*>(1);
		  (*tmp)[0] = (yyvsp[0].mport);
		  (yyval.mports) = tmp;
		}
#line 7025 "parse.cc" /* yacc.c:1646  */
    break;

  case 279:
#line 1838 "parse.y" /* yacc.c:1646  */
    { vector<Module::port_t*>*tmp = (yyvsp[-2].mports);
		  tmp->push_back((yyvsp[0].mport));
		  (yyval.mports) = tmp;
		}
#line 7034 "parse.cc" /* yacc.c:1646  */
    break;

  case 280:
#line 1843 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
		  perm_string name = lex_strings.make((yyvsp[0].text));
		  ptmp = pform_module_port_reference(name, (yylsp[0]).text,
						     (yylsp[0]).first_line);
		  vector<Module::port_t*>*tmp = (yyvsp[-2].mports);
		  tmp->push_back(ptmp);

		    /* Get the port declaration details, the port type
		       and what not, from context data stored by the
		       last port_declaration rule. */
		  pform_module_define_port((yylsp[0]), name,
					port_declaration_context.port_type,
					port_declaration_context.port_net_type,
					port_declaration_context.sign_flag,
					port_declaration_context.range, 0);
		  delete[](yyvsp[0].text);
		  (yyval.mports) = tmp;
		}
#line 7057 "parse.cc" /* yacc.c:1646  */
    break;

  case 281:
#line 1862 "parse.y" /* yacc.c:1646  */
    {
		  yyerror((yylsp[0]), "error: NULL port declarations are not "
		              "allowed.");
		}
#line 7066 "parse.cc" /* yacc.c:1646  */
    break;

  case 282:
#line 1867 "parse.y" /* yacc.c:1646  */
    {
		  yyerror((yylsp[0]), "error: ';' is an invalid port declaration "
		              "separator.");
		}
#line 7075 "parse.cc" /* yacc.c:1646  */
    break;

  case 283:
#line 1876 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[0].text));
	ptmp = pform_module_port_reference(name, (yylsp[-4]).text,
					   (yylsp[-4]).first_line);
	pform_module_define_port((yylsp[-4]), name, NetNet::PINPUT,
				 (yyvsp[-3].nettype), (yyvsp[-2].flag), (yyvsp[-1].exprs), (yyvsp[-5].named_pexprs));
	port_declaration_context.port_type = NetNet::PINPUT;
	port_declaration_context.port_net_type = (yyvsp[-3].nettype);
	port_declaration_context.sign_flag = (yyvsp[-2].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[-1].exprs);
	delete (yyvsp[-5].named_pexprs);
	delete[](yyvsp[0].text);
	(yyval.mport) = ptmp;
      }
#line 7095 "parse.cc" /* yacc.c:1646  */
    break;

  case 284:
#line 1893 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[0].text));
	ptmp = pform_module_port_reference(name, (yylsp[-4]).text,
					   (yylsp[-4]).first_line);
	pform_module_define_port((yylsp[-4]), name, NetNet::PINOUT,
				 (yyvsp[-3].nettype), (yyvsp[-2].flag), (yyvsp[-1].exprs), (yyvsp[-5].named_pexprs));
	port_declaration_context.port_type = NetNet::PINOUT;
	port_declaration_context.port_net_type = (yyvsp[-3].nettype);
	port_declaration_context.sign_flag = (yyvsp[-2].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[-1].exprs);
	delete (yyvsp[-5].named_pexprs);
	delete[](yyvsp[0].text);
	(yyval.mport) = ptmp;
      }
#line 7115 "parse.cc" /* yacc.c:1646  */
    break;

  case 285:
#line 1910 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[0].text));
	ptmp = pform_module_port_reference(name, (yylsp[-4]).text,
					   (yylsp[-4]).first_line);
	pform_module_define_port((yylsp[-4]), name, NetNet::POUTPUT,
				 (yyvsp[-3].nettype), (yyvsp[-2].flag), (yyvsp[-1].exprs), (yyvsp[-5].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = (yyvsp[-3].nettype);
	port_declaration_context.sign_flag = (yyvsp[-2].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[-1].exprs);
	delete (yyvsp[-5].named_pexprs);
	delete[](yyvsp[0].text);
	(yyval.mport) = ptmp;
      }
#line 7135 "parse.cc" /* yacc.c:1646  */
    break;

  case 286:
#line 1927 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[0].text));
	ptmp = pform_module_port_reference(name, (yylsp[-4]).text,
					   (yylsp[-4]).first_line);
	pform_module_define_port((yylsp[-4]), name, NetNet::POUTPUT,
				 (yyvsp[-3].nettype), (yyvsp[-2].flag), (yyvsp[-1].exprs), (yyvsp[-5].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = (yyvsp[-3].nettype);
	port_declaration_context.sign_flag = (yyvsp[-2].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[-1].exprs);
	delete (yyvsp[-5].named_pexprs);
	delete[](yyvsp[0].text);
	(yyval.mport) = ptmp;
      }
#line 7155 "parse.cc" /* yacc.c:1646  */
    break;

  case 287:
#line 1944 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[-2].text));
	ptmp = pform_module_port_reference(name, (yylsp[-6]).text,
					   (yylsp[-6]).first_line);
	pform_module_define_port((yylsp[-6]), name, NetNet::POUTPUT,
				 (yyvsp[-5].nettype), (yyvsp[-4].flag), (yyvsp[-3].exprs), (yyvsp[-7].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = (yyvsp[-5].nettype);
	port_declaration_context.sign_flag = (yyvsp[-4].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[-3].exprs);

	pform_make_reginit((yylsp[-2]), name, (yyvsp[0].expr));

	delete (yyvsp[-7].named_pexprs);
	delete[](yyvsp[-2].text);
	(yyval.mport) = ptmp;
      }
#line 7178 "parse.cc" /* yacc.c:1646  */
    break;

  case 288:
#line 1967 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = (yyvsp[0].nettype); }
#line 7184 "parse.cc" /* yacc.c:1646  */
    break;

  case 289:
#line 1968 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::IMPLICIT; }
#line 7190 "parse.cc" /* yacc.c:1646  */
    break;

  case 290:
#line 1971 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 7196 "parse.cc" /* yacc.c:1646  */
    break;

  case 291:
#line 1971 "parse.y" /* yacc.c:1646  */
    {(yyval.flag) = false; }
#line 7202 "parse.cc" /* yacc.c:1646  */
    break;

  case 292:
#line 1979 "parse.y" /* yacc.c:1646  */
    { PEIdent*tmp = new PEIdent(*(yyvsp[0].pform_name));
	  FILE_NAME(tmp, (yylsp[0]));
	  (yyval.expr) = tmp;
	  delete (yyvsp[0].pform_name);
	}
#line 7212 "parse.cc" /* yacc.c:1646  */
    break;

  case 293:
#line 1985 "parse.y" /* yacc.c:1646  */
    { PEConcat*tmp = new PEConcat(*(yyvsp[-1].exprs));
	  FILE_NAME(tmp, (yylsp[-2]));
	  delete (yyvsp[-1].exprs);
	  (yyval.expr) = tmp;
	}
#line 7222 "parse.cc" /* yacc.c:1646  */
    break;

  case 294:
#line 1997 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(2);
		  (*tmp)[0] = (yyvsp[-2].expr);
		  (*tmp)[1] = (yyvsp[0].expr);
		  (yyval.exprs) = tmp;
		}
#line 7232 "parse.cc" /* yacc.c:1646  */
    break;

  case 295:
#line 2006 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[-2].exprs), *(yyvsp[0].exprs));
		  delete (yyvsp[-2].exprs);
		  delete (yyvsp[0].exprs);
		  (yyval.exprs) = tmp;
		}
#line 7242 "parse.cc" /* yacc.c:1646  */
    break;

  case 296:
#line 2012 "parse.y" /* yacc.c:1646  */
    { (yyval.exprs) = (yyvsp[0].exprs); }
#line 7248 "parse.cc" /* yacc.c:1646  */
    break;

  case 297:
#line 2021 "parse.y" /* yacc.c:1646  */
    { pform_startmodule((yyvsp[0].text), (yylsp[-1]).text, (yylsp[-1]).first_line, (yyvsp[-2].named_pexprs)); }
#line 7254 "parse.cc" /* yacc.c:1646  */
    break;

  case 298:
#line 2025 "parse.y" /* yacc.c:1646  */
    { pform_module_set_ports((yyvsp[-2].mports)); }
#line 7260 "parse.cc" /* yacc.c:1646  */
    break;

  case 299:
#line 2028 "parse.y" /* yacc.c:1646  */
    { Module::UCDriveType ucd;
		  switch (uc_drive) {
		      case UCD_NONE:
		      default:
			ucd = Module::UCD_NONE;
			break;
		      case UCD_PULL0:
			ucd = Module::UCD_PULL0;
			break;
		      case UCD_PULL1:
			ucd = Module::UCD_PULL1;
			break;
		  }
		  pform_endmodule((yyvsp[-8].text), in_celldefine, ucd);
		  delete[](yyvsp[-8].text);
		}
#line 7281 "parse.cc" /* yacc.c:1646  */
    break;

  case 302:
#line 2050 "parse.y" /* yacc.c:1646  */
    { (yyval.mports) = 0; }
#line 7287 "parse.cc" /* yacc.c:1646  */
    break;

  case 303:
#line 2051 "parse.y" /* yacc.c:1646  */
    { (yyval.mports) = 0; }
#line 7293 "parse.cc" /* yacc.c:1646  */
    break;

  case 304:
#line 2055 "parse.y" /* yacc.c:1646  */
    { (yyval.mports) = (yyvsp[-1].mports); }
#line 7299 "parse.cc" /* yacc.c:1646  */
    break;

  case 305:
#line 2056 "parse.y" /* yacc.c:1646  */
    { (yyval.mports) = (yyvsp[-1].mports); }
#line 7305 "parse.cc" /* yacc.c:1646  */
    break;

  case 306:
#line 2057 "parse.y" /* yacc.c:1646  */
    { (yyval.mports) = 0; }
#line 7311 "parse.cc" /* yacc.c:1646  */
    break;

  case 312:
#line 2087 "parse.y" /* yacc.c:1646  */
    { ivl_variable_type_t dtype = (yyvsp[-5].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_makewire((yylsp[-6]), (yyvsp[-3].exprs), (yyvsp[-4].flag), (yyvsp[-1].perm_strings), (yyvsp[-6].nettype),
				 NetNet::NOT_A_PORT, dtype, (yyvsp[-7].named_pexprs));
		  if ((yyvsp[-2].exprs) != 0) {
			yyerror((yylsp[-2]), "sorry: net delays not supported.");
			delete (yyvsp[-2].exprs);
		  }
		  if ((yyvsp[-7].named_pexprs)) delete (yyvsp[-7].named_pexprs);
		}
#line 7327 "parse.cc" /* yacc.c:1646  */
    break;

  case 313:
#line 2107 "parse.y" /* yacc.c:1646  */
    { ivl_variable_type_t dtype = (yyvsp[-5].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_makewire((yylsp[-6]), (yyvsp[-3].exprs), (yyvsp[-4].flag), (yyvsp[-2].exprs),
				 str_strength, (yyvsp[-1].net_decl_assign), (yyvsp[-6].nettype), dtype);
		  if ((yyvsp[-7].named_pexprs)) {
			yyerror((yylsp[-6]), "sorry: Attributes not supported "
				"on net declaration assignments.");
			delete (yyvsp[-7].named_pexprs);
		  }
		}
#line 7343 "parse.cc" /* yacc.c:1646  */
    break;

  case 314:
#line 2126 "parse.y" /* yacc.c:1646  */
    { ivl_variable_type_t dtype = (yyvsp[-4].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_makewire((yylsp[-5]), 0, (yyvsp[-3].flag), 0, (yyvsp[-2].drive), (yyvsp[-1].net_decl_assign), (yyvsp[-5].nettype), dtype);
		  if ((yyvsp[-6].named_pexprs)) {
			yyerror((yylsp[-5]), "sorry: Attributes not supported "
				"on net declaration assignments.");
			delete (yyvsp[-6].named_pexprs);
		  }
		}
#line 7358 "parse.cc" /* yacc.c:1646  */
    break;

  case 315:
#line 2138 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-5]), "sorry: trireg nets not supported.");
		  delete (yyvsp[-3].exprs);
		  delete (yyvsp[-2].exprs);
		}
#line 7367 "parse.cc" /* yacc.c:1646  */
    break;

  case 316:
#line 2144 "parse.y" /* yacc.c:1646  */
    { pform_set_port_type((yylsp[-5]), (yyvsp[-1].perm_strings), (yyvsp[-3].exprs), (yyvsp[-4].flag), (yyvsp[-5].porttype));
		}
#line 7374 "parse.cc" /* yacc.c:1646  */
    break;

  case 317:
#line 2152 "parse.y" /* yacc.c:1646  */
    { pform_makewire((yylsp[-5]), (yyvsp[-2].exprs), (yyvsp[-3].flag), (yyvsp[-1].perm_strings), (yyvsp[-4].nettype), (yyvsp[-5].porttype), IVL_VT_NO_TYPE, 0,
		                 SR_BOTH);
		}
#line 7382 "parse.cc" /* yacc.c:1646  */
    break;

  case 318:
#line 2157 "parse.y" /* yacc.c:1646  */
    { list<pair<perm_string,PExpr*> >::const_iterator pp;
		  list<perm_string>*tmp = new list<perm_string>;
		  for (pp = (yyvsp[-1].port_list)->begin(); pp != (yyvsp[-1].port_list)->end(); pp++) {
			tmp->push_back((*pp).first);
		  }
		  pform_makewire((yylsp[-5]), (yyvsp[-2].exprs), (yyvsp[-3].flag), tmp, (yyvsp[-4].nettype), NetNet::POUTPUT,
		                 IVL_VT_NO_TYPE, 0, SR_BOTH);
		  for (pp = (yyvsp[-1].port_list)->begin(); pp != (yyvsp[-1].port_list)->end(); pp++) {
			if ((*pp).second) {
			      pform_make_reginit((yylsp[-5]), (*pp).first, (*pp).second);
			}
		  }
		  delete (yyvsp[-1].port_list);
		}
#line 7401 "parse.cc" /* yacc.c:1646  */
    break;

  case 319:
#line 2177 "parse.y" /* yacc.c:1646  */
    { pform_makewire((yylsp[-5]), (yyvsp[-2].exprs), (yyvsp[-3].flag), (yyvsp[-1].perm_strings), (yyvsp[-4].nettype), NetNet::PINPUT,
				 IVL_VT_NO_TYPE, 0);
		  yyerror((yylsp[-4]), "error: reg variables cannot be inputs.");
		}
#line 7410 "parse.cc" /* yacc.c:1646  */
    break;

  case 320:
#line 2183 "parse.y" /* yacc.c:1646  */
    { pform_makewire((yylsp[-5]), (yyvsp[-2].exprs), (yyvsp[-3].flag), (yyvsp[-1].perm_strings), (yyvsp[-4].nettype), NetNet::PINOUT,
				 IVL_VT_NO_TYPE, 0);
		  yyerror((yylsp[-4]), "error: reg variables cannot be inouts.");
		}
#line 7419 "parse.cc" /* yacc.c:1646  */
    break;

  case 321:
#line 2189 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-5]), "error: Invalid variable list"
			  " in port declaration.");
		  if ((yyvsp[-3].exprs)) delete (yyvsp[-3].exprs);
		  if ((yyvsp[-2].exprs)) delete (yyvsp[-2].exprs);
		  yyerrok;
		}
#line 7430 "parse.cc" /* yacc.c:1646  */
    break;

  case 322:
#line 2200 "parse.y" /* yacc.c:1646  */
    { pform_attach_discipline((yylsp[-2]), (yyvsp[-2].discipline), (yyvsp[-1].perm_strings)); }
#line 7436 "parse.cc" /* yacc.c:1646  */
    break;

  case 325:
#line 2216 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yyvsp[-2].gatetype), str_strength, 0, (yyvsp[-1].gates), (yyvsp[-3].named_pexprs));
		}
#line 7443 "parse.cc" /* yacc.c:1646  */
    break;

  case 326:
#line 2220 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yyvsp[-3].gatetype), str_strength, (yyvsp[-2].exprs), (yyvsp[-1].gates), (yyvsp[-4].named_pexprs));
		}
#line 7450 "parse.cc" /* yacc.c:1646  */
    break;

  case 327:
#line 2224 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yyvsp[-3].gatetype), (yyvsp[-2].drive), 0, (yyvsp[-1].gates), (yyvsp[-4].named_pexprs));
		}
#line 7457 "parse.cc" /* yacc.c:1646  */
    break;

  case 328:
#line 2228 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yyvsp[-4].gatetype), (yyvsp[-3].drive), (yyvsp[-2].exprs), (yyvsp[-1].gates), (yyvsp[-5].named_pexprs));
		}
#line 7464 "parse.cc" /* yacc.c:1646  */
    break;

  case 329:
#line 2233 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yyvsp[-2].gatetype), str_strength, 0, (yyvsp[-1].gates), (yyvsp[-3].named_pexprs));
		}
#line 7471 "parse.cc" /* yacc.c:1646  */
    break;

  case 330:
#line 2237 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yyvsp[-3].gatetype), str_strength, (yyvsp[-2].exprs), (yyvsp[-1].gates), (yyvsp[-4].named_pexprs));
		}
#line 7478 "parse.cc" /* yacc.c:1646  */
    break;

  case 331:
#line 2244 "parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLUP, pull_strength, 0,
				  (yyvsp[-1].gates), 0);
		}
#line 7486 "parse.cc" /* yacc.c:1646  */
    break;

  case 332:
#line 2248 "parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLDOWN, pull_strength,
				  0, (yyvsp[-1].gates), 0);
		}
#line 7494 "parse.cc" /* yacc.c:1646  */
    break;

  case 333:
#line 2253 "parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLUP, (yyvsp[-3].drive), 0, (yyvsp[-1].gates), 0);
		}
#line 7501 "parse.cc" /* yacc.c:1646  */
    break;

  case 334:
#line 2257 "parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLUP, (yyvsp[-5].drive), 0, (yyvsp[-1].gates), 0);
		}
#line 7508 "parse.cc" /* yacc.c:1646  */
    break;

  case 335:
#line 2261 "parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLUP, (yyvsp[-3].drive), 0, (yyvsp[-1].gates), 0);
		}
#line 7515 "parse.cc" /* yacc.c:1646  */
    break;

  case 336:
#line 2265 "parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLDOWN, (yyvsp[-3].drive), 0, (yyvsp[-1].gates), 0);
		}
#line 7522 "parse.cc" /* yacc.c:1646  */
    break;

  case 337:
#line 2269 "parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLDOWN, (yyvsp[-3].drive), 0, (yyvsp[-1].gates), 0);
		}
#line 7529 "parse.cc" /* yacc.c:1646  */
    break;

  case 338:
#line 2273 "parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLDOWN, (yyvsp[-5].drive), 0, (yyvsp[-1].gates), 0);
		}
#line 7536 "parse.cc" /* yacc.c:1646  */
    break;

  case 339:
#line 2282 "parse.y" /* yacc.c:1646  */
    { perm_string tmp1 = lex_strings.make((yyvsp[-3].text));
		  pform_make_modgates(tmp1, (yyvsp[-2].parmvalue), (yyvsp[-1].gates));
		  delete[](yyvsp[-3].text);
		  if ((yyvsp[-4].named_pexprs)) delete (yyvsp[-4].named_pexprs);
		}
#line 7546 "parse.cc" /* yacc.c:1646  */
    break;

  case 340:
#line 2290 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: Invalid module instantiation");
		  delete[](yyvsp[-3].text);
		  if ((yyvsp[-4].named_pexprs)) delete (yyvsp[-4].named_pexprs);
		}
#line 7555 "parse.cc" /* yacc.c:1646  */
    break;

  case 341:
#line 2300 "parse.y" /* yacc.c:1646  */
    { pform_make_pgassign_list((yyvsp[-1].exprs), (yyvsp[-2].exprs), (yyvsp[-3].drive), (yylsp[-4]).text, (yylsp[-4]).first_line); }
#line 7561 "parse.cc" /* yacc.c:1646  */
    break;

  case 342:
#line 2305 "parse.y" /* yacc.c:1646  */
    { PProcess*tmp = pform_make_behavior(IVL_PR_ALWAYS, (yyvsp[0].statement), (yyvsp[-2].named_pexprs));
	FILE_NAME(tmp, (yylsp[-1]));
      }
#line 7569 "parse.cc" /* yacc.c:1646  */
    break;

  case 343:
#line 2309 "parse.y" /* yacc.c:1646  */
    { PProcess*tmp = pform_make_behavior(IVL_PR_INITIAL, (yyvsp[0].statement), (yyvsp[-2].named_pexprs));
	FILE_NAME(tmp, (yylsp[-1]));
      }
#line 7577 "parse.cc" /* yacc.c:1646  */
    break;

  case 344:
#line 2314 "parse.y" /* yacc.c:1646  */
    { pform_make_analog_behavior((yylsp[-1]), IVL_PR_ALWAYS, (yyvsp[0].statement)); }
#line 7583 "parse.cc" /* yacc.c:1646  */
    break;

  case 345:
#line 2325 "parse.y" /* yacc.c:1646  */
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yylsp[-3]), (yyvsp[-1].text), (yyvsp[-2].flag));
      }
#line 7591 "parse.cc" /* yacc.c:1646  */
    break;

  case 346:
#line 2331 "parse.y" /* yacc.c:1646  */
    { current_task->set_ports((yyvsp[-2].wires));
	current_task->set_statement((yyvsp[-1].statement));
	pform_pop_scope();
	current_task = 0;
	delete[](yyvsp[-5].text);
      }
#line 7602 "parse.cc" /* yacc.c:1646  */
    break;

  case 347:
#line 2339 "parse.y" /* yacc.c:1646  */
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yylsp[-3]), (yyvsp[-1].text), (yyvsp[-2].flag));
      }
#line 7610 "parse.cc" /* yacc.c:1646  */
    break;

  case 348:
#line 2346 "parse.y" /* yacc.c:1646  */
    { current_task->set_ports((yyvsp[-5].wires));
	current_task->set_statement((yyvsp[-1].statement));
	pform_pop_scope();
	current_task = 0;
	delete[](yyvsp[-8].text);
      }
#line 7621 "parse.cc" /* yacc.c:1646  */
    break;

  case 349:
#line 2354 "parse.y" /* yacc.c:1646  */
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yylsp[-5]), (yyvsp[-3].text), (yyvsp[-4].flag));
      }
#line 7629 "parse.cc" /* yacc.c:1646  */
    break;

  case 350:
#line 2360 "parse.y" /* yacc.c:1646  */
    { current_task->set_ports(0);
	current_task->set_statement((yyvsp[-1].statement));
	pform_pop_scope();
	current_task = 0;
	cerr << (yylsp[-7]) << ": warning: task definition for \"" << (yyvsp[-7].text)
	     << "\" has an empty port declaration list!" << endl;
	delete[](yyvsp[-7].text);
      }
#line 7642 "parse.cc" /* yacc.c:1646  */
    break;

  case 351:
#line 2370 "parse.y" /* yacc.c:1646  */
    {
	assert(current_task == 0);
	delete[](yyvsp[-2].text);
      }
#line 7651 "parse.cc" /* yacc.c:1646  */
    break;

  case 352:
#line 2381 "parse.y" /* yacc.c:1646  */
    { assert(current_function == 0);
	current_function = pform_push_function_scope((yylsp[-4]), (yyvsp[-1].text), (yyvsp[-3].flag));
      }
#line 7659 "parse.cc" /* yacc.c:1646  */
    break;

  case 353:
#line 2386 "parse.y" /* yacc.c:1646  */
    { current_function->set_ports((yyvsp[-2].wires));
	current_function->set_statement((yyvsp[-1].statement));
	current_function->set_return((yyvsp[-6].function_type));
	pform_pop_scope();
	current_function = 0;
	delete[](yyvsp[-5].text);
      }
#line 7671 "parse.cc" /* yacc.c:1646  */
    break;

  case 354:
#line 2395 "parse.y" /* yacc.c:1646  */
    { assert(current_function == 0);
	current_function = pform_push_function_scope((yylsp[-3]), (yyvsp[0].text), (yyvsp[-2].flag));
      }
#line 7679 "parse.cc" /* yacc.c:1646  */
    break;

  case 355:
#line 2402 "parse.y" /* yacc.c:1646  */
    { current_function->set_ports((yyvsp[-5].wires));
	current_function->set_statement((yyvsp[-1].statement));
	current_function->set_return((yyvsp[-9].function_type));
	pform_pop_scope();
	current_function = 0;
	delete[](yyvsp[-8].text);
      }
#line 7691 "parse.cc" /* yacc.c:1646  */
    break;

  case 356:
#line 2410 "parse.y" /* yacc.c:1646  */
    {
	if (current_function != 0) {
	      pform_pop_scope();
	      current_function = 0;
	}
	delete[](yyvsp[-2].text);
      }
#line 7703 "parse.cc" /* yacc.c:1646  */
    break;

  case 358:
#line 2425 "parse.y" /* yacc.c:1646  */
    { pform_genvars((yylsp[-2]), (yyvsp[-1].perm_strings)); }
#line 7709 "parse.cc" /* yacc.c:1646  */
    break;

  case 359:
#line 2430 "parse.y" /* yacc.c:1646  */
    { pform_start_generate_for((yylsp[-11]), (yyvsp[-9].text), (yyvsp[-7].expr), (yyvsp[-5].expr), (yyvsp[-3].text), (yyvsp[-1].expr)); }
#line 7715 "parse.cc" /* yacc.c:1646  */
    break;

  case 360:
#line 2432 "parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 7721 "parse.cc" /* yacc.c:1646  */
    break;

  case 361:
#line 2437 "parse.y" /* yacc.c:1646  */
    { pform_start_generate_else((yylsp[-2])); }
#line 7727 "parse.cc" /* yacc.c:1646  */
    break;

  case 362:
#line 2439 "parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 7733 "parse.cc" /* yacc.c:1646  */
    break;

  case 363:
#line 2443 "parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 7739 "parse.cc" /* yacc.c:1646  */
    break;

  case 364:
#line 2446 "parse.y" /* yacc.c:1646  */
    { pform_start_generate_case((yylsp[-3]), (yyvsp[-1].expr)); }
#line 7745 "parse.cc" /* yacc.c:1646  */
    break;

  case 365:
#line 2449 "parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 7751 "parse.cc" /* yacc.c:1646  */
    break;

  case 366:
#line 2453 "parse.y" /* yacc.c:1646  */
    { /* Detect and warn about anachronistic begin/end use */
	if (generation_flag > GN_VER2001) {
	      warn_count += 1;
	      cerr << (yylsp[-3]) << ": warning: Anachronistic use of begin/end to surround generate schemes." << endl;
	}
      }
#line 7762 "parse.cc" /* yacc.c:1646  */
    break;

  case 367:
#line 2459 "parse.y" /* yacc.c:1646  */
    {
	pform_start_generate_nblock((yylsp[-2]), (yyvsp[0].text));
      }
#line 7770 "parse.cc" /* yacc.c:1646  */
    break;

  case 368:
#line 2462 "parse.y" /* yacc.c:1646  */
    { /* Detect and warn about anachronistic named begin/end use */
	if (generation_flag > GN_VER2001) {
	      warn_count += 1;
	      cerr << (yylsp[-6]) << ": warning: Anachronistic use of named begin/end to surround generate schemes." << endl;
	}
	pform_endgenerate();
      }
#line 7782 "parse.cc" /* yacc.c:1646  */
    break;

  case 369:
#line 2473 "parse.y" /* yacc.c:1646  */
    { /* empty lists are legal syntax. */ }
#line 7788 "parse.cc" /* yacc.c:1646  */
    break;

  case 370:
#line 2476 "parse.y" /* yacc.c:1646  */
    {
		}
#line 7795 "parse.cc" /* yacc.c:1646  */
    break;

  case 371:
#line 2480 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in specify block");
		  yyerrok;
		}
#line 7803 "parse.cc" /* yacc.c:1646  */
    break;

  case 372:
#line 2489 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: missing endmodule or attempt to "
		              "nest modules.");
		  pform_error_nested_modules();
		  yyerrok;
		}
#line 7813 "parse.cc" /* yacc.c:1646  */
    break;

  case 373:
#line 2496 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[0]), "error: invalid module item.");
		  yyerrok;
		}
#line 7821 "parse.cc" /* yacc.c:1646  */
    break;

  case 374:
#line 2501 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-4]), "error: syntax error in left side "
			  "of continuous assignment.");
		  yyerrok;
		}
#line 7830 "parse.cc" /* yacc.c:1646  */
    break;

  case 375:
#line 2507 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in "
			  "continuous assignment");
		  yyerrok;
		}
#line 7839 "parse.cc" /* yacc.c:1646  */
    break;

  case 376:
#line 2513 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: I give up on this "
			  "function definition.");
		  yyerrok;
		}
#line 7848 "parse.cc" /* yacc.c:1646  */
    break;

  case 377:
#line 2522 "parse.y" /* yacc.c:1646  */
    { perm_string tmp3 = lex_strings.make((yyvsp[-6].text));
		  perm_string tmp5 = lex_strings.make((yyvsp[-4].text));
		  pform_set_attrib(tmp3, tmp5, (yyvsp[-2].text));
		  delete[] (yyvsp[-6].text);
		  delete[] (yyvsp[-4].text);
		}
#line 7859 "parse.cc" /* yacc.c:1646  */
    break;

  case 378:
#line 2529 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-4]), "error: Malformed $attribute parameter list."); }
#line 7865 "parse.cc" /* yacc.c:1646  */
    break;

  case 379:
#line 2533 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 7871 "parse.cc" /* yacc.c:1646  */
    break;

  case 380:
#line 2534 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false;}
#line 7877 "parse.cc" /* yacc.c:1646  */
    break;

  case 381:
#line 2537 "parse.y" /* yacc.c:1646  */
    { pform_start_generate_if((yylsp[-3]), (yyvsp[-1].expr)); }
#line 7883 "parse.cc" /* yacc.c:1646  */
    break;

  case 384:
#line 2545 "parse.y" /* yacc.c:1646  */
    { pform_generate_case_item((yylsp[-1]), (yyvsp[-1].exprs)); }
#line 7889 "parse.cc" /* yacc.c:1646  */
    break;

  case 385:
#line 2546 "parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 7895 "parse.cc" /* yacc.c:1646  */
    break;

  case 386:
#line 2547 "parse.y" /* yacc.c:1646  */
    { pform_generate_case_item((yylsp[-1]), 0); }
#line 7901 "parse.cc" /* yacc.c:1646  */
    break;

  case 387:
#line 2548 "parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 7907 "parse.cc" /* yacc.c:1646  */
    break;

  case 394:
#line 2571 "parse.y" /* yacc.c:1646  */
    { pform_generate_block_name((yyvsp[-2].text)); }
#line 7913 "parse.cc" /* yacc.c:1646  */
    break;

  case 397:
#line 2586 "parse.y" /* yacc.c:1646  */
    { net_decl_assign_t*tmp = new net_decl_assign_t;
	tmp->next = tmp;
	tmp->name = lex_strings.make((yyvsp[-2].text));
	tmp->expr = (yyvsp[0].expr);
	delete[](yyvsp[-2].text);
	(yyval.net_decl_assign) = tmp;
      }
#line 7925 "parse.cc" /* yacc.c:1646  */
    break;

  case 398:
#line 2597 "parse.y" /* yacc.c:1646  */
    { net_decl_assign_t*tmp = (yyvsp[-2].net_decl_assign);
		  (yyvsp[0].net_decl_assign)->next = tmp->next;
		  tmp->next = (yyvsp[0].net_decl_assign);
		  (yyval.net_decl_assign) = tmp;
		}
#line 7935 "parse.cc" /* yacc.c:1646  */
    break;

  case 399:
#line 2603 "parse.y" /* yacc.c:1646  */
    { (yyval.net_decl_assign) = (yyvsp[0].net_decl_assign);
		}
#line 7942 "parse.cc" /* yacc.c:1646  */
    break;

  case 400:
#line 2608 "parse.y" /* yacc.c:1646  */
    { (yyval.datatype) = IVL_VT_LOGIC; }
#line 7948 "parse.cc" /* yacc.c:1646  */
    break;

  case 401:
#line 2609 "parse.y" /* yacc.c:1646  */
    { (yyval.datatype) = IVL_VT_BOOL; }
#line 7954 "parse.cc" /* yacc.c:1646  */
    break;

  case 402:
#line 2610 "parse.y" /* yacc.c:1646  */
    { (yyval.datatype) = IVL_VT_REAL; }
#line 7960 "parse.cc" /* yacc.c:1646  */
    break;

  case 403:
#line 2613 "parse.y" /* yacc.c:1646  */
    { (yyval.datatype) = (yyvsp[0].datatype); }
#line 7966 "parse.cc" /* yacc.c:1646  */
    break;

  case 404:
#line 2613 "parse.y" /* yacc.c:1646  */
    { (yyval.datatype) = IVL_VT_NO_TYPE; }
#line 7972 "parse.cc" /* yacc.c:1646  */
    break;

  case 405:
#line 2616 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::WIRE; }
#line 7978 "parse.cc" /* yacc.c:1646  */
    break;

  case 406:
#line 2617 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRI; }
#line 7984 "parse.cc" /* yacc.c:1646  */
    break;

  case 407:
#line 2618 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRI1; }
#line 7990 "parse.cc" /* yacc.c:1646  */
    break;

  case 408:
#line 2619 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::SUPPLY0; }
#line 7996 "parse.cc" /* yacc.c:1646  */
    break;

  case 409:
#line 2620 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::WAND; }
#line 8002 "parse.cc" /* yacc.c:1646  */
    break;

  case 410:
#line 2621 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRIAND; }
#line 8008 "parse.cc" /* yacc.c:1646  */
    break;

  case 411:
#line 2622 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRI0; }
#line 8014 "parse.cc" /* yacc.c:1646  */
    break;

  case 412:
#line 2623 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::SUPPLY1; }
#line 8020 "parse.cc" /* yacc.c:1646  */
    break;

  case 413:
#line 2624 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::WOR; }
#line 8026 "parse.cc" /* yacc.c:1646  */
    break;

  case 414:
#line 2625 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRIOR; }
#line 8032 "parse.cc" /* yacc.c:1646  */
    break;

  case 415:
#line 2626 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::UWIRE;
		      cerr << (yylsp[0]).text << ":" << (yylsp[0]).first_line << ": warning: "
		              "'wone' is deprecated, please use 'uwire' "
		              "instead." << endl;
		    }
#line 8042 "parse.cc" /* yacc.c:1646  */
    break;

  case 416:
#line 2631 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::UWIRE; }
#line 8048 "parse.cc" /* yacc.c:1646  */
    break;

  case 417:
#line 2635 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::REG; }
#line 8054 "parse.cc" /* yacc.c:1646  */
    break;

  case 418:
#line 2640 "parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8063 "parse.cc" /* yacc.c:1646  */
    break;

  case 419:
#line 2645 "parse.y" /* yacc.c:1646  */
    { param_active_range = (yyvsp[0].exprs);
        param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8072 "parse.cc" /* yacc.c:1646  */
    break;

  case 420:
#line 2650 "parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8081 "parse.cc" /* yacc.c:1646  */
    break;

  case 421:
#line 2655 "parse.y" /* yacc.c:1646  */
    { param_active_range = (yyvsp[0].exprs);
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8090 "parse.cc" /* yacc.c:1646  */
    break;

  case 422:
#line 2660 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum(integer_width-1, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The default range is [31:0] */
        param_active_range = range_stub;
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8106 "parse.cc" /* yacc.c:1646  */
    break;

  case 423:
#line 2672 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum((uint64_t)63, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The range is [63:0] */
        param_active_range = range_stub;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8122 "parse.cc" /* yacc.c:1646  */
    break;

  case 424:
#line 2684 "parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
	param_active_signed = true;
	param_active_type = IVL_VT_REAL;
      }
#line 8131 "parse.cc" /* yacc.c:1646  */
    break;

  case 429:
#line 2707 "parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[-1].expr);
	pform_set_parameter((yylsp[-3]), lex_strings.make((yyvsp[-3].text)), param_active_type,
			    param_active_signed, param_active_range, tmp, (yyvsp[0].value_range));
	delete[](yyvsp[-3].text);
      }
#line 8141 "parse.cc" /* yacc.c:1646  */
    break;

  case 430:
#line 2716 "parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[0].expr);
	pform_set_localparam((yylsp[-2]), lex_strings.make((yyvsp[-2].text)), param_active_type,
			     param_active_signed, param_active_range, tmp);
	delete[](yyvsp[-2].text);
      }
#line 8151 "parse.cc" /* yacc.c:1646  */
    break;

  case 431:
#line 2723 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = (yyvsp[0].value_range); }
#line 8157 "parse.cc" /* yacc.c:1646  */
    break;

  case 432:
#line 2723 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = 0; }
#line 8163 "parse.cc" /* yacc.c:1646  */
    break;

  case 433:
#line 2727 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = (yyvsp[0].value_range); (yyval.value_range)->next = (yyvsp[-1].value_range); }
#line 8169 "parse.cc" /* yacc.c:1646  */
    break;

  case 434:
#line 2729 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = (yyvsp[0].value_range); (yyval.value_range)->next = 0; }
#line 8175 "parse.cc" /* yacc.c:1646  */
    break;

  case 435:
#line 2734 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[-5].flag), false, (yyvsp[-3].expr), false, (yyvsp[-1].expr)); }
#line 8181 "parse.cc" /* yacc.c:1646  */
    break;

  case 436:
#line 2736 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[-5].flag), false, (yyvsp[-3].expr), true, (yyvsp[-1].expr)); }
#line 8187 "parse.cc" /* yacc.c:1646  */
    break;

  case 437:
#line 2738 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[-5].flag), true, (yyvsp[-3].expr), false, (yyvsp[-1].expr)); }
#line 8193 "parse.cc" /* yacc.c:1646  */
    break;

  case 438:
#line 2740 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[-5].flag), true, (yyvsp[-3].expr), true, (yyvsp[-1].expr)); }
#line 8199 "parse.cc" /* yacc.c:1646  */
    break;

  case 439:
#line 2742 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range(true, false, (yyvsp[0].expr), false, (yyvsp[0].expr)); }
#line 8205 "parse.cc" /* yacc.c:1646  */
    break;

  case 440:
#line 2746 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 8211 "parse.cc" /* yacc.c:1646  */
    break;

  case 441:
#line 2747 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 8217 "parse.cc" /* yacc.c:1646  */
    break;

  case 442:
#line 2748 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 8223 "parse.cc" /* yacc.c:1646  */
    break;

  case 443:
#line 2749 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 8229 "parse.cc" /* yacc.c:1646  */
    break;

  case 444:
#line 2752 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 8235 "parse.cc" /* yacc.c:1646  */
    break;

  case 445:
#line 2752 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 8241 "parse.cc" /* yacc.c:1646  */
    break;

  case 446:
#line 2772 "parse.y" /* yacc.c:1646  */
    { struct parmvalue_t*tmp = new struct parmvalue_t;
		  tmp->by_order = (yyvsp[-1].exprs);
		  tmp->by_name = 0;
		  (yyval.parmvalue) = tmp;
		}
#line 8251 "parse.cc" /* yacc.c:1646  */
    break;

  case 447:
#line 2778 "parse.y" /* yacc.c:1646  */
    { struct parmvalue_t*tmp = new struct parmvalue_t;
		  tmp->by_order = 0;
		  tmp->by_name = (yyvsp[-1].named_pexprs);
		  (yyval.parmvalue) = tmp;
		}
#line 8261 "parse.cc" /* yacc.c:1646  */
    break;

  case 448:
#line 2784 "parse.y" /* yacc.c:1646  */
    { assert((yyvsp[0].number));
		  PENumber*tmp = new PENumber((yyvsp[0].number));
		  FILE_NAME(tmp, (yylsp[-1]));

		  struct parmvalue_t*lst = new struct parmvalue_t;
		  lst->by_order = new svector<PExpr*>(1);
		  (*lst->by_order)[0] = tmp;
		  lst->by_name = 0;
		  (yyval.parmvalue) = lst;
		  based_size = 0;
		}
#line 8277 "parse.cc" /* yacc.c:1646  */
    break;

  case 449:
#line 2796 "parse.y" /* yacc.c:1646  */
    { assert((yyvsp[0].realtime));
		  PEFNumber*tmp = new PEFNumber((yyvsp[0].realtime));
		  FILE_NAME(tmp, (yylsp[-1]));

		  struct parmvalue_t*lst = new struct parmvalue_t;
		  lst->by_order = new svector<PExpr*>(1);
		  (*lst->by_order)[0] = tmp;
		  lst->by_name = 0;
		  (yyval.parmvalue) = lst;
		}
#line 8292 "parse.cc" /* yacc.c:1646  */
    break;

  case 450:
#line 2807 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: syntax error in parameter value "
			  "assignment list.");
		  (yyval.parmvalue) = 0;
		}
#line 8301 "parse.cc" /* yacc.c:1646  */
    break;

  case 451:
#line 2812 "parse.y" /* yacc.c:1646  */
    { (yyval.parmvalue) = 0; }
#line 8307 "parse.cc" /* yacc.c:1646  */
    break;

  case 452:
#line 2817 "parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-3].text));
		  tmp->parm = (yyvsp[-1].expr);
		  delete[](yyvsp[-3].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 8318 "parse.cc" /* yacc.c:1646  */
    break;

  case 453:
#line 2824 "parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-2].text));
		  tmp->parm = 0;
		  delete[](yyvsp[-2].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 8329 "parse.cc" /* yacc.c:1646  */
    break;

  case 454:
#line 2834 "parse.y" /* yacc.c:1646  */
    { svector<named_pexpr_t*>*tmp = new svector<named_pexpr_t*>(1);
		  (*tmp)[0] = (yyvsp[0].named_pexpr);
		  (yyval.named_pexprs) = tmp;
		}
#line 8338 "parse.cc" /* yacc.c:1646  */
    break;

  case 455:
#line 2839 "parse.y" /* yacc.c:1646  */
    { svector<named_pexpr_t*>*tmp =
			new svector<named_pexpr_t*>(*(yyvsp[-2].named_pexprs),(yyvsp[0].named_pexpr));
		  delete (yyvsp[-2].named_pexprs);
		  (yyval.named_pexprs) = tmp;
		}
#line 8348 "parse.cc" /* yacc.c:1646  */
    break;

  case 456:
#line 2862 "parse.y" /* yacc.c:1646  */
    { (yyval.mport) = (yyvsp[0].mport); }
#line 8354 "parse.cc" /* yacc.c:1646  */
    break;

  case 457:
#line 2870 "parse.y" /* yacc.c:1646  */
    { Module::port_t*tmp = (yyvsp[-1].mport);
		  tmp->name = lex_strings.make((yyvsp[-3].text));
		  delete[](yyvsp[-3].text);
		  (yyval.mport) = tmp;
		}
#line 8364 "parse.cc" /* yacc.c:1646  */
    break;

  case 458:
#line 2881 "parse.y" /* yacc.c:1646  */
    { Module::port_t*tmp = (yyvsp[-1].mport);
		  tmp->name = perm_string();
		  (yyval.mport) = tmp;
		}
#line 8373 "parse.cc" /* yacc.c:1646  */
    break;

  case 459:
#line 2890 "parse.y" /* yacc.c:1646  */
    { Module::port_t*tmp = (yyvsp[-2].mport);
		  tmp->name = lex_strings.make((yyvsp[-5].text));
		  delete[](yyvsp[-5].text);
		  (yyval.mport) = tmp;
		}
#line 8383 "parse.cc" /* yacc.c:1646  */
    break;

  case 460:
#line 2898 "parse.y" /* yacc.c:1646  */
    { (yyval.mport) = (yyvsp[0].mport); }
#line 8389 "parse.cc" /* yacc.c:1646  */
    break;

  case 461:
#line 2899 "parse.y" /* yacc.c:1646  */
    { (yyval.mport) = 0; }
#line 8395 "parse.cc" /* yacc.c:1646  */
    break;

  case 462:
#line 2916 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	  perm_string name = lex_strings.make((yyvsp[0].text));
	  ptmp = pform_module_port_reference(name, (yylsp[0]).text, (yylsp[0]).first_line);
	  delete[](yyvsp[0].text);
	  (yyval.mport) = ptmp;
	}
#line 8406 "parse.cc" /* yacc.c:1646  */
    break;

  case 463:
#line 2924 "parse.y" /* yacc.c:1646  */
    { index_component_t itmp;
	  itmp.sel = index_component_t::SEL_PART;
	  itmp.msb = (yyvsp[-3].expr);
	  itmp.lsb = (yyvsp[-1].expr);

	  name_component_t ntmp (lex_strings.make((yyvsp[-5].text)));
	  ntmp.index.push_back(itmp);

	  pform_name_t pname;
	  pname.push_back(ntmp);

	  PEIdent*wtmp = new PEIdent(pname);
	  FILE_NAME(wtmp, (yylsp[-5]));

	  Module::port_t*ptmp = new Module::port_t;
	  ptmp->name = perm_string();
	  ptmp->expr.push_back(wtmp);

	  delete[](yyvsp[-5].text);
	  (yyval.mport) = ptmp;
	}
#line 8432 "parse.cc" /* yacc.c:1646  */
    break;

  case 464:
#line 2947 "parse.y" /* yacc.c:1646  */
    { index_component_t itmp;
	  itmp.sel = index_component_t::SEL_BIT;
	  itmp.msb = (yyvsp[-1].expr);
	  itmp.lsb = 0;

	  name_component_t ntmp (lex_strings.make((yyvsp[-3].text)));
	  ntmp.index.push_back(itmp);

	  pform_name_t pname;
	  pname.push_back(ntmp);

	  PEIdent*tmp = new PEIdent(pname);
	  FILE_NAME(tmp, (yylsp[-3]));

	  Module::port_t*ptmp = new Module::port_t;
	  ptmp->name = perm_string();
	  ptmp->expr.push_back(tmp);
	  delete[](yyvsp[-3].text);
	  (yyval.mport) = ptmp;
	}
#line 8457 "parse.cc" /* yacc.c:1646  */
    break;

  case 465:
#line 2969 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: invalid port bit select");
	  Module::port_t*ptmp = new Module::port_t;
	  PEIdent*wtmp = new PEIdent(lex_strings.make((yyvsp[-3].text)));
	  FILE_NAME(wtmp, (yylsp[-3]));
	  ptmp->name = lex_strings.make((yyvsp[-3].text));
	  ptmp->expr.push_back(wtmp);
	  delete[](yyvsp[-3].text);
	  (yyval.mport) = ptmp;
	}
#line 8471 "parse.cc" /* yacc.c:1646  */
    break;

  case 466:
#line 2983 "parse.y" /* yacc.c:1646  */
    { (yyval.mport) = (yyvsp[0].mport); }
#line 8477 "parse.cc" /* yacc.c:1646  */
    break;

  case 467:
#line 2985 "parse.y" /* yacc.c:1646  */
    { Module::port_t*tmp = (yyvsp[-2].mport);
		  append(tmp->expr, (yyvsp[0].mport)->expr);
		  delete (yyvsp[0].mport);
		  (yyval.mport) = tmp;
		}
#line 8487 "parse.cc" /* yacc.c:1646  */
    break;

  case 468:
#line 2998 "parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-3].text));
		  tmp->parm = (yyvsp[-1].expr);
		  delete[](yyvsp[-3].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 8498 "parse.cc" /* yacc.c:1646  */
    break;

  case 469:
#line 3005 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: invalid port connection expression.");
		  named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-3].text));
		  tmp->parm = 0;
		  delete[](yyvsp[-3].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 8510 "parse.cc" /* yacc.c:1646  */
    break;

  case 470:
#line 3013 "parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-2].text));
		  tmp->parm = 0;
		  delete[](yyvsp[-2].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 8521 "parse.cc" /* yacc.c:1646  */
    break;

  case 471:
#line 3023 "parse.y" /* yacc.c:1646  */
    { svector<named_pexpr_t*>*tmp;
		  tmp = new svector<named_pexpr_t*>(*(yyvsp[-2].named_pexprs), (yyvsp[0].named_pexpr));
		  delete (yyvsp[-2].named_pexprs);
		  (yyval.named_pexprs) = tmp;
		}
#line 8531 "parse.cc" /* yacc.c:1646  */
    break;

  case 472:
#line 3029 "parse.y" /* yacc.c:1646  */
    { svector<named_pexpr_t*>*tmp = new svector<named_pexpr_t*>(1);
		  (*tmp)[0] = (yyvsp[0].named_pexpr);
		  (yyval.named_pexprs) = tmp;
		}
#line 8540 "parse.cc" /* yacc.c:1646  */
    break;

  case 473:
#line 3036 "parse.y" /* yacc.c:1646  */
    { (yyval.porttype) = NetNet::PINPUT; }
#line 8546 "parse.cc" /* yacc.c:1646  */
    break;

  case 474:
#line 3037 "parse.y" /* yacc.c:1646  */
    { (yyval.porttype) = NetNet::POUTPUT; }
#line 8552 "parse.cc" /* yacc.c:1646  */
    break;

  case 475:
#line 3038 "parse.y" /* yacc.c:1646  */
    { (yyval.porttype) = NetNet::PINOUT; }
#line 8558 "parse.cc" /* yacc.c:1646  */
    break;

  case 476:
#line 3043 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*> (2);
		  (*tmp)[0] = (yyvsp[-3].expr);
		  (*tmp)[1] = (yyvsp[-1].expr);
		  (yyval.exprs) = tmp;
		}
#line 8568 "parse.cc" /* yacc.c:1646  */
    break;

  case 478:
#line 3052 "parse.y" /* yacc.c:1646  */
    { (yyval.exprs) = 0; }
#line 8574 "parse.cc" /* yacc.c:1646  */
    break;

  case 479:
#line 3055 "parse.y" /* yacc.c:1646  */
    { (yyval.dimensions) = 0; }
#line 8580 "parse.cc" /* yacc.c:1646  */
    break;

  case 480:
#line 3056 "parse.y" /* yacc.c:1646  */
    { (yyval.dimensions) = (yyvsp[0].dimensions); }
#line 8586 "parse.cc" /* yacc.c:1646  */
    break;

  case 481:
#line 3061 "parse.y" /* yacc.c:1646  */
    { list<index_component_t> *tmp = new list<index_component_t>;
		  index_component_t index;
		  index.msb = (yyvsp[-3].expr);
		  index.lsb = (yyvsp[-1].expr);
		  tmp->push_back(index);
		  (yyval.dimensions) = tmp;
		}
#line 8598 "parse.cc" /* yacc.c:1646  */
    break;

  case 482:
#line 3069 "parse.y" /* yacc.c:1646  */
    { list<index_component_t> *tmp = (yyvsp[-5].dimensions);
		  index_component_t index;
		  index.msb = (yyvsp[-3].expr);
		  index.lsb = (yyvsp[-1].expr);
		  tmp->push_back(index);
		  (yyval.dimensions) = tmp;
		}
#line 8610 "parse.cc" /* yacc.c:1646  */
    break;

  case 483:
#line 3080 "parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = (yyvsp[0].exprs); (yyval.function_type).type = PTF_REG; }
#line 8616 "parse.cc" /* yacc.c:1646  */
    break;

  case 484:
#line 3081 "parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = (yyvsp[0].exprs); (yyval.function_type).type = PTF_REG_S; }
#line 8622 "parse.cc" /* yacc.c:1646  */
    break;

  case 485:
#line 3082 "parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_INTEGER; }
#line 8628 "parse.cc" /* yacc.c:1646  */
    break;

  case 486:
#line 3083 "parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_REAL; }
#line 8634 "parse.cc" /* yacc.c:1646  */
    break;

  case 487:
#line 3084 "parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_REALTIME; }
#line 8640 "parse.cc" /* yacc.c:1646  */
    break;

  case 488:
#line 3085 "parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_TIME; }
#line 8646 "parse.cc" /* yacc.c:1646  */
    break;

  case 489:
#line 3086 "parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_REG; }
#line 8652 "parse.cc" /* yacc.c:1646  */
    break;

  case 490:
#line 3096 "parse.y" /* yacc.c:1646  */
    { perm_string ident_name = lex_strings.make((yyvsp[-1].text));
	pform_makewire((yylsp[-1]), ident_name, NetNet::REG,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	if ((yyvsp[0].dimensions) != 0) {
	      index_component_t index;
	      if ((yyvsp[0].dimensions)->size() > 1) {
		    yyerror((yylsp[0]), "sorry: only 1 dimensional arrays "
			    "are currently supported.");
	      }
	      index = (yyvsp[0].dimensions)->front();
	      pform_set_reg_idx(ident_name, index.msb, index.lsb);
	      delete (yyvsp[0].dimensions);
	}
	(yyval.text) = (yyvsp[-1].text);
      }
#line 8672 "parse.cc" /* yacc.c:1646  */
    break;

  case 491:
#line 3112 "parse.y" /* yacc.c:1646  */
    { perm_string ident_name = lex_strings.make((yyvsp[-2].text));
	pform_makewire((yylsp[-2]), ident_name, NetNet::REG,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	pform_make_reginit((yylsp[-2]), ident_name, (yyvsp[0].expr));
	(yyval.text) = (yyvsp[-2].text);
      }
#line 8683 "parse.cc" /* yacc.c:1646  */
    break;

  case 492:
#line 3122 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 8693 "parse.cc" /* yacc.c:1646  */
    break;

  case 493:
#line 3128 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 8703 "parse.cc" /* yacc.c:1646  */
    break;

  case 494:
#line 3137 "parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[-1].text));
        pform_makewire((yylsp[-1]), name, NetNet::REG, NetNet::NOT_A_PORT, IVL_VT_REAL, 0);
        if ((yyvsp[0].dimensions) != 0) {
	      index_component_t index;
	      if ((yyvsp[0].dimensions)->size() > 1) {
		    yyerror((yylsp[0]), "sorry: only 1 dimensional arrays "
			    "are currently supported.");
	      }
	      index = (yyvsp[0].dimensions)->front();
	      pform_set_reg_idx(name, index.msb, index.lsb);
	      delete (yyvsp[0].dimensions);
        }
	(yyval.text) = (yyvsp[-1].text);
      }
#line 8722 "parse.cc" /* yacc.c:1646  */
    break;

  case 495:
#line 3152 "parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[-2].text));
	pform_makewire((yylsp[-2]), name, NetNet::REG, NetNet::NOT_A_PORT, IVL_VT_REAL, 0);
	pform_make_reginit((yylsp[-2]), name, (yyvsp[0].expr));
	(yyval.text) = (yyvsp[-2].text);
      }
#line 8732 "parse.cc" /* yacc.c:1646  */
    break;

  case 496:
#line 3161 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
	tmp->push_back(lex_strings.make((yyvsp[0].text)));
	(yyval.perm_strings) = tmp;
	delete[](yyvsp[0].text);
      }
#line 8742 "parse.cc" /* yacc.c:1646  */
    break;

  case 497:
#line 3167 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
	tmp->push_back(lex_strings.make((yyvsp[0].text)));
	(yyval.perm_strings) = tmp;
	delete[](yyvsp[0].text);
      }
#line 8752 "parse.cc" /* yacc.c:1646  */
    break;

  case 498:
#line 3176 "parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[-1].text));
	pform_makewire((yylsp[-1]), name, NetNet::IMPLICIT,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	if ((yyvsp[0].dimensions) != 0) {
	      index_component_t index;
	      if ((yyvsp[0].dimensions)->size() > 1) {
		    yyerror((yylsp[0]), "sorry: only 1 dimensional arrays "
			    "are currently supported.");
	      }
	      index = (yyvsp[0].dimensions)->front();
	      pform_set_reg_idx(name, index.msb, index.lsb);
	      delete (yyvsp[0].dimensions);
	}
	(yyval.text) = (yyvsp[-1].text);
      }
#line 8772 "parse.cc" /* yacc.c:1646  */
    break;

  case 499:
#line 3195 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 8782 "parse.cc" /* yacc.c:1646  */
    break;

  case 500:
#line 3201 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 8792 "parse.cc" /* yacc.c:1646  */
    break;

  case 502:
#line 3211 "parse.y" /* yacc.c:1646  */
    { pform_module_specify_path((yyvsp[-1].specpath));
		}
#line 8799 "parse.cc" /* yacc.c:1646  */
    break;

  case 503:
#line 3214 "parse.y" /* yacc.c:1646  */
    { pform_module_specify_path((yyvsp[-1].specpath));
		}
#line 8806 "parse.cc" /* yacc.c:1646  */
    break;

  case 504:
#line 3217 "parse.y" /* yacc.c:1646  */
    { PSpecPath*tmp = (yyvsp[-1].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = (yyvsp[-3].expr);
		  }
		  pform_module_specify_path(tmp);
		}
#line 8818 "parse.cc" /* yacc.c:1646  */
    break;

  case 505:
#line 3225 "parse.y" /* yacc.c:1646  */
    { PSpecPath*tmp = (yyvsp[-1].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = (yyvsp[-3].expr);
		  }
		  pform_module_specify_path(tmp);
		}
#line 8830 "parse.cc" /* yacc.c:1646  */
    break;

  case 506:
#line 3233 "parse.y" /* yacc.c:1646  */
    { PSpecPath*tmp = (yyvsp[-1].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = 0;
		  }
		  pform_module_specify_path(tmp);
		}
#line 8842 "parse.cc" /* yacc.c:1646  */
    break;

  case 507:
#line 3241 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "Sorry: ifnone with an edge-sensitive path is "
		              "not supported.");
		  yyerrok;
		}
#line 8851 "parse.cc" /* yacc.c:1646  */
    break;

  case 508:
#line 3247 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 8859 "parse.cc" /* yacc.c:1646  */
    break;

  case 509:
#line 3252 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8866 "parse.cc" /* yacc.c:1646  */
    break;

  case 510:
#line 3256 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 8874 "parse.cc" /* yacc.c:1646  */
    break;

  case 511:
#line 3261 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8881 "parse.cc" /* yacc.c:1646  */
    break;

  case 512:
#line 3265 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8888 "parse.cc" /* yacc.c:1646  */
    break;

  case 513:
#line 3269 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 8896 "parse.cc" /* yacc.c:1646  */
    break;

  case 514:
#line 3274 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8903 "parse.cc" /* yacc.c:1646  */
    break;

  case 515:
#line 3278 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8910 "parse.cc" /* yacc.c:1646  */
    break;

  case 516:
#line 3282 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 8918 "parse.cc" /* yacc.c:1646  */
    break;

  case 517:
#line 3287 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8925 "parse.cc" /* yacc.c:1646  */
    break;

  case 518:
#line 3291 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8932 "parse.cc" /* yacc.c:1646  */
    break;

  case 519:
#line 3295 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 8940 "parse.cc" /* yacc.c:1646  */
    break;

  case 520:
#line 3299 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
		}
#line 8947 "parse.cc" /* yacc.c:1646  */
    break;

  case 521:
#line 3302 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings);
		}
#line 8954 "parse.cc" /* yacc.c:1646  */
    break;

  case 522:
#line 3305 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings);
		}
#line 8961 "parse.cc" /* yacc.c:1646  */
    break;

  case 523:
#line 3308 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings);
		}
#line 8968 "parse.cc" /* yacc.c:1646  */
    break;

  case 524:
#line 3311 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings);
		}
#line 8975 "parse.cc" /* yacc.c:1646  */
    break;

  case 527:
#line 3322 "parse.y" /* yacc.c:1646  */
    { (yyval.specpath) = pform_assign_path_delay((yyvsp[-4].specpath), (yyvsp[-1].exprs)); }
#line 8981 "parse.cc" /* yacc.c:1646  */
    break;

  case 528:
#line 3324 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[0].expr);
		  (yyval.specpath) = pform_assign_path_delay((yyvsp[-2].specpath), tmp);
		}
#line 8990 "parse.cc" /* yacc.c:1646  */
    break;

  case 529:
#line 3330 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 8996 "parse.cc" /* yacc.c:1646  */
    break;

  case 530:
#line 3330 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 9002 "parse.cc" /* yacc.c:1646  */
    break;

  case 531:
#line 3335 "parse.y" /* yacc.c:1646  */
    { int edge_flag = 0;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[-9]), edge_flag, (yyvsp[-8].perm_strings), (yyvsp[-7].letter), false, (yyvsp[-4].perm_strings), (yyvsp[-2].expr)); }
#line 9009 "parse.cc" /* yacc.c:1646  */
    break;

  case 532:
#line 3339 "parse.y" /* yacc.c:1646  */
    { int edge_flag = (yyvsp[-9].flag)? 1 : -1;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[-10]), edge_flag, (yyvsp[-8].perm_strings), (yyvsp[-7].letter), false, (yyvsp[-4].perm_strings), (yyvsp[-2].expr));}
#line 9016 "parse.cc" /* yacc.c:1646  */
    break;

  case 533:
#line 3343 "parse.y" /* yacc.c:1646  */
    { int edge_flag = 0;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[-9]), edge_flag, (yyvsp[-8].perm_strings), (yyvsp[-7].letter), true, (yyvsp[-4].perm_strings), (yyvsp[-2].expr)); }
#line 9023 "parse.cc" /* yacc.c:1646  */
    break;

  case 534:
#line 3347 "parse.y" /* yacc.c:1646  */
    { int edge_flag = (yyvsp[-9].flag)? 1 : -1;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[-10]), edge_flag, (yyvsp[-8].perm_strings), (yyvsp[-7].letter), true, (yyvsp[-4].perm_strings), (yyvsp[-2].expr)); }
#line 9030 "parse.cc" /* yacc.c:1646  */
    break;

  case 538:
#line 3359 "parse.y" /* yacc.c:1646  */
    { (yyval.specpath) = pform_assign_path_delay((yyvsp[-4].specpath), (yyvsp[-1].exprs)); }
#line 9036 "parse.cc" /* yacc.c:1646  */
    break;

  case 539:
#line 3361 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[0].expr);
		  (yyval.specpath) = pform_assign_path_delay((yyvsp[-2].specpath), tmp);
		}
#line 9045 "parse.cc" /* yacc.c:1646  */
    break;

  case 540:
#line 3366 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "Syntax error in delay value list.");
		  yyerrok;
		  (yyval.specpath) = 0;
		}
#line 9054 "parse.cc" /* yacc.c:1646  */
    break;

  case 541:
#line 3375 "parse.y" /* yacc.c:1646  */
    { (yyval.specpath) = pform_make_specify_path((yylsp[-5]), (yyvsp[-4].perm_strings), (yyvsp[-3].letter), false, (yyvsp[-1].perm_strings)); }
#line 9060 "parse.cc" /* yacc.c:1646  */
    break;

  case 542:
#line 3378 "parse.y" /* yacc.c:1646  */
    { (yyval.specpath) = pform_make_specify_path((yylsp[-5]), (yyvsp[-4].perm_strings), (yyvsp[-3].letter), true, (yyvsp[-1].perm_strings)); }
#line 9066 "parse.cc" /* yacc.c:1646  */
    break;

  case 543:
#line 3380 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "Invalid simple path");
		  yyerrok;
		}
#line 9074 "parse.cc" /* yacc.c:1646  */
    break;

  case 544:
#line 3387 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 9084 "parse.cc" /* yacc.c:1646  */
    break;

  case 545:
#line 3393 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[-3].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[-3].text);
		}
#line 9094 "parse.cc" /* yacc.c:1646  */
    break;

  case 546:
#line 3399 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 9104 "parse.cc" /* yacc.c:1646  */
    break;

  case 547:
#line 3405 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-5].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[-3].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[-3].text);
		}
#line 9114 "parse.cc" /* yacc.c:1646  */
    break;

  case 548:
#line 3414 "parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[0].expr);
		  pform_set_specparam(lex_strings.make((yyvsp[-2].text)), tmp);
		  delete[](yyvsp[-2].text);
		}
#line 9123 "parse.cc" /* yacc.c:1646  */
    break;

  case 549:
#line 3419 "parse.y" /* yacc.c:1646  */
    { PExpr*tmp = 0;
		  switch (min_typ_max_flag) {
		      case MIN:
			tmp = (yyvsp[-4].expr);
			delete (yyvsp[-2].expr);
			delete (yyvsp[0].expr);
			break;
		      case TYP:
			delete (yyvsp[-4].expr);
			tmp = (yyvsp[-2].expr);
			delete (yyvsp[0].expr);
			break;
		      case MAX:
			delete (yyvsp[-4].expr);
			delete (yyvsp[-2].expr);
			tmp = (yyvsp[0].expr);
			break;
		  }
		  if (min_typ_max_warn > 0) {
		        cerr << tmp->get_fileline() << ": warning: choosing ";
		        switch (min_typ_max_flag) {
		            case MIN:
		              cerr << "min";
		              break;
		            case TYP:
		              cerr << "typ";
		              break;
		            case MAX:
		              cerr << "max";
		              break;
		        }
		        cerr << " expression." << endl;
		        min_typ_max_warn -= 1;
		  }
		  pform_set_specparam(lex_strings.make((yyvsp[-6].text)), tmp);
		  delete[](yyvsp[-6].text);
		}
#line 9165 "parse.cc" /* yacc.c:1646  */
    break;

  case 550:
#line 3457 "parse.y" /* yacc.c:1646  */
    { delete[](yyvsp[-2].text);
		  delete (yyvsp[0].expr);
		}
#line 9173 "parse.cc" /* yacc.c:1646  */
    break;

  case 551:
#line 3461 "parse.y" /* yacc.c:1646  */
    { delete[](yyvsp[-6].text);
		  delete (yyvsp[-3].expr);
		  delete (yyvsp[-1].expr);
		}
#line 9182 "parse.cc" /* yacc.c:1646  */
    break;

  case 554:
#line 3473 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '+'; }
#line 9188 "parse.cc" /* yacc.c:1646  */
    break;

  case 555:
#line 3474 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '-'; }
#line 9194 "parse.cc" /* yacc.c:1646  */
    break;

  case 556:
#line 3475 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 0;   }
#line 9200 "parse.cc" /* yacc.c:1646  */
    break;

  case 557:
#line 3480 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[0].expr); }
#line 9206 "parse.cc" /* yacc.c:1646  */
    break;

  case 558:
#line 3482 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[0].expr); }
#line 9212 "parse.cc" /* yacc.c:1646  */
    break;

  case 559:
#line 3484 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
      delete (yyvsp[0].expr);
    }
#line 9220 "parse.cc" /* yacc.c:1646  */
    break;

  case 560:
#line 3488 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
      delete (yyvsp[0].expr);
    }
#line 9228 "parse.cc" /* yacc.c:1646  */
    break;

  case 561:
#line 3492 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[0].expr); }
#line 9234 "parse.cc" /* yacc.c:1646  */
    break;

  case 562:
#line 3494 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
      delete (yyvsp[0].expr);
    }
#line 9242 "parse.cc" /* yacc.c:1646  */
    break;

  case 563:
#line 3498 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
      delete (yyvsp[0].expr);
    }
#line 9250 "parse.cc" /* yacc.c:1646  */
    break;

  case 564:
#line 3502 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[0].expr); }
#line 9256 "parse.cc" /* yacc.c:1646  */
    break;

  case 567:
#line 3516 "parse.y" /* yacc.c:1646  */
    {  }
#line 9262 "parse.cc" /* yacc.c:1646  */
    break;

  case 568:
#line 3518 "parse.y" /* yacc.c:1646  */
    {  }
#line 9268 "parse.cc" /* yacc.c:1646  */
    break;

  case 569:
#line 3522 "parse.y" /* yacc.c:1646  */
    { args_after_notifier = 0; }
#line 9274 "parse.cc" /* yacc.c:1646  */
    break;

  case 570:
#line 3524 "parse.y" /* yacc.c:1646  */
    { args_after_notifier = 0; delete (yyvsp[0].pform_name); }
#line 9280 "parse.cc" /* yacc.c:1646  */
    break;

  case 571:
#line 3526 "parse.y" /* yacc.c:1646  */
    {  args_after_notifier += 1; }
#line 9286 "parse.cc" /* yacc.c:1646  */
    break;

  case 572:
#line 3528 "parse.y" /* yacc.c:1646  */
    { args_after_notifier += 1;
		  if (args_after_notifier >= 3)  {
                    cerr << (yylsp[0]) << ": warning: timing checks are not supported "
		                  "and delayed signal \"" << *(yyvsp[0].pform_name)
		         << "\" will not be driven." << endl;
		  }
                  delete (yyvsp[0].pform_name); }
#line 9298 "parse.cc" /* yacc.c:1646  */
    break;

  case 573:
#line 3537 "parse.y" /* yacc.c:1646  */
    { args_after_notifier = 0; delete[](yyvsp[0].text); }
#line 9304 "parse.cc" /* yacc.c:1646  */
    break;

  case 574:
#line 3549 "parse.y" /* yacc.c:1646  */
    { PCAssign*tmp = new PCAssign((yyvsp[-3].expr), (yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9313 "parse.cc" /* yacc.c:1646  */
    break;

  case 575:
#line 3555 "parse.y" /* yacc.c:1646  */
    { PDeassign*tmp = new PDeassign((yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-2]));
		  (yyval.statement) = tmp;
		}
#line 9322 "parse.cc" /* yacc.c:1646  */
    break;

  case 576:
#line 3565 "parse.y" /* yacc.c:1646  */
    { PForce*tmp = new PForce((yyvsp[-3].expr), (yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9331 "parse.cc" /* yacc.c:1646  */
    break;

  case 577:
#line 3570 "parse.y" /* yacc.c:1646  */
    { PRelease*tmp = new PRelease((yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-2]));
		  (yyval.statement) = tmp;
		}
#line 9340 "parse.cc" /* yacc.c:1646  */
    break;

  case 578:
#line 3582 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[-1]));
	(yyval.statement) = tmp;
      }
#line 9349 "parse.cc" /* yacc.c:1646  */
    break;

  case 579:
#line 3587 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[-2]));
	tmp->set_statement(*(yyvsp[-1].statement_list));
	delete (yyvsp[-1].statement_list);
	(yyval.statement) = tmp;
      }
#line 9360 "parse.cc" /* yacc.c:1646  */
    break;

  case 580:
#line 3594 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp = pform_push_block_scope((yyvsp[0].text), PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[-2]));
	current_block_stack.push(tmp);
      }
#line 9369 "parse.cc" /* yacc.c:1646  */
    break;

  case 581:
#line 3600 "parse.y" /* yacc.c:1646  */
    { pform_pop_scope();
	assert(! current_block_stack.empty());
	PBlock*tmp = current_block_stack.top();
	current_block_stack.pop();
	if ((yyvsp[-1].statement_list)) tmp->set_statement(*(yyvsp[-1].statement_list));
	delete[](yyvsp[-4].text);
	delete (yyvsp[-1].statement_list);
	(yyval.statement) = tmp;
      }
#line 9383 "parse.cc" /* yacc.c:1646  */
    break;

  case 582:
#line 3610 "parse.y" /* yacc.c:1646  */
    { yyerrok; }
#line 9389 "parse.cc" /* yacc.c:1646  */
    break;

  case 583:
#line 3618 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp = new PBlock(PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[-1]));
	(yyval.statement) = tmp;
      }
#line 9398 "parse.cc" /* yacc.c:1646  */
    break;

  case 584:
#line 3623 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp = new PBlock(PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[-2]));
	tmp->set_statement(*(yyvsp[-1].statement_list));
	delete (yyvsp[-1].statement_list);
	(yyval.statement) = tmp;
      }
#line 9409 "parse.cc" /* yacc.c:1646  */
    break;

  case 585:
#line 3630 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp = pform_push_block_scope((yyvsp[0].text), PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[-2]));
	current_block_stack.push(tmp);
      }
#line 9418 "parse.cc" /* yacc.c:1646  */
    break;

  case 586:
#line 3636 "parse.y" /* yacc.c:1646  */
    { pform_pop_scope();
        assert(! current_block_stack.empty());
	PBlock*tmp = current_block_stack.top();
	current_block_stack.pop();
	if ((yyvsp[-1].statement_list)) tmp->set_statement(*(yyvsp[-1].statement_list));
	delete[](yyvsp[-4].text);
	delete (yyvsp[-1].statement_list);
	(yyval.statement) = tmp;
      }
#line 9432 "parse.cc" /* yacc.c:1646  */
    break;

  case 587:
#line 3646 "parse.y" /* yacc.c:1646  */
    { yyerrok; }
#line 9438 "parse.cc" /* yacc.c:1646  */
    break;

  case 588:
#line 3649 "parse.y" /* yacc.c:1646  */
    { PDisable*tmp = new PDisable(*(yyvsp[-1].pform_name));
		  FILE_NAME(tmp, (yylsp[-2]));
		  delete (yyvsp[-1].pform_name);
		  (yyval.statement) = tmp;
		}
#line 9448 "parse.cc" /* yacc.c:1646  */
    break;

  case 589:
#line 3655 "parse.y" /* yacc.c:1646  */
    { PTrigger*tmp = new PTrigger(*(yyvsp[-1].pform_name));
		  FILE_NAME(tmp, (yylsp[-2]));
		  delete (yyvsp[-1].pform_name);
		  (yyval.statement) = tmp;
		}
#line 9458 "parse.cc" /* yacc.c:1646  */
    break;

  case 590:
#line 3661 "parse.y" /* yacc.c:1646  */
    { PForever*tmp = new PForever((yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.statement) = tmp;
		}
#line 9467 "parse.cc" /* yacc.c:1646  */
    break;

  case 591:
#line 3666 "parse.y" /* yacc.c:1646  */
    { PRepeat*tmp = new PRepeat((yyvsp[-2].expr), (yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9476 "parse.cc" /* yacc.c:1646  */
    break;

  case 592:
#line 3671 "parse.y" /* yacc.c:1646  */
    { PCase*tmp = new PCase(NetCase::EQ, (yyvsp[-3].expr), (yyvsp[-1].citems));
		  FILE_NAME(tmp, (yylsp[-5]));
		  (yyval.statement) = tmp;
		}
#line 9485 "parse.cc" /* yacc.c:1646  */
    break;

  case 593:
#line 3676 "parse.y" /* yacc.c:1646  */
    { PCase*tmp = new PCase(NetCase::EQX, (yyvsp[-3].expr), (yyvsp[-1].citems));
		  FILE_NAME(tmp, (yylsp[-5]));
		  (yyval.statement) = tmp;
		}
#line 9494 "parse.cc" /* yacc.c:1646  */
    break;

  case 594:
#line 3681 "parse.y" /* yacc.c:1646  */
    { PCase*tmp = new PCase(NetCase::EQZ, (yyvsp[-3].expr), (yyvsp[-1].citems));
		  FILE_NAME(tmp, (yylsp[-5]));
		  (yyval.statement) = tmp;
		}
#line 9503 "parse.cc" /* yacc.c:1646  */
    break;

  case 595:
#line 3686 "parse.y" /* yacc.c:1646  */
    { yyerrok; }
#line 9509 "parse.cc" /* yacc.c:1646  */
    break;

  case 596:
#line 3688 "parse.y" /* yacc.c:1646  */
    { yyerrok; }
#line 9515 "parse.cc" /* yacc.c:1646  */
    break;

  case 597:
#line 3690 "parse.y" /* yacc.c:1646  */
    { yyerrok; }
#line 9521 "parse.cc" /* yacc.c:1646  */
    break;

  case 598:
#line 3692 "parse.y" /* yacc.c:1646  */
    { PCondit*tmp = new PCondit((yyvsp[-2].expr), (yyvsp[0].statement), 0);
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9530 "parse.cc" /* yacc.c:1646  */
    break;

  case 599:
#line 3697 "parse.y" /* yacc.c:1646  */
    { PCondit*tmp = new PCondit((yyvsp[-4].expr), (yyvsp[-2].statement), (yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-6]));
		  (yyval.statement) = tmp;
		}
#line 9539 "parse.cc" /* yacc.c:1646  */
    break;

  case 600:
#line 3702 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-4]), "error: Malformed conditional expression.");
		  (yyval.statement) = (yyvsp[0].statement);
		}
#line 9547 "parse.cc" /* yacc.c:1646  */
    break;

  case 601:
#line 3706 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-6]), "error: Malformed conditional expression.");
		  (yyval.statement) = (yyvsp[-2].statement);
		}
#line 9555 "parse.cc" /* yacc.c:1646  */
    break;

  case 602:
#line 3711 "parse.y" /* yacc.c:1646  */
    { PForStatement*tmp = new PForStatement((yyvsp[-10].expr), (yyvsp[-8].expr), (yyvsp[-6].expr), (yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-12]));
		  (yyval.statement) = tmp;
		}
#line 9564 "parse.cc" /* yacc.c:1646  */
    break;

  case 603:
#line 3717 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0;
		  yyerror((yylsp[-10]), "error: Error in for loop step assignment.");
		}
#line 9572 "parse.cc" /* yacc.c:1646  */
    break;

  case 604:
#line 3722 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0;
		  yyerror((yylsp[-12]), "error: Error in for loop condition expression.");
		}
#line 9580 "parse.cc" /* yacc.c:1646  */
    break;

  case 605:
#line 3726 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0;
		  yyerror((yylsp[-4]), "error: Incomprehensible for loop.");
		}
#line 9588 "parse.cc" /* yacc.c:1646  */
    break;

  case 606:
#line 3730 "parse.y" /* yacc.c:1646  */
    { PWhile*tmp = new PWhile((yyvsp[-2].expr), (yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9597 "parse.cc" /* yacc.c:1646  */
    break;

  case 607:
#line 3735 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0;
		  yyerror((yylsp[-4]), "error: Error in while loop condition.");
		}
#line 9605 "parse.cc" /* yacc.c:1646  */
    break;

  case 608:
#line 3739 "parse.y" /* yacc.c:1646  */
    { PExpr*del = (*(yyvsp[-1].exprs))[0];
		  assert((yyvsp[-1].exprs)->count() == 1);
		  PDelayStatement*tmp = new PDelayStatement(del, (yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.statement) = tmp;
		}
#line 9616 "parse.cc" /* yacc.c:1646  */
    break;

  case 609:
#line 3746 "parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp = (yyvsp[-2].event_statement);
	if (tmp == 0) {
	      yyerror((yylsp[-2]), "error: Invalid event control.");
	      (yyval.statement) = 0;
	} else {
	      if ((yyvsp[0].statement)) pform_bind_attributes((yyvsp[0].statement)->attributes,(yyvsp[-1].named_pexprs));
	      tmp->set_statement((yyvsp[0].statement));
	      (yyval.statement) = tmp;
	}
      }
#line 9631 "parse.cc" /* yacc.c:1646  */
    break;

  case 610:
#line 3757 "parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp = new PEventStatement;
	FILE_NAME(tmp, (yylsp[-3]));
	if ((yyvsp[0].statement)) pform_bind_attributes((yyvsp[0].statement)->attributes,(yyvsp[-1].named_pexprs));
	tmp->set_statement((yyvsp[0].statement));
	(yyval.statement) = tmp;
      }
#line 9642 "parse.cc" /* yacc.c:1646  */
    break;

  case 611:
#line 3764 "parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp = new PEventStatement;
	FILE_NAME(tmp, (yylsp[-5]));
	if ((yyvsp[0].statement)) pform_bind_attributes((yyvsp[0].statement)->attributes,(yyvsp[-1].named_pexprs));
	tmp->set_statement((yyvsp[0].statement));
	(yyval.statement) = tmp;
      }
#line 9653 "parse.cc" /* yacc.c:1646  */
    break;

  case 612:
#line 3771 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-3].expr),(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-3]));
		  (yyval.statement) = tmp;
		}
#line 9662 "parse.cc" /* yacc.c:1646  */
    break;

  case 613:
#line 3776 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "Syntax in assignment statement l-value.");
		  yyerrok;
		  (yyval.statement) = new PNoop;
		}
#line 9671 "parse.cc" /* yacc.c:1646  */
    break;

  case 614:
#line 3781 "parse.y" /* yacc.c:1646  */
    { PAssignNB*tmp = new PAssignNB((yyvsp[-3].expr),(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-3]));
		  (yyval.statement) = tmp;
		}
#line 9680 "parse.cc" /* yacc.c:1646  */
    break;

  case 615:
#line 3786 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "Syntax in assignment statement l-value.");
		  yyerrok;
		  (yyval.statement) = new PNoop;
		}
#line 9689 "parse.cc" /* yacc.c:1646  */
    break;

  case 616:
#line 3791 "parse.y" /* yacc.c:1646  */
    { assert((yyvsp[-2].exprs)->count() == 1);
		  PExpr*del = (*(yyvsp[-2].exprs))[0];
		  PAssign*tmp = new PAssign((yyvsp[-4].expr),del,(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9700 "parse.cc" /* yacc.c:1646  */
    break;

  case 617:
#line 3798 "parse.y" /* yacc.c:1646  */
    { assert((yyvsp[-2].exprs)->count() == 1);
		  PExpr*del = (*(yyvsp[-2].exprs))[0];
		  PAssignNB*tmp = new PAssignNB((yyvsp[-4].expr),del,(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9711 "parse.cc" /* yacc.c:1646  */
    break;

  case 618:
#line 3805 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-4].expr),0,(yyvsp[-2].event_statement),(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9720 "parse.cc" /* yacc.c:1646  */
    break;

  case 619:
#line 3810 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-8].expr),(yyvsp[-4].expr),(yyvsp[-2].event_statement),(yyvsp[-1].expr));
		  FILE_NAME(tmp,(yylsp[-8]));
		  tmp->set_lineno((yylsp[-8]).first_line);
		  (yyval.statement) = tmp;
		}
#line 9730 "parse.cc" /* yacc.c:1646  */
    break;

  case 620:
#line 3816 "parse.y" /* yacc.c:1646  */
    { PAssignNB*tmp = new PAssignNB((yyvsp[-4].expr),0,(yyvsp[-2].event_statement),(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9739 "parse.cc" /* yacc.c:1646  */
    break;

  case 621:
#line 3821 "parse.y" /* yacc.c:1646  */
    { PAssignNB*tmp = new PAssignNB((yyvsp[-8].expr),(yyvsp[-4].expr),(yyvsp[-2].event_statement),(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-8]));
		  (yyval.statement) = tmp;
		}
#line 9748 "parse.cc" /* yacc.c:1646  */
    break;

  case 622:
#line 3826 "parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp;
		  PEEvent*etmp = new PEEvent(PEEvent::POSITIVE, (yyvsp[-2].expr));
		  tmp = new PEventStatement(etmp);
		  FILE_NAME(tmp,(yylsp[-4]));
		  tmp->set_statement((yyvsp[0].statement));
		  (yyval.statement) = tmp;
		}
#line 9760 "parse.cc" /* yacc.c:1646  */
    break;

  case 623:
#line 3834 "parse.y" /* yacc.c:1646  */
    { PCallTask*tmp = new PCallTask(lex_strings.make((yyvsp[-4].text)), *(yyvsp[-2].exprs));
		  FILE_NAME(tmp,(yylsp[-4]));
		  delete[](yyvsp[-4].text);
		  delete (yyvsp[-2].exprs);
		  (yyval.statement) = tmp;
		}
#line 9771 "parse.cc" /* yacc.c:1646  */
    break;

  case 624:
#line 3841 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>pt (0);
		  PCallTask*tmp = new PCallTask(lex_strings.make((yyvsp[-1].text)), pt);
		  FILE_NAME(tmp,(yylsp[-1]));
		  delete[](yyvsp[-1].text);
		  (yyval.statement) = tmp;
		}
#line 9782 "parse.cc" /* yacc.c:1646  */
    break;

  case 625:
#line 3848 "parse.y" /* yacc.c:1646  */
    { PCallTask*tmp = new PCallTask(*(yyvsp[-4].pform_name), *(yyvsp[-2].exprs));
		  FILE_NAME(tmp, (yylsp[-4]));
		  delete (yyvsp[-4].pform_name);
		  delete (yyvsp[-2].exprs);
		  (yyval.statement) = tmp;
		}
#line 9793 "parse.cc" /* yacc.c:1646  */
    break;

  case 626:
#line 3860 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>pt (0);
		  PCallTask*tmp = new PCallTask(*(yyvsp[-3].pform_name), pt);
		  FILE_NAME(tmp, (yylsp[-3]));
		  delete (yyvsp[-3].pform_name);
		  (yyval.statement) = tmp;
		}
#line 9804 "parse.cc" /* yacc.c:1646  */
    break;

  case 627:
#line 3867 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>pt (0);
		  PCallTask*tmp = new PCallTask(*(yyvsp[-1].pform_name), pt);
		  FILE_NAME(tmp, (yylsp[-1]));
		  delete (yyvsp[-1].pform_name);
		  (yyval.statement) = tmp;
		}
#line 9815 "parse.cc" /* yacc.c:1646  */
    break;

  case 628:
#line 3874 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[0]), "error: malformed statement");
		  yyerrok;
		  (yyval.statement) = new PNoop;
		}
#line 9824 "parse.cc" /* yacc.c:1646  */
    break;

  case 629:
#line 3882 "parse.y" /* yacc.c:1646  */
    { svector<Statement*>*tmp = (yyvsp[-1].statement_list);
	if (tmp) {
	      tmp = new svector<Statement*>(*(yyvsp[-1].statement_list), (yyvsp[0].statement));
	      delete (yyvsp[-1].statement_list);
	} else {
	      tmp = new svector<Statement*>(1);
	      (*tmp)[0] = (yyvsp[0].statement);
	}
	(yyval.statement_list) = tmp;
      }
#line 9839 "parse.cc" /* yacc.c:1646  */
    break;

  case 630:
#line 3893 "parse.y" /* yacc.c:1646  */
    { (yyval.statement_list) = 0; }
#line 9845 "parse.cc" /* yacc.c:1646  */
    break;

  case 631:
#line 3898 "parse.y" /* yacc.c:1646  */
    { svector<Statement*>*tmp = new svector<Statement*>(*(yyvsp[-1].statement_list), (yyvsp[0].statement));
		  delete (yyvsp[-1].statement_list);
		  (yyval.statement_list) = tmp;
		}
#line 9854 "parse.cc" /* yacc.c:1646  */
    break;

  case 632:
#line 3903 "parse.y" /* yacc.c:1646  */
    { svector<Statement*>*tmp = new svector<Statement*>(1);
		  (*tmp)[0] = (yyvsp[0].statement);
		  (yyval.statement_list) = tmp;
		}
#line 9863 "parse.cc" /* yacc.c:1646  */
    break;

  case 633:
#line 3911 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 9869 "parse.cc" /* yacc.c:1646  */
    break;

  case 634:
#line 3913 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0; }
#line 9875 "parse.cc" /* yacc.c:1646  */
    break;

  case 635:
#line 3918 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = pform_contribution_statement((yylsp[-2]), (yyvsp[-3].expr), (yyvsp[-1].expr)); }
#line 9881 "parse.cc" /* yacc.c:1646  */
    break;

  case 636:
#line 3924 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = new svector<PWire*>(0); }
#line 9887 "parse.cc" /* yacc.c:1646  */
    break;

  case 637:
#line 3925 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 9893 "parse.cc" /* yacc.c:1646  */
    break;

  case 638:
#line 3929 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 9899 "parse.cc" /* yacc.c:1646  */
    break;

  case 639:
#line 3930 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 9905 "parse.cc" /* yacc.c:1646  */
    break;

  case 640:
#line 3935 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						(yyvsp[-4].flag) ? IVL_VT_LOGIC :
						     IVL_VT_NO_TYPE,
						(yyvsp[-3].flag), (yyvsp[-2].exprs), (yyvsp[-1].perm_strings),
						(yylsp[-5]).text, (yylsp[-5]).first_line);
		  (yyval.wires) = tmp;
		}
#line 9918 "parse.cc" /* yacc.c:1646  */
    break;

  case 641:
#line 3944 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						(yyvsp[-4].flag) ? IVL_VT_LOGIC :
						     IVL_VT_NO_TYPE,
						(yyvsp[-3].flag), (yyvsp[-2].exprs), (yyvsp[-1].perm_strings),
						(yylsp[-5]).text, (yylsp[-5]).first_line);
		  (yyval.wires) = tmp;
		}
#line 9931 "parse.cc" /* yacc.c:1646  */
    break;

  case 642:
#line 3953 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						(yyvsp[-4].flag) ? IVL_VT_LOGIC :
						     IVL_VT_NO_TYPE,
						(yyvsp[-3].flag), (yyvsp[-2].exprs), (yyvsp[-1].perm_strings),
						(yylsp[-5]).text, (yylsp[-5]).first_line);
		  (yyval.wires) = tmp;
		}
#line 9944 "parse.cc" /* yacc.c:1646  */
    break;

  case 643:
#line 3966 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, true,
						range_stub, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line, true);
		  (yyval.wires) = tmp;
		}
#line 9963 "parse.cc" /* yacc.c:1646  */
    break;

  case 644:
#line 3981 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, true,
						range_stub, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line, true);
		  (yyval.wires) = tmp;
		}
#line 9982 "parse.cc" /* yacc.c:1646  */
    break;

  case 645:
#line 3996 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, true,
						range_stub, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line, true);
		  (yyval.wires) = tmp;
		}
#line 10001 "parse.cc" /* yacc.c:1646  */
    break;

  case 646:
#line 4014 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, false,
						range_stub, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10019 "parse.cc" /* yacc.c:1646  */
    break;

  case 647:
#line 4028 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, false,
						range_stub, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10037 "parse.cc" /* yacc.c:1646  */
    break;

  case 648:
#line 4042 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, false,
						range_stub, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10055 "parse.cc" /* yacc.c:1646  */
    break;

  case 649:
#line 4059 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_REAL, false,
						0, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10067 "parse.cc" /* yacc.c:1646  */
    break;

  case 650:
#line 4067 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_REAL, true,
						0, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10079 "parse.cc" /* yacc.c:1646  */
    break;

  case 651:
#line 4075 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_REAL, true,
						0, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10091 "parse.cc" /* yacc.c:1646  */
    break;

  case 652:
#line 4086 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[-1].wires), *(yyvsp[0].wires));
		  delete (yyvsp[-1].wires);
		  delete (yyvsp[0].wires);
		  (yyval.wires) = tmp;
		}
#line 10101 "parse.cc" /* yacc.c:1646  */
    break;

  case 653:
#line 4092 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 10107 "parse.cc" /* yacc.c:1646  */
    break;

  case 654:
#line 4097 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 10113 "parse.cc" /* yacc.c:1646  */
    break;

  case 655:
#line 4099 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = 0; }
#line 10119 "parse.cc" /* yacc.c:1646  */
    break;

  case 656:
#line 4105 "parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = (yyvsp[-2].flag);
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range((yyvsp[-1].exprs));
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, (yyvsp[-2].flag),
						(yyvsp[-1].exprs), list_from_identifier((yyvsp[0].text)),
						(yylsp[-4]).text, (yylsp[-4]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10136 "parse.cc" /* yacc.c:1646  */
    break;

  case 657:
#line 4119 "parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = (yyvsp[-2].flag);
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range((yyvsp[-1].exprs));
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, (yyvsp[-2].flag),
						(yyvsp[-1].exprs), list_from_identifier((yyvsp[0].text)),
						(yylsp[-4]).text, (yylsp[-4]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10153 "parse.cc" /* yacc.c:1646  */
    break;

  case 658:
#line 4132 "parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = (yyvsp[-2].flag);
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range((yyvsp[-1].exprs));
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, (yyvsp[-2].flag),
						(yyvsp[-1].exprs), list_from_identifier((yyvsp[0].text)),
						(yylsp[-4]).text, (yylsp[-4]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10170 "parse.cc" /* yacc.c:1646  */
    break;

  case 659:
#line 4148 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = true;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, true,
						range_stub,
						list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line, true);
		  (yyval.wires) = tmp;
		}
#line 10195 "parse.cc" /* yacc.c:1646  */
    break;

  case 660:
#line 4169 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = true;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, true,
						range_stub,
						list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line, true);
		  (yyval.wires) = tmp;
		}
#line 10220 "parse.cc" /* yacc.c:1646  */
    break;

  case 661:
#line 4190 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = true;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, true,
						range_stub,
						list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line, true);
		  (yyval.wires) = tmp;
		}
#line 10245 "parse.cc" /* yacc.c:1646  */
    break;

  case 662:
#line 4214 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, false,
						range_stub,
						list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10269 "parse.cc" /* yacc.c:1646  */
    break;

  case 663:
#line 4234 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, false,
						range_stub,
						list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10293 "parse.cc" /* yacc.c:1646  */
    break;

  case 664:
#line 4254 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, false,
						range_stub,
						list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10317 "parse.cc" /* yacc.c:1646  */
    break;

  case 665:
#line 4277 "parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_REAL;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = 0;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_REAL, false,
						0, list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10334 "parse.cc" /* yacc.c:1646  */
    break;

  case 666:
#line 4290 "parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_REAL;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = 0;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_REAL, false,
						0, list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10351 "parse.cc" /* yacc.c:1646  */
    break;

  case 667:
#line 4303 "parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_REAL;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = 0;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_REAL, false,
						0, list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10368 "parse.cc" /* yacc.c:1646  */
    break;

  case 668:
#line 4319 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[-2].wires), *(yyvsp[0].wires));
		  delete (yyvsp[-2].wires);
		  delete (yyvsp[0].wires);
		  (yyval.wires) = tmp;
		}
#line 10378 "parse.cc" /* yacc.c:1646  */
    break;

  case 669:
#line 4325 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 10384 "parse.cc" /* yacc.c:1646  */
    break;

  case 670:
#line 4327 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*new_decl
			= pform_make_task_ports(
				port_declaration_context.port_type,
				port_declaration_context.var_type,
				port_declaration_context.sign_flag,
				copy_range(port_declaration_context.range),
				list_from_identifier((yyvsp[0].text)),
				(yylsp[0]).text, (yylsp[0]).first_line);
		  svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[-2].wires), *new_decl);
		  delete (yyvsp[-2].wires);
		  delete new_decl;
		  (yyval.wires) = tmp;
		}
#line 10402 "parse.cc" /* yacc.c:1646  */
    break;

  case 671:
#line 4341 "parse.y" /* yacc.c:1646  */
    {
		  yyerror((yylsp[0]), "error: NULL port declarations are not "
		              "allowed.");
		}
#line 10411 "parse.cc" /* yacc.c:1646  */
    break;

  case 672:
#line 4346 "parse.y" /* yacc.c:1646  */
    {
		  yyerror((yylsp[0]), "error: ';' is an invalid port declaration "
		              "separator.");
		}
#line 10420 "parse.cc" /* yacc.c:1646  */
    break;

  case 673:
#line 4353 "parse.y" /* yacc.c:1646  */
    { lex_start_table(); }
#line 10426 "parse.cc" /* yacc.c:1646  */
    break;

  case 674:
#line 4355 "parse.y" /* yacc.c:1646  */
    { lex_end_table(); (yyval.strings) = (yyvsp[-1].strings); }
#line 10432 "parse.cc" /* yacc.c:1646  */
    break;

  case 677:
#line 4365 "parse.y" /* yacc.c:1646  */
    { char*tmp = new char[strlen((yyvsp[-3].text))+3];
		  strcpy(tmp, (yyvsp[-3].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = ':';
		  *tp++ = (yyvsp[-1].letter);
		  *tp++ = 0;
		  delete[](yyvsp[-3].text);
		  (yyval.text) = tmp;
		}
#line 10446 "parse.cc" /* yacc.c:1646  */
    break;

  case 678:
#line 4378 "parse.y" /* yacc.c:1646  */
    { list<string>*tmp = new list<string>;
		  tmp->push_back((yyvsp[0].text));
		  delete[](yyvsp[0].text);
		  (yyval.strings) = tmp;
		}
#line 10456 "parse.cc" /* yacc.c:1646  */
    break;

  case 679:
#line 4384 "parse.y" /* yacc.c:1646  */
    { list<string>*tmp = (yyvsp[-1].strings);
		  tmp->push_back((yyvsp[0].text));
		  delete[](yyvsp[0].text);
		  (yyval.strings) = tmp;
		}
#line 10466 "parse.cc" /* yacc.c:1646  */
    break;

  case 680:
#line 4393 "parse.y" /* yacc.c:1646  */
    { list<string>*tmp = new list<string>;
		  tmp->push_back((yyvsp[0].text));
		  delete[](yyvsp[0].text);
		  (yyval.strings) = tmp;
		}
#line 10476 "parse.cc" /* yacc.c:1646  */
    break;

  case 681:
#line 4399 "parse.y" /* yacc.c:1646  */
    { list<string>*tmp = (yyvsp[-1].strings);
		  tmp->push_back((yyvsp[0].text));
		  delete[](yyvsp[0].text);
		  (yyval.strings) = tmp;
		}
#line 10486 "parse.cc" /* yacc.c:1646  */
    break;

  case 682:
#line 4408 "parse.y" /* yacc.c:1646  */
    { char*tmp = new char[strlen((yyvsp[-5].text))+5];
		  strcpy(tmp, (yyvsp[-5].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = ':';
		  *tp++ = (yyvsp[-3].letter);
		  *tp++ = ':';
		  *tp++ = (yyvsp[-1].letter);
		  *tp++ = 0;
		  (yyval.text) = tmp;
		}
#line 10501 "parse.cc" /* yacc.c:1646  */
    break;

  case 683:
#line 4422 "parse.y" /* yacc.c:1646  */
    { PExpr*etmp = new PENumber((yyvsp[-1].number));
		  PEIdent*itmp = new PEIdent(lex_strings.make((yyvsp[-3].text)));
		  PAssign*atmp = new PAssign(itmp, etmp);
		  FILE_NAME(atmp, (yylsp[-3]));
		  delete[](yyvsp[-3].text);
		  (yyval.statement) = atmp;
		}
#line 10513 "parse.cc" /* yacc.c:1646  */
    break;

  case 684:
#line 4432 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 10519 "parse.cc" /* yacc.c:1646  */
    break;

  case 685:
#line 4433 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0; }
#line 10525 "parse.cc" /* yacc.c:1646  */
    break;

  case 686:
#line 4438 "parse.y" /* yacc.c:1646  */
    { char*tmp = new char[2];
		  tmp[0] = (yyvsp[0].letter);
		  tmp[1] = 0;
		  (yyval.text) = tmp;
		}
#line 10535 "parse.cc" /* yacc.c:1646  */
    break;

  case 687:
#line 4444 "parse.y" /* yacc.c:1646  */
    { char*tmp = new char[strlen((yyvsp[-1].text))+2];
		  strcpy(tmp, (yyvsp[-1].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = (yyvsp[0].letter);
		  *tp++ = 0;
		  delete[](yyvsp[-1].text);
		  (yyval.text) = tmp;
		}
#line 10548 "parse.cc" /* yacc.c:1646  */
    break;

  case 688:
#line 4455 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '0'; }
#line 10554 "parse.cc" /* yacc.c:1646  */
    break;

  case 689:
#line 4456 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '1'; }
#line 10560 "parse.cc" /* yacc.c:1646  */
    break;

  case 690:
#line 4457 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'x'; }
#line 10566 "parse.cc" /* yacc.c:1646  */
    break;

  case 691:
#line 4458 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '?'; }
#line 10572 "parse.cc" /* yacc.c:1646  */
    break;

  case 692:
#line 4459 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'b'; }
#line 10578 "parse.cc" /* yacc.c:1646  */
    break;

  case 693:
#line 4460 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '*'; }
#line 10584 "parse.cc" /* yacc.c:1646  */
    break;

  case 694:
#line 4461 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '%'; }
#line 10590 "parse.cc" /* yacc.c:1646  */
    break;

  case 695:
#line 4462 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'f'; }
#line 10596 "parse.cc" /* yacc.c:1646  */
    break;

  case 696:
#line 4463 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'F'; }
#line 10602 "parse.cc" /* yacc.c:1646  */
    break;

  case 697:
#line 4464 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'l'; }
#line 10608 "parse.cc" /* yacc.c:1646  */
    break;

  case 698:
#line 4465 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'H'; }
#line 10614 "parse.cc" /* yacc.c:1646  */
    break;

  case 699:
#line 4466 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'B'; }
#line 10620 "parse.cc" /* yacc.c:1646  */
    break;

  case 700:
#line 4467 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'r'; }
#line 10626 "parse.cc" /* yacc.c:1646  */
    break;

  case 701:
#line 4468 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'R'; }
#line 10632 "parse.cc" /* yacc.c:1646  */
    break;

  case 702:
#line 4469 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'M'; }
#line 10638 "parse.cc" /* yacc.c:1646  */
    break;

  case 703:
#line 4470 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'n'; }
#line 10644 "parse.cc" /* yacc.c:1646  */
    break;

  case 704:
#line 4471 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'N'; }
#line 10650 "parse.cc" /* yacc.c:1646  */
    break;

  case 705:
#line 4472 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'p'; }
#line 10656 "parse.cc" /* yacc.c:1646  */
    break;

  case 706:
#line 4473 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'P'; }
#line 10662 "parse.cc" /* yacc.c:1646  */
    break;

  case 707:
#line 4474 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'Q'; }
#line 10668 "parse.cc" /* yacc.c:1646  */
    break;

  case 708:
#line 4475 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'q'; }
#line 10674 "parse.cc" /* yacc.c:1646  */
    break;

  case 709:
#line 4476 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '_'; }
#line 10680 "parse.cc" /* yacc.c:1646  */
    break;

  case 710:
#line 4477 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '+'; }
#line 10686 "parse.cc" /* yacc.c:1646  */
    break;

  case 711:
#line 4481 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '0'; }
#line 10692 "parse.cc" /* yacc.c:1646  */
    break;

  case 712:
#line 4482 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '1'; }
#line 10698 "parse.cc" /* yacc.c:1646  */
    break;

  case 713:
#line 4483 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'x'; }
#line 10704 "parse.cc" /* yacc.c:1646  */
    break;

  case 714:
#line 4484 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '-'; }
#line 10710 "parse.cc" /* yacc.c:1646  */
    break;

  case 715:
#line 4492 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = pform_make_udp_input_ports((yyvsp[-1].perm_strings)); }
#line 10716 "parse.cc" /* yacc.c:1646  */
    break;

  case 716:
#line 4494 "parse.y" /* yacc.c:1646  */
    { perm_string pname = lex_strings.make((yyvsp[-1].text));
	PWire*pp = new PWire(pname, NetNet::IMPLICIT, NetNet::POUTPUT, IVL_VT_LOGIC);
	svector<PWire*>*tmp = new svector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[-1].text);
      }
#line 10728 "parse.cc" /* yacc.c:1646  */
    break;

  case 717:
#line 4502 "parse.y" /* yacc.c:1646  */
    { perm_string pname = lex_strings.make((yyvsp[-1].text));
	PWire*pp = new PWire(pname, NetNet::REG, NetNet::PIMPLICIT, IVL_VT_LOGIC);
	svector<PWire*>*tmp = new svector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[-1].text);
      }
#line 10740 "parse.cc" /* yacc.c:1646  */
    break;

  case 718:
#line 4510 "parse.y" /* yacc.c:1646  */
    { perm_string pname = lex_strings.make((yyvsp[-1].text));
	PWire*pp = new PWire(pname, NetNet::REG, NetNet::POUTPUT, IVL_VT_LOGIC);
	svector<PWire*>*tmp = new svector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[-1].text);
      }
#line 10752 "parse.cc" /* yacc.c:1646  */
    break;

  case 719:
#line 4521 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 10758 "parse.cc" /* yacc.c:1646  */
    break;

  case 720:
#line 4523 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[-1].wires), *(yyvsp[0].wires));
		  delete (yyvsp[-1].wires);
		  delete (yyvsp[0].wires);
		  (yyval.wires) = tmp;
		}
#line 10768 "parse.cc" /* yacc.c:1646  */
    break;

  case 721:
#line 4532 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
	tmp->push_back(lex_strings.make((yyvsp[0].text)));
	delete[](yyvsp[0].text);
	(yyval.perm_strings) = tmp;
      }
#line 10778 "parse.cc" /* yacc.c:1646  */
    break;

  case 722:
#line 4538 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
	tmp->push_back(lex_strings.make((yyvsp[0].text)));
	delete[](yyvsp[0].text);
	(yyval.perm_strings) = tmp;
      }
#line 10788 "parse.cc" /* yacc.c:1646  */
    break;

  case 723:
#line 4545 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 10794 "parse.cc" /* yacc.c:1646  */
    break;

  case 724:
#line 4545 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 10800 "parse.cc" /* yacc.c:1646  */
    break;

  case 725:
#line 4548 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 10806 "parse.cc" /* yacc.c:1646  */
    break;

  case 726:
#line 4549 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 10812 "parse.cc" /* yacc.c:1646  */
    break;

  case 727:
#line 4554 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 10822 "parse.cc" /* yacc.c:1646  */
    break;

  case 728:
#line 4560 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-3].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 10832 "parse.cc" /* yacc.c:1646  */
    break;

  case 729:
#line 4578 "parse.y" /* yacc.c:1646  */
    { perm_string tmp2 = lex_strings.make((yyvsp[-8].text));
		  pform_make_udp(tmp2, (yyvsp[-6].perm_strings), (yyvsp[-3].wires), (yyvsp[-1].strings), (yyvsp[-2].statement),
				 (yylsp[-8]).text, (yylsp[-8]).first_line);
		  delete[](yyvsp[-8].text);
		}
#line 10842 "parse.cc" /* yacc.c:1646  */
    break;

  case 730:
#line 4593 "parse.y" /* yacc.c:1646  */
    { perm_string tmp2 = lex_strings.make((yyvsp[-11].text));
		  perm_string tmp6 = lex_strings.make((yyvsp[-7].text));
		  pform_make_udp(tmp2, (yyvsp[-8].flag), tmp6, (yyvsp[-6].expr), (yyvsp[-4].perm_strings), (yyvsp[-1].strings),
				 (yylsp[-11]).text, (yylsp[-11]).first_line);
		  delete[](yyvsp[-11].text);
		  delete[](yyvsp[-7].text);
		}
#line 10854 "parse.cc" /* yacc.c:1646  */
    break;


#line 10858 "parse.cc" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
